#region References
using System;
using System.Collections;
using System.Data;
using System.Text;
using EXT.DOMAIN.vbecs.Common;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using SPROC = EXT.DOMAIN.vbecs.Common.VbecsStoredProcs;
using TABLE = EXT.DOMAIN.vbecs.Common.VbecsTables;
using ARTIFICIAL = EXT.DOMAIN.vbecs.Common.DatabaseConstants.ArtificialColumnNames;
using BLOODUNITREPORTSUMMARY = EXT.DOMAIN.vbecs.Common.DatabaseConstants.BloodUnitReportSummary;
using REPORT_TABLES = EXT.DOMAIN.vbecs.Common.DatabaseConstants.BloodUnitReportTables;
#endregion
namespace EXT.DOMAIN.vbecs.BOL
#region Header
///<Package>Package: VBECS - VistA Blood Establishment Computer System</Package>
///<Warning> WARNING: Per VHA Directive $VADIRECTIVE this class should not be modified</Warning>
///<MedicalDevice> Medical Device #: $MEDDEVICENO</MedicalDevice>
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>10/07/2004</CreationDate>
///<Note>The Food and Drug Administration classifies this software as a medical device.  As such, it may not be changed in any way. Modifications to this software may result in an adulterated medical device under 21CFR820, the use of which is considered to be a violation of US Federal Statutes.  Acquiring and implementing this software through the Freedom of information Act requires the implementor to assume total responsibility for the software, and become a registered manufacturer of a medical device, subject to FDA regulations</Note>
///<summary>
///
Business object component providing functionality for
///
blood unit history report
///</summary>
#endregion
public class BloodUnitReport : VbecsReport
#region Variables
/// <summary>
/// Used to hold the message we will display after the report criteria
/// indicating those sections the user requested but which contained no
/// data
/// </summary>
private string _message;
/// <summary>
/// Used to indicate whether exception report data was returned;
/// we will show warning in _message if there was not any data returned  
/// </summary>
private int _exceptionReportRowCount;
#endregion
#region Properties
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6214"> 
///
<ExpectedInput>Valid Guid Value</ExpectedInput>
///
<ExpectedOutput>Valid Guid Value passed in.</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6215"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// BloodUnitGuid
/// </summary>
public Guid BloodUnitGuid
get 
return (Guid)this.ParameterRow[TABLE.BloodUnit.BloodUnitGuid];
set
this.ParameterRow[TABLE.BloodUnit.BloodUnitGuid] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6216"> 
///
<ExpectedInput>Valid string value.</ExpectedInput>
///
<ExpectedOutput>String value passed in.</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6217"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// EyeReadableUnitId
/// </summary>
public string EyeReadableUnitId
get 
return Convert.ToString( this.ParameterRow[TABLE.BloodUnit.EyeReadableUnitId] );
set
this.ParameterRow[TABLE.BloodUnit.EyeReadableUnitId] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6218"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6219"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// ProductCode
/// </summary>
public string ProductCode
get 
return Convert.ToString( this.ParameterRow[TABLE.BloodProduct.ProductCode] );
set
this.ParameterRow[TABLE.BloodProduct.ProductCode] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6220"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6221"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// ReportsSelected
/// </summary>
public int ReportsSelected
get 
int count = 0;
count += (this.IncludeAntigenTypingReport ? 1 : 0);
count += (this.IncludeBloodUnitTestingReport ? 1 : 0);
count += (this.IncludeCrossmatchTestingReport ? 1 : 0);
count += (this.IncludeRestrictedPatientReport ? 1 : 0);
count += (this.IncludeExceptionReport ? 1 : 0);
count += (this.IncludeFinanceReport ? 1 : 0);
count += (this.IncludeIncomingShipmentReport ? 1 : 0);
count += (this.IncludeIssueReport ? 1 : 0);
count += (this.IncludeModificationReport ? 1 : 0);
count += (this.IncludeOutgoingShipmentReport ? 1 : 0);
count += (this.IncludePatientAssociationReport ? 1 : 0);
count += (this.IncludeStatusReport ? 1 : 0);
count += (this.IncludeTransfusionReport ? 1 : 0);
return count;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6222"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6223"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludeIncomingShipmentReport
/// </summary>
public bool IncludeIncomingShipmentReport
get 
return Convert.ToBoolean(this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeIncomingShipmentReport]);
set
this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeIncomingShipmentReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6224"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6225"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludeOutgoingShipmentReport
/// </summary>
public bool IncludeOutgoingShipmentReport
get 
return Convert.ToBoolean(this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeOutgoingShipmentReport]);
set
this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeOutgoingShipmentReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6226"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6227"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///<summary>
/// IncludeAnitgenTypingReport
/// </summary>
public bool IncludeAntigenTypingReport
get 
return Convert.ToBoolean(this.ParameterRow[ARTIFICIAL.IncludeAntigenTypingReport]);
set
this.ParameterRow[ARTIFICIAL.IncludeAntigenTypingReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6228"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6229"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludeRestrictedPatientReport
/// </summary>
public bool IncludeRestrictedPatientReport
get 
return Convert.ToBoolean(this.ParameterRow[ARTIFICIAL.IncludeRestrictedPatientReport]);
set
this.ParameterRow[ARTIFICIAL.IncludeRestrictedPatientReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6230"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6231"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludeStatusReport
/// </summary>
public bool IncludeStatusReport
get 
return Convert.ToBoolean(this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeStatusReport]);
set
this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeStatusReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6232"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6233"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludeFinanceReport
/// </summary>
public bool IncludeFinanceReport
get 
return Convert.ToBoolean(this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeFinanceReport]);
set
this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeFinanceReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6234"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6235"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludePatientAssociationReport
/// </summary>
public bool IncludePatientAssociationReport
get 
return Convert.ToBoolean(this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludePatientAssociationReport]);
set
this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludePatientAssociationReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6236"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6237"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///<summary>
/// IncludeIssueReport
/// </summary>
public bool IncludeIssueReport
get 
return Convert.ToBoolean(this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeIssueReport]);
set
this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeIssueReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6238"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6239"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludeBloodUnitTestingReport
/// </summary>
public bool IncludeBloodUnitTestingReport
get 
return Convert.ToBoolean(this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeBloodUnitTestingReport]);
set
this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeBloodUnitTestingReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6240"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6241"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludeCrossmatchTestingReport
/// </summary>
public bool IncludeCrossmatchTestingReport
get 
return Convert.ToBoolean(this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeCrossmatchTestingReport]);
set
this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeCrossmatchTestingReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6242"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6243"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludeModificationReport
/// </summary>
public bool IncludeModificationReport
get 
return Convert.ToBoolean(this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeModificationReport]);
set
this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeModificationReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6244"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6245"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludeTransfusionReport
/// </summary>
public bool IncludeTransfusionReport
get 
return Convert.ToBoolean(this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeTransfusionReport]);
set
this.ParameterRow[BLOODUNITREPORTSUMMARY.IncludeTransfusionReport] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6246"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6247"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// IncludeExceptionReport
/// </summary>
public bool IncludeExceptionReport
get 
return Convert.ToBoolean(this.ParameterRow[ARTIFICIAL.IncludeExceptionReport]);
set
this.ParameterRow[ARTIFICIAL.IncludeExceptionReport] = value;
#endregion
#region Constructors
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>10/7/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5759"> 
///
<ExpectedInput>BloodUnit Guid</ExpectedInput>
///
<ExpectedOutput>BloodUnitReport object</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5760"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor
/// </summary>
public BloodUnitReport(Guid bloodUnitGuid)
BloodUnitGuid = bloodUnitGuid;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/13/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6248"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6249"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// Constructor
/// </summary>
public BloodUnitReport()
this.BloodUnitGuid=Guid.Empty;
this.EyeReadableUnitId=String.Empty;
this.ProductCode=String.Empty;
this.IncludeIncomingShipmentReport=false;
this.IncludeOutgoingShipmentReport=false;
this.IncludeAntigenTypingReport=false;
this.IncludeRestrictedPatientReport=false;
this.IncludeStatusReport=false;
this.IncludeFinanceReport=false;
this.IncludePatientAssociationReport=false;
this.IncludeIssueReport=false;
this.IncludeBloodUnitTestingReport=false;
this.IncludeCrossmatchTestingReport=false;
this.IncludeModificationReport=false;
this.IncludeTransfusionReport=false;
this.IncludeExceptionReport=false;
#endregion
#region Static Methods
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>10/7/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5755"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>DataTable</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5756"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// GetBloodUnitsForHistoryReport
/// </summary>
public static DataTable GetBloodUnitsForHistoryReport()
return DAL.BloodUnitReport.GetBloodUnitsForHistoryReport();
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>12/9/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8371"> 
///
<ExpectedInput>BloodUnitGuid</ExpectedInput>
///
<ExpectedOutput>Int value</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8372"> 
///
<ExpectedInput>Invalid BloodUnitGuid</ExpectedInput>
///
<ExpectedOutput>0</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Returns estimated record count for the unit history report
/// </summary>
public static int GetReportBloodUnitHistoryRecordCount
Guid bloodUnitGuid,
bool includeIncomingShipmentReport,
bool includeOutgoingShipmentReport,
bool includeAntigenTypingReport,
bool includeRestrictedPatientReport,
bool includeStatusReport,
bool includeFinanceReport,
bool includePatientAssociationReport,
bool includeIssueReport,
bool includeBloodUnitTestingReport,
bool includeCrossmatchTestingReport,
bool includeModificationReport,
bool includeTransfusionReport,
bool includeExceptionReport
return DAL.BloodUnitReport.GetReportBloodUnitHistoryRecordCount
bloodUnitGuid,
includeIncomingShipmentReport,
includeOutgoingShipmentReport,
includeAntigenTypingReport,
includeRestrictedPatientReport,
includeStatusReport,
includeFinanceReport,
includePatientAssociationReport,
includeIssueReport,
includeBloodUnitTestingReport,
includeCrossmatchTestingReport,
includeModificationReport,
includeTransfusionReport,
includeExceptionReport
);
#endregion
#region Instance Methods
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/8/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="7398"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="7399"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Generate and print report
/// Used by VbecsConsoleReport application
/// </summary>
public override void GenerateAndPrintReport()
va.med.vbecs.reports.BloodUnitHistoryReport.BloodUnitHistoryReport _bloodUnitHistoryReport = this.GenerateReport();
_bloodUnitHistoryReport.PrintOptions.PrinterName=this.PrinterName;
_bloodUnitHistoryReport.PrintToPrinter(1,false,0,0);
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/10/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6149"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6150"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// BR_85.02 
/// </summary>
/// <returns></returns>
public va.med.vbecs.reports.BloodUnitHistoryReport.BloodUnitHistoryReport GenerateReport()
int modificationSectionRecordCount = 0;
//
StringBuilder message = new StringBuilder();
//
va.med.vbecs.reports.BloodUnitHistoryReport.BloodUnitHistoryReport bloodUnitHistoryReport = new va.med.vbecs.reports.BloodUnitHistoryReport.BloodUnitHistoryReport();
//
DataSet
reportData = this.GetReportTables(); 
#region Report Data Schema
#if DEBUG
// reportData.WriteXml("D:\\Temp\\BloodUnitHistoryTables.xml", XmlWriteMode.WriteSchema);
#endif
#endregion
// suppress/enable report sections as appropriate
#region Section Check
for (int sectionIdx = 0; sectionIdx < bloodUnitHistoryReport.ReportDefinition.Sections.Count; sectionIdx++)
Section section = bloodUnitHistoryReport.ReportDefinition.Sections[sectionIdx];
//
section.SectionFormat.EnableSuppress = true;
//
if(section.Name.Equals(bloodUnitHistoryReport.Summary.Name) 
|| section.Name.Equals(bloodUnitHistoryReport.ReportHeader.Name) 
|| section.Name.Equals(bloodUnitHistoryReport.ReportFooter.Name) 
|| section.Name.Equals(bloodUnitHistoryReport.PageHeader.Name) 
|| section.Name.Equals(bloodUnitHistoryReport.PageFooter.Name))
section.SectionFormat.EnableSuppress = false;
else if(SectionRequested(section.Name))
int count = reportData.Tables[section.Name] != null ? reportData.Tables[section.Name].Rows.Count : 0;
section.SectionFormat.EnableSuppress = (count == 0);
//
string displayName = GetSectionDisplayName(section.Name);
//
// we will handle the modification section later
if (displayName.Equals("Modification"))
modificationSectionRecordCount += count;
// User requested this section, but no data was returned, so we will display a message 
// indicating this after the report criteria at the end of the report (see GetReportCriteria)
else if (count == 0)
if (message.ToString().IndexOf(displayName) == -1)
message.Append("\n").Append(displayName).Append(",");
#endregion
// we have to do these separately
#region Exception Reports
if(IncludeExceptionReport)
bloodUnitHistoryReport.OpenSubreport("ExceptionReportAntigenTest.rpt").SetDataSource(reportData);
bloodUnitHistoryReport.OpenSubreport("ExceptionReportExpiredUnit.rpt").SetDataSource(reportData);
bloodUnitHistoryReport.OpenSubreport("ExceptionReportLabelMismatch.rpt").SetDataSource(reportData);
bloodUnitHistoryReport.OpenSubreport("ExceptionReportQuarantine.rpt").SetDataSource(reportData);
bloodUnitHistoryReport.OpenSubreport("ExceptionReportRemoveFinalUnitStatus.rpt").SetDataSource(reportData);
bloodUnitHistoryReport.OpenSubreport("ExceptionReportReturnIssuedUnit.rpt").SetDataSource(reportData);
bloodUnitHistoryReport.OpenSubreport("ExceptionReportUnitAboRH.rpt").SetDataSource(reportData);
bloodUnitHistoryReport.OpenSubreport("ExceptionReportUnitModification.rpt").SetDataSource(reportData);
bloodUnitHistoryReport.OpenSubreport("ExceptionReportUnitSelection.rpt").SetDataSource(reportData);
bloodUnitHistoryReport.OpenSubreport("ExceptionReportUnitSupply.rpt").SetDataSource(reportData);
bloodUnitHistoryReport.OpenSubreport("ExceptionReportQC.rpt").SetDataSource(reportData);
#endregion
bloodUnitHistoryReport.SetDataSource(reportData);
//
if (message.Length > 0)
if (IncludeModificationReport && modificationSectionRecordCount == 0)
message.Append("\nModification,");
//
if (IncludeExceptionReport && this._exceptionReportRowCount == 0)
message.Append("\nException,");
//
message.Insert(0, "The following reports were requested but did not return any data: ");
message.Remove(message.Length - 1, 1);
message.Append(".");
this._message = message.ToString();
//
#region Report Header and Footer
DataSet dsHeader =  VbecsReport.GetReportHeader( new VbecsUser(this.PrintedBy).UserName );
DataSet dsFooter =  VbecsReport.GetReportFooter( this.GetReportCriteria() );
//
bloodUnitHistoryReport.OpenSubreport("ReportHeader.rpt" ).SetDataSource(dsHeader);
bloodUnitHistoryReport.OpenSubreport("ReportFooter.rpt" ).SetDataSource(dsFooter);
bloodUnitHistoryReport.SetParameterValue("ReportTitle" , "Unit History Report");
#endregion
//
return bloodUnitHistoryReport;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>10/7/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5757"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>DataSet</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5758"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// GetReportTables
/// </summary>
public DataSet GetReportTables()
DataSet reportData = DAL.BloodUnitReport.GetHistoricalBloodUnitDataTables
BloodUnitGuid,
this.IncludeIncomingShipmentReport,
this.IncludeOutgoingShipmentReport,
this.IncludeAntigenTypingReport,
this.IncludeRestrictedPatientReport,
this.IncludeStatusReport,
this.IncludeFinanceReport,
this.IncludePatientAssociationReport,
this.IncludeIssueReport,
this.IncludeBloodUnitTestingReport,
this.IncludeCrossmatchTestingReport,
this.IncludeModificationReport,
this.IncludeTransfusionReport 
);
//
if(reportData.Tables.Count > 0 && reportData.Tables[REPORT_TABLES.BloodUnitHistorySummary].Rows.Count > 0)
this._exceptionReportRowCount = 0;
// Handle Exception Reports (mainly done in BOL.ExceptionReport)
#region Exception Reports
if(this.IncludeExceptionReport)
// ExceptionReportAntigenTest
DataSet antigenTest = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportAntigenTest);
if(antigenTest.Tables.Count > 0 && antigenTest.Tables[0].Rows.Count > 0)
DataTable antigenTestTable = antigenTest.Tables[0].Copy();
reportData.Tables.Add(antigenTestTable);
this._exceptionReportRowCount = antigenTest.Tables[0].Rows.Count;
// ExceptionReportExpiredUnitReceived
DataSet expiredUnitReceived = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportExpiredUnitReceived);
if(expiredUnitReceived.Tables.Count > 0 && expiredUnitReceived.Tables[0].Rows.Count > 0)
DataTable expiredUnitReceivedTable = expiredUnitReceived.Tables[0].Copy();
reportData.Tables.Add(expiredUnitReceivedTable);
this._exceptionReportRowCount += expiredUnitReceived.Tables[0].Rows.Count;
//
// ExceptionReportLabelMismatch
DataSet labeMismatch = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportLabelMismatch);
if(labeMismatch.Tables.Count > 0 && labeMismatch.Tables[0].Rows.Count > 0)
DataTable labeMismatchTable = labeMismatch.Tables[0].Copy();
reportData.Tables.Add(labeMismatchTable);
this._exceptionReportRowCount += labeMismatch.Tables[0].Rows.Count;
//
// ExceptionReportQuarantine
DataSet quarantine = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportQuarantine);
if(quarantine.Tables.Count > 0 && quarantine.Tables[0].Rows.Count > 0)
DataTable quarantineTable = quarantine.Tables[0].Copy();
reportData.Tables.Add(quarantineTable);
this._exceptionReportRowCount += quarantine.Tables[0].Rows.Count;
//
// ExceptionReportRemoveFinalUnitStatus
DataSet removeFinalStatus = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportRemoveFinalUnitStatus);
if(removeFinalStatus.Tables.Count > 0 && removeFinalStatus.Tables[0].Rows.Count > 0)
DataTable removeFinalStatusTable = removeFinalStatus.Tables[0].Copy();
reportData.Tables.Add(removeFinalStatusTable);
this._exceptionReportRowCount += removeFinalStatus.Tables[0].Rows.Count;
//
// ExceptionReportReturnIssuedUnit
DataSet returnIssuedUnit = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportReturnIssuedUnit);
if(returnIssuedUnit.Tables.Count > 0 && returnIssuedUnit.Tables[0].Rows.Count > 0)
DataTable returnIssuedUnitTable = returnIssuedUnit.Tables[0].Copy();
reportData.Tables.Add(returnIssuedUnitTable);
this._exceptionReportRowCount += returnIssuedUnit.Tables[0].Rows.Count;
//
// ExceptionReportUnitAboRh
DataSet unitAboRh = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportUnitAboRh);
if(unitAboRh.Tables.Count > 0 && unitAboRh.Tables[0].Rows.Count > 0)
DataTable unitAboRhTable = unitAboRh.Tables[0].Copy();
reportData.Tables.Add(unitAboRhTable);
this._exceptionReportRowCount += unitAboRh.Tables[0].Rows.Count;
//
// ExceptionReportUnitModification
DataSet unitModification = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportUnitModification);
if(unitModification.Tables.Count > 0 && unitModification.Tables[0].Rows.Count > 0)
DataTable unitModificationTable = unitModification.Tables[0].Copy();
reportData.Tables.Add(unitModificationTable);
this._exceptionReportRowCount += unitModification.Tables[0].Rows.Count;
//
// ExceptionReportUnitSelection
DataSet unitSelection = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportUnitSelection);
if(unitSelection.Tables.Count > 0 && unitSelection.Tables[0].Rows.Count > 0)
DataTable unitSelectionTable = unitSelection.Tables[0].Copy();
reportData.Tables.Add(unitSelectionTable);
this._exceptionReportRowCount += unitSelection.Tables[0].Rows.Count;
//
// ExceptionReportUnitSupply
DataSet unitSupply = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportUnitSupply);
if(unitSupply.Tables.Count > 0 && unitSupply.Tables[0].Rows.Count > 0)
DataTable unitSupplyTable = unitSupply.Tables[0].Copy();
reportData.Tables.Add(unitSupplyTable);
this._exceptionReportRowCount += unitSupply.Tables[0].Rows.Count;
//
// ExceptionReportQc
DataSet reagentQc = BOL.ExceptionReport.GetBloodUnitExceptionReport(this.BloodUnitGuid, Common.ExceptionReportType.ExceptionReportQC);
if(reagentQc.Tables.Count > 0 && reagentQc.Tables[0].Rows.Count > 0)
DataTable reagentQcTable = reagentQc.Tables[0].Copy();
reportData.Tables.Add(reagentQcTable);
this._exceptionReportRowCount += reagentQc.Tables[0].Rows.Count;
#endregion
return reportData;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>10/22/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5867"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>string</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5868"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Builds report criteria string 
/// (what subreports were included, etc.)
/// </summary>
public string GetReportCriteria()
StringBuilder builder = new StringBuilder();
builder.Append("Blood Unit ID = ");
builder.Append(this.EyeReadableUnitId);
builder.Append(", Product Code = ");
builder.Append(this.ProductCode);
builder.Append(", Requested Reports: ");
//
StringBuilder reports = new StringBuilder();
reports.Append(this.IncludeAntigenTypingReport ? "\nAnitgen Typing" : "");
reports.Append(this.IncludeBloodUnitTestingReport ? (reports.Length > 0 ? ", \nBlood Unit Testing" : "\nBlood Unit Testing") : "");
reports.Append(this.IncludeCrossmatchTestingReport ? (reports.Length > 0 ? ", \nCrossmatch Testing" : "\nCrossmatch Testing") : "");
reports.Append(this.IncludeExceptionReport ? (reports.Length > 0 ? ", \nException" : "\nException") : "");
reports.Append(this.IncludeFinanceReport ? (reports.Length > 0 ? ", \nFinance" : "\nFinance") : "");
reports.Append(this.IncludeIncomingShipmentReport ? (reports.Length > 0 ? ", \nIncoming Shipment" : "\nIncoming Shipment") : "");
reports.Append(this.IncludeIssueReport ? (reports.Length > 0 ? ", \nIssue" : "\nIssue") : "");
reports.Append(this.IncludeModificationReport ? (reports.Length > 0 ? ", \nModification" : "\nModification") : "");
reports.Append(this.IncludeOutgoingShipmentReport ? (reports.Length > 0 ? ", \nOutgoing Shipment" : "\nOutgoing Shipment") : "");
reports.Append(this.IncludePatientAssociationReport ? (reports.Length > 0 ? ", \nPatient Association" : "\nPatient Association") : "");
reports.Append(this.IncludeRestrictedPatientReport ? (reports.Length > 0 ? ", \nRestricted Patient" : "\nRestricted Patient") : "");
reports.Append(this.IncludeStatusReport ? (reports.Length > 0 ? ", \nQuarantine" : "\nQuarantine") : "");
reports.Append(this.IncludeTransfusionReport ? (reports.Length > 0 ? ", \nTransfusion" : "\nTransfusion") : "");
reports.Append(".");
builder.Append(reports);
//
builder.Append("\n\n");
builder.Append(this._message);
//
return builder.ToString();
/// <summary>
/// SectionRequested
/// </summary>
private bool SectionRequested(string reportName)
switch(reportName)
case "AntigenTypingReport":
{ return IncludeAntigenTypingReport; }
case "BloodUnitTestingReport":
{ return IncludeBloodUnitTestingReport; }
case "CrossmatchTestingReport":
{ return IncludeCrossmatchTestingReport; }
case "DirectedPatientReport":
{ return IncludeRestrictedPatientReport; }
case "FinanceReport":
{ return IncludeFinanceReport; }
case "IncomingShipmentReport":
{ return IncludeIncomingShipmentReport; }
case "IssueReport":
{ return IncludeIssueReport; }
case "ModificationReport":
{ return IncludeModificationReport; }
case "OriginalUnitsFromModification":
{ return IncludeModificationReport; }
case "TargetUnitsFromModification":
{ return IncludeModificationReport; }
case "ModificationEquipmentAndSupplies":
{ return IncludeModificationReport; }
case "OutgoingShipmentReport":
{ return IncludeOutgoingShipmentReport; }
case "PatientAssociationReport":
{ return IncludePatientAssociationReport; }
case "StatusReport":
{ return IncludeStatusReport; }
case "TransfusionReport":
{ return IncludeTransfusionReport; }
case "GetExceptionReportExpiredUnitReceived":
{ return IncludeExceptionReport; }
case "ExceptionReportAntigenTest":
{ return IncludeExceptionReport; }
case "ExceptionReportLabelMismatch":
{ return IncludeExceptionReport; }
case "ExceptionReportQuarantine":
{ return IncludeExceptionReport; }
case "ExceptionReportRemoveFinalUnitStatus":
{ return IncludeExceptionReport; }
case "ExceptionReportReturnIssuedUnit":
{ return IncludeExceptionReport; }
case "ExceptionReportUnitAboRH":
{ return IncludeExceptionReport; }
case "ExceptionReportUnitSelection":
{ return IncludeExceptionReport; }
case "ExceptionReportUnitModification":
{ return IncludeExceptionReport; }
case "ExceptionReportUnitSupply":
{ return IncludeExceptionReport; }
case "ExceptionReportQC":
{ return IncludeExceptionReport; }
default:
{ return false; }
/// <summary>
/// SectionRequested
/// </summary>
private string GetSectionDisplayName(string reportName)
switch(reportName)
case "AntigenTypingReport":
{ return "Anitgen Typing"; }
case "BloodUnitTestingReport":
{ return "Blood Unit Testing" ; }
case "CrossmatchTestingReport":
{ return "Crossmatch Testing"; }
case "DirectedPatientReport":
{ return "Restricted Patient"; }
case "FinanceReport":
{ return "Finance"; }
case "IncomingShipmentReport":
{ return "Incoming Shipment"; }
case "IssueReport":
{ return "Issue"; }
case "ModificationReport":
{ return "Modification"; }
case "OriginalUnitsFromModification":
{ return "Modification"; }
case "TargetUnitsFromModification":
{ return "Modification"; }
case "ModificationEquipmentAndSupplies":
{ return "Modification"; }
case "OutgoingShipmentReport":
{ return "Outgoing Shipment"; }
case "PatientAssociationReport":
{ return "Patient Association"; }
case "StatusReport":
{ return "Quarantine"; }
case "TransfusionReport":
{ return "Transfusion"; }
default:
{ return string.Empty; }
#endregion
