using System;
using System.Data;
using Method = System.Reflection.MethodBase;
using CrystalDecisions.CrystalReports.Engine;
using TABLE = EXT.DOMAIN.vbecs.Common.VbecsTables;
using ARTIFICIAL = EXT.DOMAIN.vbecs.Common.DatabaseConstants.ArtificialColumnNames;
namespace EXT.DOMAIN.vbecs.BOL
/// <summary>
/// Summary description for OrderReport.
/// </summary>
public class OrderReport:VbecsReport
private Guid _orderGuid;
private int _recordCount = int.MinValue;
#region constructors
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/28/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5480"> 
///
<ExpectedInput>None</ExpectedInput>
///
<ExpectedOutput>Instance of OrderReport</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5481"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// OrderReport
/// </summary>
public OrderReport()
// multi order report by default
IsSingleOrderReport = false;
SortByTreatingSpecialty = true;
#endregion
#region properties
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/28/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5482"> 
///
<ExpectedInput>None (single order)</ExpectedInput>
///
<ExpectedOutput>Count > 0</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5484"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Returns the number of records
/// </summary>
public int RecordCount
get
if (this.IsSingleOrderReport)
// They have selected an order.  This is always 1!
return 1;
else
_recordCount = DAL.OrderReport.GetMultiOrderReportCount(this.StartDate, this.EndDate, Common.LogonUser.LogonUserDivisionCode);
return _recordCount;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/28/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5485"> 
///
<ExpectedInput>bool</ExpectedInput>
///
<ExpectedOutput>bool</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5486"> 
///
<ExpectedInput>true (with OrderGuid = Empty)</ExpectedInput>
///
<ExpectedOutput>Broken rule</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Indicates whether this is a single or multi-order report
/// </summary>
public bool IsSingleOrderReport
get
if (this.ParameterRow.IsNull(ARTIFICIAL.IsSingleOrderReport))
return false;
return Convert.ToBoolean(this.ParameterRow[ARTIFICIAL.IsSingleOrderReport]);
set
this.ParameterRow[ARTIFICIAL.IsSingleOrderReport] = value;
if (IsSingleOrderReport)
RuleBroken("OrderGuid", _orderGuid == Guid.Empty);
else
RuleBroken("OrderGuid", false);
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/29/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5488"> 
///
<ExpectedInput>bool</ExpectedInput>
///
<ExpectedOutput>bool</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5489"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// IsComponentOrder
/// </summary>
public bool IsComponentOrder
get
if (this.ParameterRow.IsNull(ARTIFICIAL.IsComponentOrder))
return false;
return Convert.ToBoolean(this.ParameterRow[ARTIFICIAL.IsComponentOrder]);
set
this.ParameterRow[ARTIFICIAL.IsComponentOrder] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/29/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5490"> 
///
<ExpectedInput>bool</ExpectedInput>
///
<ExpectedOutput>bool</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5491"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Specifies sorting in multiple order reports only
/// </summary>
public bool SortByTreatingSpecialty
get
if (this.ParameterRow.IsNull(ARTIFICIAL.SortByTreatingSpecialty))
return false;
return Convert.ToBoolean(this.ParameterRow[ARTIFICIAL.SortByTreatingSpecialty]);
set
this.ParameterRow[ARTIFICIAL.SortByTreatingSpecialty] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/29/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5492"> 
///
<ExpectedInput>Guid</ExpectedInput>
///
<ExpectedOutput>Guid</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5494"> 
///
<ExpectedInput>Empty Guid (with SingleOrderReport = true)</ExpectedInput>
///
<ExpectedOutput>Broken rule</ExpectedOutput>
///
</Case>
///
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Specifies order Guid (component or test) in a single order report only
/// </summary>
public Guid OrderGuid
get
return _orderGuid;
set
_orderGuid = value;
RuleBroken(Method.GetCurrentMethod().Name, _orderGuid == Guid.Empty && IsSingleOrderReport == true);
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/29/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5507"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>Non-empty string</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5508"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// SearchCriteria
/// </summary>
public string SearchCriteria
get
if (IsSingleOrderReport)
return "Search by patient";
else
return "Order received between " + Common.VBECSDateTime.FormatDateString(StartDate) + " and " + Common.VBECSDateTime.FormatDateString(EndDate) + 
", sorted by " + (this.SortByTreatingSpecialty ? "treating specialty." : "ordering location.") ;
#endregion
#region methods
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/29/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5495"> 
///
<ExpectedInput>No broken rules</ExpectedInput>
///
<ExpectedOutput>DataSet representing the report</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5496"> 
///
<ExpectedInput>Broken rule count > 0</ExpectedInput>
///
<ExpectedOutput>Business object layer exception</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Returns a DataSet representing the report
/// </summary>
/// <returns></returns>
public DataSet CreateReport()
if (this.BrokenRulesCount > 0)
throw new BOL.BusinessObjectException("There are broken rules, so the report cannot be created.");
DataSet dsOrderHistory = new DataSet();
if (IsSingleOrderReport)
dsOrderHistory.DataSetName = "SingleOrderHistoryReport";
//
DataTable dtOrder = new DataTable();
//
DataTable dtSpecimenHistory = new DataTable();
DataTable dtReflexTests = new DataTable();
//
bool specimenHistoryExists = false;
bool reflexTestsExist = false;
// Main order
if (IsComponentOrder)
dtOrder = DAL.OrderReport.GetReportSingleOrderComponentHistory(_orderGuid);
else
dtOrder = DAL.OrderReport.GetReportSingleOrderTestHistory(_orderGuid);
dtOrder.TableName = "Order";
dsOrderHistory.Tables.Add(dtOrder.Copy());
// Specimen history
Guid specimenGuid = dtOrder.Rows[0].IsNull(TABLE.PatientSpecimen.PatientSpecimenGuid) ? Guid.Empty : (Guid) dtOrder.Rows[0][TABLE.PatientSpecimen.PatientSpecimenGuid];
if (specimenGuid != Guid.Empty)
dtSpecimenHistory = BOL.Specimen.GetSpecimenHistory(specimenGuid).Copy();
if (dtSpecimenHistory.Rows.Count > 0)
dtSpecimenHistory.TableName = "SpecimenHistory";
specimenHistoryExists = true;
dsOrderHistory.Tables.Add(dtSpecimenHistory);
// Reflex tests
dtReflexTests = BOL.PatientOrder.GetReflexTestsForOrder(_orderGuid);
if (dtReflexTests.Rows.Count > 0)
dtReflexTests.TableName = "ReflexTests";
reflexTestsExist = true;
dsOrderHistory.Tables.Add(dtReflexTests.Copy());
// Modify Order table
dsOrderHistory.Tables[0].Columns.Add(ARTIFICIAL.SpecimenHistoryExists,typeof(bool));
dsOrderHistory.Tables[0].Columns.Add(ARTIFICIAL.ReflexTestsExist,typeof(bool));
dsOrderHistory.Tables[0].Columns.Add(ARTIFICIAL.IsComponentOrder,typeof(bool));
dsOrderHistory.Tables[0].Columns.Add(ARTIFICIAL.OrderExpirationDate,typeof(DateTime));
dsOrderHistory.Tables[0].Rows[0][ARTIFICIAL.SpecimenHistoryExists] = specimenHistoryExists;
dsOrderHistory.Tables[0].Rows[0][ARTIFICIAL.ReflexTestsExist] = reflexTestsExist;
dsOrderHistory.Tables[0].Rows[0][ARTIFICIAL.IsComponentOrder] = IsComponentOrder;
if (specimenGuid != Guid.Empty)
dsOrderHistory.Tables[0].Rows[0][ARTIFICIAL.OrderExpirationDate] = (DateTime) dtOrder.Rows[0][TABLE.PatientSpecimen.SpecimenExpirationDate];
else
dsOrderHistory.Tables[0].Rows[0][ARTIFICIAL.OrderExpirationDate] = ((DateTime) dtOrder.Rows[0][TABLE.PatientOrder.OrderReceivedDatetime]).AddDays(10);
// Modify SpecimenHistory table
if (specimenHistoryExists)
dsOrderHistory.Tables[1].Columns.Add(TABLE.BloodUnitMedia.Comments);
foreach (DataRow dtRow in dsOrderHistory.Tables[1].Rows )
dtRow[TABLE.BloodUnitMedia.Comments] = string.Empty;
#if DEBUG
//dsOrderHistory.WriteXml(@"C:\dataset.xml", System.Data.XmlWriteMode.WriteSchema);
#endif
else
dsOrderHistory.DataSetName = "MultiOrderHistoryReport";
DataTable dtOrder = DAL.OrderReport.GetReportMultiOrderHistory(this.StartDate, this.EndDate, Common.LogonUser.LogonUserDivisionCode);
dtOrder.TableName = "Order";
dsOrderHistory.Tables.Add(dtOrder.Copy());
return dsOrderHistory;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/5/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6123"> 
///
<ExpectedInput>N/A</ExpectedInput>
///
<ExpectedOutput>N/A</ExpectedOutput>
///
</Case>
///
///
///<Case type="1" testid ="6124"> 
///
<ExpectedInput>N/A</ExpectedInput>
///
<ExpectedOutput>N/A</ExpectedOutput>
///
</Case>
///
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Generate and print report
/// Used by VbecsConsoleReport application
/// </summary>
public override void GenerateAndPrintReport()
ReportClass report = null;
report = this.GenerateReport(new BOL.VbecsUser(this.PrintedBy).UserName);
//
report.PrintOptions.PrinterName = this.PrinterName;
//
report.PrintToPrinter(1, false, 0, 0);
/// <summary>
/// Generates the report for the scheduler
/// </summary>
/// <param name="printedBy"></param>
/// <returns></returns>
private ReportClass GenerateReport(string printedBy)
ReportClass report = null;
DataSet reportData = this.CreateReport();
DataSet dsHeader = BOL.VbecsReport.GetReportHeader(printedBy);
if (this.IsSingleOrderReport)
report = new EXT.DOMAIN.vbecs.reports.OrderHistory.SingleOrderHistory();
report.SetDataSource(reportData);
int index = ( reportData.Tables.IndexOf("SpecimenHistory"));
if ( reportData.Tables.IndexOf("SpecimenHistory") != -1)
report.OpenSubreport("SpecimenHistory.rpt").SetDataSource(reportData.Tables[reportData.Tables.IndexOf("SpecimenHistory")]);
if ( reportData.Tables.IndexOf("ReflexTests") != -1)
report.OpenSubreport("ReflexTests.rpt").SetDataSource(reportData.Tables[reportData.Tables.IndexOf("ReflexTests")]);
// Populate parameters of report
report.SetParameterValue("ReportTitle", "Single Order History Report");
// Set the subreport data source
report.OpenSubreport("ReportHeaderPortrait.rpt").SetDataSource(dsHeader);
else
if (this.SortByTreatingSpecialty)
report = new EXT.DOMAIN.vbecs.reports.OrderHistory.MultiOrderTransfusionSpecialty();
else
report = new EXT.DOMAIN.vbecs.reports.OrderHistory.MultiOrderOrderingLocation();
// title
report.SetParameterValue("ReportTitle", "Order History Report");
// header
report.OpenSubreport("ReportHeaderPortrait.rpt").SetDataSource(dsHeader);
// footer
DataSet dsFooter = BOL.VbecsReport.GetReportFooter(this.SearchCriteria);
report.OpenSubreport("ReportFooterPortrait.rpt").SetDataSource(dsFooter);
return report;
} 
#endregion
