#region References
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Text;
using TABLE = EXT.DOMAIN.vbecs.Common.VbecsTables;
using ARTIFICIAL = EXT.DOMAIN.vbecs.Common.DatabaseConstants.ArtificialColumnNames;
#endregion
namespace EXT.DOMAIN.vbecs.BOL
#region Header
///<Package>Package: VBECS - VistA Blood Establishment Computer System</Package>
///<Warning> WARNING: Per VHA Directive $VADIRECTIVE this class should not be modified</Warning>
///<MedicalDevice> Medical Device #: $MEDDEVICENO</MedicalDevice>
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>10/25/2004</CreationDate>
///<Note>The Food and Drug Administration classifies this software as a medical device.  As such, it may not be changed in any way. Modifications to this software may result in an adulterated medical device under 21CFR820, the use of which is considered to be a violation of US Federal Statutes.  Acquiring and implementing this software through the Freedom of information Act requires the implementor to assume total responsibility for the software, and become a registered manufacturer of a medical device, subject to FDA regulations</Note>
///<summary>
///
Business object component providing functionality for
///
transfusion reaction count report
///</summary>
#endregion
public class TransfusionReactionReport : VbecsReport
#region Variables
//private bool _detailedReport;
//private bool _multiDivisionalReport;
#endregion
#region Properties
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/26/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6544"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///
///<Case type="1" testid ="6545"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// DetailedReport
/// </summary>
public bool DetailedReport
get 
return Convert.ToBoolean(this.ParameterRow[ARTIFICIAL.DetailedReport]);
set
this.ParameterRow[ARTIFICIAL.DetailedReport] = value;
#endregion
#region Instance Methods
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/15/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="7853"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="7854"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Generate and print report
/// Used by VbecsConsoleReport application
/// </summary>
public override void GenerateAndPrintReport()
va.med.vbecs.reports.TransfusionReactionCount.TransfusionReactionCountReport rpt = this.GenerateReport(new BOL.VbecsUser(this.PrintedBy).UserName);
rpt.PrintOptions.PrinterName=this.PrinterName;
rpt.PrintToPrinter(1,false,0,0);
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>1/10/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6151"> 
///
<ExpectedInput>Valid business object data for summary report</ExpectedInput>
///
<ExpectedOutput>va.med.vbecs.reports.TransfusionReactionCount.TransfusionReactionCountReport</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="6152"> 
///
<ExpectedInput>Valid business object data for multi divisional summary report</ExpectedInput>
///
<ExpectedOutput>va.med.vbecs.reports.TransfusionReactionCount.TransfusionReactionCountReport</ExpectedOutput>
///
</Case>
///
///<Case type="0" testid ="6153"> 
///
<ExpectedInput>Valid business object data for detailed report</ExpectedInput>
///
<ExpectedOutput>va.med.vbecs.reports.TransfusionReactionCount.TransfusionReactionCountReport</ExpectedOutput>
///
</Case>
///
///<Case type="0" testid ="6154"> 
///
<ExpectedInput>Valid business object data for multi divisional detailed report</ExpectedInput>
///
<ExpectedOutput>va.med.vbecs.reports.TransfusionReactionCount.TransfusionReactionCountReport</ExpectedOutput>
///
</Case>
///
///<Case type="0" testid ="6155"> 
///
<ExpectedInput>N/A</ExpectedInput>
///
<ExpectedOutput>N/A</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// GenerateReport
/// </summary>
/// <param name="PrintedByUser"></param>
/// <returns></returns>
public va.med.vbecs.reports.TransfusionReactionCount.TransfusionReactionCountReport GenerateReport(string PrintedByUser)
va.med.vbecs.reports.TransfusionReactionCount.TransfusionReactionCountReport rpt = new EXT.DOMAIN.vbecs.reports.TransfusionReactionCount.TransfusionReactionCountReport();
DataSet dsHeader = VbecsReport.GetReportHeader(PrintedByUser);
DataSet dsFooter = VbecsReport.GetReportFooter(this.GetReportCriteria());
//
DataSet reportData = this.GetReportData();
#region Report Data Schema
#if DEBUG
// reportData.WriteXml("D:\\Temp\\TransfusionReactionCountData.xml", XmlWriteMode.WriteSchema);
#endif
#endregion
rpt.SetDataSource( reportData );
rpt.SetParameterValue( "ReportTitle" , "Transfusion Reaction Count Report" );
// Load appropriate report
if(reportData.Tables.Count > 0 && reportData.Tables[0].Rows.Count > 0)
if(this.DetailedReport) 
rpt.PrintOptions.PaperOrientation = CrystalDecisions.Shared.PaperOrientation.Landscape;
rpt.OpenSubreport("ReportHeader.rpt").SetDataSource(dsHeader);
rpt.OpenSubreport("ReportFooter.rpt").SetDataSource(dsFooter);
rpt.OpenSubreport("TransfusionReactionCountDetails.rpt").SetDataSource(reportData);
else
rpt.PrintOptions.PaperOrientation = CrystalDecisions.Shared.PaperOrientation.Portrait;
rpt.OpenSubreport("ReportHeaderPortrait.rpt").SetDataSource(dsHeader);
rpt.OpenSubreport("ReportFooterPortrait.rpt").SetDataSource(dsFooter);
rpt.OpenSubreport("TransfusionReactionCountSummary.rpt").SetDataSource(reportData);
return rpt;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/15/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="7855"> 
///
<ExpectedInput>Valid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="7856"> 
///
<ExpectedInput>Invalid Parameters</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor
/// </summary>
public TransfusionReactionReport()
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>10/25/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5861"> 
///
<ExpectedInput>Valid business object data for summary report</ExpectedInput>
///
<ExpectedOutput>DataSet</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5862"> 
///
<ExpectedInput>Valid business object data for multi divisional summary report</ExpectedInput>
///
<ExpectedOutput>DataSet</ExpectedOutput>
///
</Case>
///
///<Case type="2" testid ="5869"> 
///
<ExpectedInput>Valid business object data for detailed report</ExpectedInput>
///
<ExpectedOutput>DataSet</ExpectedOutput>
///
</Case>
///
///<Case type="3" testid ="5870"> 
///
<ExpectedInput>Valid business object data for multi divisional detailed report</ExpectedInput>
///
<ExpectedOutput>DataSet</ExpectedOutput>
///
</Case>
///
///<Case type="4" testid ="5871"> 
///
<ExpectedInput>Invalid business object data (start and end dates)</ExpectedInput>
///
<ExpectedOutput>Empty DataSet</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// GetReportData
/// </summary>
public DataSet GetReportData()
DataSet reportData = new DataSet("TransfusionReactionCountData");
DataSet temp;
//
if (this.DetailedReport)
if(this.IsMultiDivisional)
temp =  DAL.TransfusionReactionReport.GetDetailedDataForReportAllDivisions(this.StartDate, this.EndDate);
else
temp = DAL.TransfusionReactionReport.GetDetailedDataForReport(this.StartDate, this.EndDate);
else
if (this.IsMultiDivisional)
temp =  DAL.TransfusionReactionReport.GetSummaryDataForReportAllDivisions(this.StartDate, this.EndDate);
else
temp = DAL.TransfusionReactionReport.GetSummaryDataForReport(this.StartDate, this.EndDate);
//
DataTable newTable = new DataTable();
newTable.TableName = "ReportInfo";
newTable.Columns.Add(ARTIFICIAL.DetailReport, typeof(bool));
newTable.Columns.Add(ARTIFICIAL.RecordCount, typeof(int));
//
DataRow newRow = newTable.NewRow();
newRow[ARTIFICIAL.DetailReport] = this.DetailedReport;
//
if(temp.Tables.Count > 0 && temp.Tables[0].Rows.Count > 0)
newRow[ARTIFICIAL.RecordCount] = temp.Tables[0].Rows.Count;
else
newRow[ARTIFICIAL.RecordCount] = 0;
newTable.Rows.Add(newRow);
reportData.Tables.Add(newTable);
//
if (this.DetailedReport)
DataTable dt = temp.Tables[0].Copy();
dt.Columns.Add(TABLE.BloodUnitMedia.Comments, typeof(string));
//
for (int i = 0; i < dt.Rows.Count; i++)
for (int j = 0; j < temp.Tables[1].Rows.Count; j++)
if ( dt.Rows[i][TABLE.PatientTransfusionReaction.PatientTransfusionReactionGuid].ToString().Equals( temp.Tables[1].Rows[j][TABLE.PatientTransfusionReaction.PatientTransfusionReactionGuid].ToString() ) )
string currentComments = dt.Rows[i][TABLE.BloodUnitMedia.Comments].ToString();
string newComment = temp.Tables[1].Rows[j][TABLE.PatientTransfusionComment.PatientTransfusionCommentText].ToString();
//
if( currentComments.Length == 0 )
dt.Rows[i][TABLE.BloodUnitMedia.Comments] = newComment;
else
dt.Rows[i][TABLE.BloodUnitMedia.Comments] = string.Concat( currentComments, "; ", newComment );
//
reportData.Tables.Add(dt);
else
DataTable dt = temp.Tables[0].Copy();
reportData.Tables.Add(dt);
//
return reportData;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>10/22/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="5863"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>string</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="5864"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Builds report criteria string 
/// (what subreports were included, etc.)
/// </summary>
public string GetReportCriteria()
StringBuilder builder = new StringBuilder();
builder.Append("Start Date = ");
builder.Append(Common.VBECSDateTime.FormatDateString(this.StartDate));
builder.Append(", End Date = ");
builder.Append(Common.VBECSDateTime.FormatDateString(this.EndDate));
builder.Append(", Requested Report: ");
builder.Append(this.DetailedReport ? "Detailed" : "Summary");
builder.Append(this.IsMultiDivisional ? ", Multi Divisional" : ", Single Division");
return builder.ToString();
#endregion
