using System;
using System.Data;
using TABLE = EXT.DOMAIN.vbecs.Common.VbecsTables;
using ARTIFICIAL = EXT.DOMAIN.vbecs.Common.DatabaseConstants.ArtificialColumnNames;
namespace EXT.DOMAIN.vbecs.BOL
/// <summary>
/// Summary description for TransfusionReactionWorkupReport.
/// </summary>
public class TransfusionReactionWorkupReport:VbecsReport
private const int PreXMInterp = 109;
private const int PostXMInterp = 110;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/15/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="7877"> 
///
<ExpectedInput>None</ExpectedInput>
///
<ExpectedOutput>Transfusion Reaction Workup Report object</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="7878"> 
///
<ExpectedInput>N/A</ExpectedInput>
///
<ExpectedOutput>N/A</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// TransfusionReactionWorkupReport constructor
/// </summary>
public TransfusionReactionWorkupReport()
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/15/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="7879"> 
///
<ExpectedInput>Valid Patient Transfusion Reaction Guid</ExpectedInput>
///
<ExpectedOutput>Transfusion reaction workup report object updated</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="7880"> 
///
<ExpectedInput>N/A</ExpectedInput>
///
<ExpectedOutput>N/A</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Gets or sets Patient Transfusion Reaction unique identifier
/// </summary>
public Guid PatientTransfusionReactionGuid
get
if (this.ParameterRow.IsNull(TABLE.PatientTransfusionReaction.PatientTransfusionReactionGuid))
return Guid.Empty;
return (Guid)this.ParameterRow[TABLE.PatientTransfusionReaction.PatientTransfusionReactionGuid];
set
this.ParameterRow[TABLE.PatientTransfusionReaction.PatientTransfusionReactionGuid] = value;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/15/2005</CreationDate>
/// <summary>
/// GetPatientTransfusionReactionReport
/// </summary>
/// <returns></returns>
private DataSet GetPatientTransfusionReactionReport()
string preSpecimenUid = "";
string postSpecimenUid = "";
//
DataSet ds = DAL.PatientTransfusionReaction.GetPatientTransfusionReactionReport(this.PatientTransfusionReactionGuid);
//
if (ds.Tables.Count>3)
ds.Tables[0].Columns.Add(Common.DatabaseConstants.ArtificialColumnNames.PatientDisplayName);
//
foreach(DataRow dr in ds.Tables[0].Rows)
dr[Common.DatabaseConstants.ArtificialColumnNames.PatientDisplayName] = 
BOL.Patient.BuildDisplayName(dr[TABLE.Patient.PatientFirstName].ToString(),dr[TABLE.Patient.PatientMiddleName].ToString(),dr[TABLE.Patient.PatientLastName].ToString());
//
if (!dr.IsNull(ARTIFICIAL.PreNACannedCommentGuid))
dr[ARTIFICIAL.PreNACommentText] = BOL.CannedComment.CombinedComment((Guid)dr[ARTIFICIAL.PreNACannedCommentGuid],dr[ARTIFICIAL.PreNACommentText].ToString());
if (!dr.IsNull(ARTIFICIAL.PostNACannedCommentGuid))
dr[ARTIFICIAL.PostNACommentText] = BOL.CannedComment.CombinedComment((Guid)dr[ARTIFICIAL.PostNACannedCommentGuid],dr[ARTIFICIAL.PostNACommentText].ToString());
if (!dr.IsNull(ARTIFICIAL.PreCCCannedCommentGuid))
dr[ARTIFICIAL.PreCCCommentText] = BOL.CannedComment.CombinedComment((Guid)dr[ARTIFICIAL.PreCCCannedCommentGuid],dr[ARTIFICIAL.PreCCCommentText].ToString());
if (!dr.IsNull(ARTIFICIAL.PostCCCannedCommentGuid))
dr[ARTIFICIAL.PostCCCommentText] = BOL.CannedComment.CombinedComment((Guid)dr[ARTIFICIAL.PostCCCannedCommentGuid],dr[ARTIFICIAL.PostCCCommentText].ToString());
if (!dr.IsNull(ARTIFICIAL.FinalizeCannedCommentGuid))
dr[ARTIFICIAL.FinalizeCommentText] = BOL.CannedComment.CombinedComment((Guid)dr[ARTIFICIAL.FinalizeCannedCommentGuid],dr[ARTIFICIAL.FinalizeCommentText].ToString());
if (dr.IsNull(TABLE.TransfusionReactionType.TransfusionReactionTypeText))
dr[TABLE.TransfusionReactionType.TransfusionReactionTypeText] = "Undetermined";
preSpecimenUid = dr[ARTIFICIAL.PreSpecimenUid].ToString().Trim();
postSpecimenUid = dr[ARTIFICIAL.PostSpecimenUid].ToString().Trim();
//
foreach(DataRow dr in ds.Tables[1].Rows)
if (Convert.ToInt32(dr[TABLE.PatientSymptom.PatientSymptomId]) == 21)
string freeTextSymptom = dr[TABLE.PatientSymptom.PatientSymptomName].ToString()+": ";
if (!dr.IsNull(TABLE.PatientTransfusionComment.CannedCommentGuid))
freeTextSymptom += BOL.CannedComment.CombinedComment((Guid)dr[TABLE.PatientTransfusionComment.CannedCommentGuid],dr[TABLE.PatientTransfusionComment.PatientTransfusionCommentText].ToString());
else
freeTextSymptom+=dr[TABLE.PatientTransfusionComment.PatientTransfusionCommentText].ToString();
//
dr[TABLE.PatientSymptom.PatientSymptomName] = freeTextSymptom;
break;
//
if (ds.Tables[1].Rows.Count == 0)
foreach(DataColumn col in ds.Tables[1].Columns)
col.AllowDBNull = true;
DataRow dr = ds.Tables[1].NewRow();
dr[TABLE.PatientSymptom.PatientSymptomName] = "No symptoms identified";
ds.Tables[1].Rows.Add(dr);
//
foreach(DataRow dr in ds.Tables[2].Rows)
if (!dr.IsNull(ARTIFICIAL.BagCannedCommentGuid))
dr[ARTIFICIAL.BagCommentText] = BOL.CannedComment.CombinedComment((Guid)dr[ARTIFICIAL.BagCannedCommentGuid],dr[ARTIFICIAL.BagCommentText].ToString());
if (!dr.IsNull(ARTIFICIAL.CheckCannedCommentGuid))
dr[ARTIFICIAL.CheckCommentText] = BOL.CannedComment.CombinedComment((Guid)dr[ARTIFICIAL.CheckCannedCommentGuid],dr[ARTIFICIAL.CheckCommentText].ToString());
if (!dr.IsNull(Common.DatabaseConstants.ArtificialColumnNames.PooledUnitsCount))
if (Convert.ToInt32(dr[Common.DatabaseConstants.ArtificialColumnNames.PooledUnitsCount])>0)
dr[TABLE.BloodProduct.ProductShortName] = dr[TABLE.BloodProduct.ProductShortName].ToString()+" ("+dr[Common.DatabaseConstants.ArtificialColumnNames.PooledUnitsCount].ToString()+")";
//
if (ds.Tables[2].Rows.Count == 0)
foreach(DataColumn col in ds.Tables[2].Columns)
col.AllowDBNull = true;
DataRow dr = ds.Tables[2].NewRow();
dr[TABLE.BloodUnit.EyeReadableUnitId] = "None";
ds.Tables[2].Rows.Add(dr);
//
foreach(DataRow dr in ds.Tables[3].Rows)
if (!dr.IsNull(TABLE.CannedComment.CannedCommentGuid))
dr[TABLE.BloodUnitTest.TestComments] = BOL.CannedComment.CombinedComment((Guid)dr[TABLE.CannedComment.CannedCommentGuid],dr[TABLE.BloodUnitTest.TestComments].ToString());
if (!dr.IsNull(Common.DatabaseConstants.ArtificialColumnNames.PooledUnitsCount))
if (Convert.ToInt32(dr[Common.DatabaseConstants.ArtificialColumnNames.PooledUnitsCount])>0)
dr[TABLE.BloodProduct.ProductShortName] = dr[TABLE.BloodProduct.ProductShortName].ToString()+" ("+dr[Common.DatabaseConstants.ArtificialColumnNames.PooledUnitsCount].ToString()+")";
if (Convert.ToInt32(dr[TABLE.BloodTestType.BloodTestTypeId]) == PreXMInterp)
dr[TABLE.PatientSpecimen.SpecimenUid] = dr[ARTIFICIAL.PreSpecimenUid];
if (!dr.IsNull(TABLE.BloodUnit.BloodUnitGuid))
if ((Convert.ToInt32(dr[TABLE.BloodTestType.BloodTestTypeId]) != PreXMInterp) &&
(Convert.ToInt32(dr[TABLE.BloodTestType.BloodTestTypeId]) != PostXMInterp))
dr[TABLE.PatientSpecimen.SpecimenUid] = "";
if ((Convert.ToInt32(dr[TABLE.BloodTestType.BloodTestTypeId]) != PreXMInterp) &&
(Convert.ToInt32(dr[TABLE.BloodTestType.BloodTestTypeId]) != PostXMInterp) &&
(dr[TABLE.PatientSpecimen.SpecimenUid].ToString().Trim().Length>0))
if (dr[TABLE.PatientSpecimen.SpecimenUid].ToString().Trim() == preSpecimenUid)
dr[TABLE.BloodTestType.BloodTestName] = "Pre "+dr[TABLE.BloodTestType.BloodTestName];
else if (dr[TABLE.PatientSpecimen.SpecimenUid].ToString().Trim() == postSpecimenUid)
dr[TABLE.BloodTestType.BloodTestName] = "Post "+dr[TABLE.BloodTestType.BloodTestName];
//
if (ds.Tables[3].Rows.Count == 0)
foreach(DataColumn col in ds.Tables[3].Columns)
col.AllowDBNull = true;
DataRow dr = ds.Tables[3].NewRow();
dr[TABLE.BloodTestType.BloodTestName] = "No tests performed";
ds.Tables[3].Rows.Add(dr);
//
return ds;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/15/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="7883"> 
///
<ExpectedInput>Valid Transfusion reaction Workup Report object</ExpectedInput>
///
<ExpectedOutput>Transfusion Reaction Workup Report created</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="7884"> 
///
<ExpectedInput>N/A</ExpectedInput>
///
<ExpectedOutput>N/A</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// GenerateReport
/// </summary>
/// <param name="printedBy"></param>
/// <returns></returns>
public EXT.DOMAIN.vbecs.reports.TransfusionReactionWorkupReport.TransfusionReactionWorkupReport GenerateReport(string printedBy)
DataSet dsReport = this.GetPatientTransfusionReactionReport();
//
#if DEBUG
//dsReport.WriteXml("D:\\temp\\TRWReport.xml", XmlWriteMode.WriteSchema);
#endif
EXT.DOMAIN.vbecs.reports.TransfusionReactionWorkupReport.TransfusionReactionWorkupReport report = new EXT.DOMAIN.vbecs.reports.TransfusionReactionWorkupReport.TransfusionReactionWorkupReport();
report.SetDataSource(dsReport);
//
DataSet dsHeader =  BOL.VbecsReport.GetReportHeader(printedBy);
//
report.OpenSubreport("ReportHeaderPortrait.rpt").SetDataSource(dsHeader);
//
report.OpenSubreport("TrwSymptoms.rpt").SetDataSource(dsReport.Tables[1]);
//
report.OpenSubreport("TrwImplicatedUnits.rpt").SetDataSource(dsReport.Tables[2]);
//
report.OpenSubreport("TrwSerologicTests.rpt").SetDataSource(dsReport.Tables[3]);
//
return report;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/15/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="7885"> 
///
<ExpectedInput>N/A</ExpectedInput>
///
<ExpectedOutput>N/A</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="7886"> 
///
<ExpectedInput>N/A</ExpectedInput>
///
<ExpectedOutput>N/A</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// GenerateAndPrintReport
/// </summary>
public override void GenerateAndPrintReport()
EXT.DOMAIN.vbecs.reports.TransfusionReactionWorkupReport.TransfusionReactionWorkupReport report = this.GenerateReport(new BOL.VbecsUser(this.PrintedBy).UserName);
//
report.PrintOptions.PrinterName = this.PrinterName;
//
report.PrintToPrinter(1, false, 0, 0);
