using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;
using System.Collections.Specialized;
using System.ServiceProcess;
using System.IO;
using System.Reflection;
using System.Xml;
using Microsoft.Win32;
namespace EXT.DOMAIN.vbecs.DAL.HL7.Client.WinService
/// <summary>
/// This is a custom project installer.
/// Applies a unique name to the service using the /name switch
/// Sets user name and password using the /user and /password switches
/// Allows the use of a local account using the /account switch
/// </summary>
[RunInstaller(true)]
public class ScriptedInstaller : Installer
private ServiceInstaller serviceInstaller;
private ServiceProcessInstaller processInstaller;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8969"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8970"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor
/// </summary>
public ScriptedInstaller()
processInstaller
= new ServiceProcessInstaller();
serviceInstaller
= new ServiceInstaller();
// Always following parameters (any command line args regarding that will be ignored)
processInstaller.Account        = System.ServiceProcess.ServiceAccount.User;
serviceInstaller.StartType
= ServiceStartMode.Manual;
Installers.Add(serviceInstaller);
Installers.Add(processInstaller);
#region Access parameters
/// <summary>
/// Return the value of the parameter in dicated by key
/// </summary>
/// <param name="key">Context parameter key</param>
/// <returns>Context parameter specified by key</returns>
public string GetContextParameter(string key) 
string sValue = "";
try 
sValue = this.Context.Parameters[key].ToString();
catch 
sValue = "";
return sValue;
#endregion
/// <summary>
/// This method is run before the install process.
/// This method is overriden to set the following parameters:
/// service name (/name switch)
/// for a user account user name (/user switch)
/// for a user account password (/password switch)
/// Note that when using a user account, if the user name or password is not set,
/// the installing user is prompted for the credentials to use.
/// CR 2732: self installation/uninstallation feature.
/// </summary>
/// <param name="savedState"></param>
protected override void OnBeforeInstall(IDictionary savedState)
base.OnBeforeInstall(savedState);
// Get service name
string serviceName = GetContextParameter("serviceName");
            if( serviceName != string.Empty )
            {
                // Overwrite configuration server name
                SetXmlConfigFileKeyValue("serviceName", serviceName);
            }
            else
            {
                // Try to read server name from configuration
                serviceName = System.Configuration.ConfigurationSettings.AppSettings["serviceName"];
            }
            // If finally service name is not available error out
            if( serviceName == string.Empty )
                throw new System.Configuration.ConfigurationException("serviceName is not avalable");
            serviceInstaller.ServiceName = serviceName;
            // Get DB connection string
            string db_server = GetContextParameter("server");
            string db_name = GetContextParameter("database");
            if( (db_server != string.Empty || db_name != string.Empty) &&
                (db_server == string.Empty || db_name == string.Empty) )
                throw new System.Configuration.ConfigurationException("Server and database arguments must be specified together.");
            if(db_server == string.Empty && db_name == string.Empty && 
               System.Configuration.ConfigurationSettings.AppSettings["PrimaryDbConnectionString"] == string.Empty)
                throw new System.Configuration.ConfigurationException("Some database arguments are missed.");
            // If command line contains data base information, overwrite it in configuration file
            if(db_server != string.Empty && db_name != string.Empty)
    
SetXmlConfigFileKeyValue("PrimaryDbConnectionString","Connection Timeout=90"
+ ";Data Source=" + GetContextParameter("server") + ";Initial Catalog=" + GetContextParameter("database")
+ ";persist security info=False;packet size=8192;integrated security=SSPI"
+ ";Application Name=VBECS");
            // If we need to use a user account, set the user name and password
processInstaller.Username = GetContextParameter("username");
processInstaller.Password = GetContextParameter("password");
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8972"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8973"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Modify the registry to install the new service
/// </summary>
/// <param name="stateServer"></param>
public override void Install(IDictionary stateServer)
RegistryKey system,
//HKEY_LOCAL_MACHINE\Services\CurrentControlSet
currentControlSet,
//...\Services
services,
//...\<Service Name>
service,
//...\Parameters - this is where you can put service-specific configuration
config; 
base.Install(stateServer);
// Define the registry keys
// Navigate to services
system
= Registry.LocalMachine.OpenSubKey("System");
currentControlSet
= system.OpenSubKey("CurrentControlSet");
services
= currentControlSet.OpenSubKey("Services");
// Add the service
service
= services.OpenSubKey(this.serviceInstaller.ServiceName, true);
// Default service description
service.SetValue("Description", "Monitors the VBECS database for HL7 messages for CPRS.");
// Display the assembly image path and modify to add the service name
// The executable then strips the name out of the image
Console.WriteLine("ImagePath: " + service.GetValue("ImagePath"));
string imagePath = (string)service.GetValue("ImagePath");
imagePath
+= " -s" + this.serviceInstaller.ServiceName;
service.SetValue("ImagePath", imagePath);
// Create a parameters subkey
config
= service.CreateSubKey("Parameters");
// Close keys
config.Close();
service.Close();
services.Close();
currentControlSet.Close();
system.Close();
/// <summary>
/// Uninstall based on the service name
/// </summary>
/// <param name="savedState"></param>
protected override void OnBeforeUninstall(IDictionary savedState)
            // Set the service name based on the config file.
            serviceInstaller.ServiceName = System.Configuration.ConfigurationSettings.AppSettings["serviceName"];
base.OnBeforeUninstall(savedState);
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8974"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8975"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Modify the registry to remove the service
/// </summary>
/// <param name="stateServer"></param>
public override void Uninstall(IDictionary stateServer)
RegistryKey system,
//HKEY_LOCAL_MACHINE\Services\CurrentControlSet
currentControlSet,
//...\Services
services,
//...\<Service Name>
service;
//...\Parameters - this is where you can put service-specific configuration
base.Uninstall(stateServer);
// Navigate down the registry path
system
= Registry.LocalMachine.OpenSubKey("System");
currentControlSet
= system.OpenSubKey("CurrentControlSet");
services
= currentControlSet.OpenSubKey("Services");
service
= services.OpenSubKey(System.Configuration.ConfigurationSettings.AppSettings["serviceName"],true);
// Remove the parameters key
service.DeleteSubKeyTree("Parameters");
// Close keys
service.Close();
services.Close();
currentControlSet.Close();
system.Close();
// Potentially unwanted code that need to be removed
private static bool SetXmlConfigFileKeyValue(string keyName, string keyValue)
FileInfo _fileInfo = new FileInfo(Assembly.GetExecutingAssembly().Location + ".config");
if(!_fileInfo.Exists)
throw new InstallException("Missing config file");
XmlDocument xmlConfig = new XmlDocument();
xmlConfig.Load(_fileInfo.FullName);
bool keyExists = false;
foreach(XmlNode node in xmlConfig["configuration"]["appSettings"])
if(node.Name == "add")
if(node.Attributes.GetNamedItem("key").Value == keyName)
node.Attributes.GetNamedItem("value").Value = keyValue;
keyExists = true;
xmlConfig.Save(_fileInfo.FullName);
return keyExists;
}//end class
}//end namespace declaration
