using System;
using System.Xml;
using System.Collections;
using System.Configuration;
using EXT.DOMAIN.vbecs.Common;
namespace EXT.DOMAIN.vbecs.DAL.HL7.Client.WinService
    /// <summary>
    /// Parses configuration section. Created regarding CR 2732.
    /// </summary>
    public class TimerSettingsSectionHandler : IConfigurationSectionHandler
    {
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8982"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8983"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor
/// </summary>
        public TimerSettingsSectionHandler()
        {}
        #region IConfigurationSectionHandler Members
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9006"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9007"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Actually this method creates a TimerSettingsSection object.
/// </summary>
/// <param name="parent"></param>
/// <param name="configContext"></param>
/// <param name="section"></param>
/// <returns></returns>
        public object Create(object parent, object configContext, System.Xml.XmlNode section)
        {
            int ping_iterval = 0;
            bool log = false;
            bool enabled = false;
            // First read enabled flag if it is 'false' don't read rest configuration staff.
            XmlNode a = section.Attributes.RemoveNamedItem("Enabled");
            if(a != null)
                enabled = bool.Parse(a.Value);
            if( !enabled )
                return new TimerSettingsSection(ping_iterval, log, enabled, string.Empty, null);
            a = section.Attributes.RemoveNamedItem("PingInterval");
            if(a == null)
                throw new ConfigurationException("Attribute required: PingInterval");
            else
                ping_iterval = int.Parse(a.Value);
            if(ping_iterval == 0)
                throw new ConfigurationException("PingInterval can't be 0");
            a = section.Attributes.RemoveNamedItem("Log");
            if(a == null)
                throw new ConfigurationException("Attribute required: Log");
            else
                log = bool.Parse(a.Value);
            //read pinger's type
            string type = null;
            a = section.SelectSingleNode("Pinger/Type/text()");
            if(a == null)
                throw new ConfigurationException("Node required: Type");
            type = a.Value;
            //read pingers's configuration values
            System.Collections.Hashtable adds = new System.Collections.Hashtable();
            XmlNodeList list = section.SelectNodes("Pinger/add");
            if(list != null)
            {
                //Change the price on the books.
                foreach (XmlNode add_node in list)
                {
                    string key = null;
                    a = add_node.Attributes.RemoveNamedItem("key");
                    if(a == null)
                        throw new ConfigurationException("Attribute required: key");
                    key = a.Value;
                    string val = null;
                    a = add_node.Attributes.RemoveNamedItem("value");
                    if(a == null)
                        throw new ConfigurationException("Attribute required: value");
                    val = a.Value;
                    adds.Add( key, val );
                }                
            }
            // Try to get port number and IP from the database
if( ConfigurationSettings.AppSettings["PrimaryDbConnectionString"] != string.Empty )
IList hl7_interfaces = EXT.DOMAIN.vbecs.DAL.HL7AL.HL7Interface.GetHL7Interfaces();
EXT.DOMAIN.vbecs.DAL.HL7AL.HL7Interface cprs_interface = null;
foreach(EXT.DOMAIN.vbecs.DAL.HL7AL.HL7Interface int_face in hl7_interfaces)
if(int_face.InterfaceName == "CPRS")
cprs_interface = int_face;
break;
                // Don't use data base at all if some information in data base is not available. 
                // Values from configuration file will be used instead.
                if(cprs_interface == null || cprs_interface.InterfaceIPAddress == null || cprs_interface.InterfacePortNumber == EXT.DOMAIN.vbecs.Common.StNullConvert.Int32Null)
                {
                    EventsLoggerSingleton.Instance.Log("Some vaules for CPRS interface in VBECS database are not found. Use values from configuration file if the present there.");
                    // Note: if configuration file doesn't have IP or Port number information. Pinger object has to handle this case correclty.
                    // For example record warning and disable pinging functionality.
                    return new TimerSettingsSection(ping_iterval, log, enabled, type, adds);
                }
if(adds.Contains("PingIP"))
adds["PingIP"] = cprs_interface.InterfaceIPAddress.ToString();
else
adds.Add( "PingIP", cprs_interface.InterfaceIPAddress.ToString() );
if(adds.Contains("PingPort"))
adds["PingPort"] = cprs_interface.InterfacePortNumber.ToString();
else
adds.Add( "PingPort", cprs_interface.InterfacePortNumber.ToString() );
            else
                EventsLoggerSingleton.Instance.Log("Database connection string is not found. Use values from configuration file if the present there.");
            return new TimerSettingsSection(ping_iterval, log, enabled, type, adds);
        }
        #endregion
    }
/// <summary>
/// Class TimerSettingsSection
/// </summary>
    public class TimerSettingsSection
    {
        private int ping_iterval_ = 0;
        private bool log_ = false;
        private bool enabled_ = false;
        private string type_ = string.Empty;
        System.Collections.Hashtable in_params_;
      
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8984"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8985"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor
/// </summary>
/// <param name="ping_iterval"></param>
/// <param name="log"></param>
/// <param name="enabled"></param>
/// <param name="type"></param>
/// <param name="in_params"></param>
        public TimerSettingsSection(int ping_iterval, bool log, bool enabled, string type,
            System.Collections.Hashtable in_params)
        {
            ping_iterval_ = ping_iterval;
            log_ = log;
            enabled_ = enabled;
            type_ = type;
            in_params_ = in_params;
        }
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8986"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8987"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Ping Interval
/// </summary>
        public int PingInterval
        {
            get
            { return ping_iterval_; }
        }
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8994"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8995"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Log
/// </summary>
        public bool Log
        {
            get
            { return log_; }
        }
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8992"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8993"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Enabled
/// </summary>
        public bool Enabled
        {
            get
            { return enabled_; }
        }
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8990"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8991"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Type
/// </summary>
        public string Type
        {
            get 
            { return type_; }
        }
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/16/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8988"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="8989"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// In Parameters
/// </summary>
        public System.Collections.Hashtable InParams
        {
            get
            { return in_params_; }
        }
/// <summary>
/// Becouse ProjectInstaller updates configuration file
/// </summary>
internal void PostInnitiallization()
    }
