using System;
using System.Collections.Specialized;
using System.IO;
namespace EXT.DOMAIN.vbecs.ExceptionManagement
#region Header
///<Package>Package: VBECS - VistA Blood Establishment Computer System</Package>
///<Warning> WARNING: Per VHA Directive $VADIRECTIVE this class should not be modified</Warning>
///<MedicalDevice> Medical Device #: $MEDDEVICENO</MedicalDevice>
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>2/24/2003</CreationDate>
///<Note>The Food and Drug Administration classifies this software as a medical device.  As such, it may not be changed in any way. Modifications to this software may result in an adulterated medical device under 21CFR820, the use of which is considered to be a violation of US Federal Statutes.  Acquiring and implementing this software through the Freedom of information Act requires the implementor to assume total responsibility for the software, and become a registered manufacturer of a medical device, subject to FDA regulations</Note>
///<summary>ExceptionPublisher</summary>
#endregion
public class ExceptionFilePublisher : IExceptionPublisher
/// <summary>
/// Function sends an email with the contents fo the exception passed in.
/// </summary>
/// <param name="exception">Exception that occured in the system.</param>
/// <param name="additionalInfo"></param>
/// <param name="ConfigSettings"></param>
void IExceptionPublisher.Publish(Exception exception, NameValueCollection additionalInfo, NameValueCollection ConfigSettings)
if( Common.VbecsConfig.Current.ErrorLogFileName.Length <= 0 )
return;
string formattedException = ExceptionManagement.DefaultPublisher.FormatExceptionInfoAndDumpToString( exception );
using ( FileStream fs = File.Open(Common.VbecsConfig.Current.ErrorLogFileName, FileMode.Append, FileAccess.Write))
using (StreamWriter sw = new StreamWriter(fs))
sw.Write(formattedException);
