//===============================================================================
// Microsoft Exception Management Application Block for .NET
// http://msdn.microsoft.com/library/en-us/dnbda/html/emab-rm.asp
//
// ExceptionManagerExceptions.cs
// This file contains the CustomPublisherException class, which it created when 
// a publisher throws an exception to the ExceptionManager class.
//
// For more information see the Implementation of the CustomPublisherException 
// Class section of the Exception Management Application Block Implementation Overview. 
//===============================================================================
// Copyright (C) 2000-2001 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================
using System;
using System.Runtime.Serialization;
using System.Security.Permissions;
namespace EXT.DOMAIN.vbecs.ExceptionManagement
#region Header
///<Package>Package: VBECS - VistA Blood Establishment Computer System</Package>
///<Warning> WARNING: Per VHA Directive $VADIRECTIVE this class should not be modified</Warning>
///<MedicalDevice> Medical Device #: $MEDDEVICENO</MedicalDevice>
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>03/12/2003</CreationDate>
///<Note>The Food and Drug Administration classifies this software as a medical device.  As such, it may not be changed in any way. Modifications to this software may result in an adulterated medical device under 21CFR820, the use of which is considered to be a violation of US Federal Statutes.  Acquiring and implementing this software through the Freedom of information Act requires the implementor to assume total responsibility for the software, and become a registered manufacturer of a medical device, subject to FDA regulations</Note>
/// <summary>
/// Summary description for ExceptionManagerExceptions.
/// </summary>
#endregion
[Serializable]
public class CustomPublisherException : BaseApplicationException
#region Constructors
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>2/24/2003</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="3054"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>CustomPublisherException object</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="3055"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// Constructor with no params.
/// </summary>
public CustomPublisherException() : base()
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>2/24/2003</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="2341"> 
///
<ExpectedInput>string</ExpectedInput>
///
<ExpectedOutput>Valid CustomPublisherException object</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="2342"> 
///
<ExpectedInput>null</ExpectedInput>
///
<ExpectedOutput>CustomPublisherException object</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor allowing the Message property to be set.
/// </summary>
/// <param name="message">String setting the message of the exception.</param>
public CustomPublisherException(string message) : base(message)
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>2/24/2003</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="2343"> 
///
<ExpectedInput>string and exception</ExpectedInput>
///
<ExpectedOutput>Valid CustomPublisherException object</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="2344"> 
///
<ExpectedInput>nulls</ExpectedInput>
///
<ExpectedOutput>CustomPublisherException object</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor allowing the Message and InnerException property to be set.
/// </summary>
/// <param name="message">String setting the message of the exception.</param>
/// <param name="inner">Sets a reference to the InnerException.</param>
public CustomPublisherException(string message,Exception inner) : base(message, inner)
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>2/24/2003</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="2345"> 
///
<ExpectedInput>Message, assembly name, type name and PublisherFormat</ExpectedInput>
///
<ExpectedOutput>Valid CustomPublisherException object</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="2346"> 
///
<ExpectedInput>Null values</ExpectedInput>
///
<ExpectedOutput>CustomPublisherException object</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor allowing the message, assembly name, type name, and publisher format to be set.
/// </summary>
/// <param name="message">String setting the message of the exception.</param>
/// <param name="assemblyName">String setting the assembly name of the exception.</param>
/// <param name="typeName">String setting the type name of the exception.</param>
/// <param name="publisherFormat">String setting the publisher format of the exception.</param>
public CustomPublisherException(string message, string assemblyName, string typeName, PublisherFormat publisherFormat) : base(message)
this.assemblyName = assemblyName;
this.typeName = typeName;
this.publisherFormat = publisherFormat;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>2/24/2003</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="2349"> 
///
<ExpectedInput>Message, assembly name, type name, PublisherFormat, inner exception</ExpectedInput>
///
<ExpectedOutput>Valid CustomPublisherException object</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="2350"> 
///
<ExpectedInput>Null values</ExpectedInput>
///
<ExpectedOutput>CustomPublisherException object</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor allowing the Message and InnerException property to be set.
/// </summary>
/// <param name="message">String setting the message of the exception.</param>
/// <param name="assemblyName">String setting the assembly name of the exception.</param>
/// <param name="typeName">String setting the type name of the exception.</param>
/// <param name="publisherFormat">String setting the publisher format of the exception.</param>
/// <param name="inner">Sets a reference to the InnerException.</param>
public CustomPublisherException(string message, string assemblyName, string typeName, PublisherFormat publisherFormat, Exception inner) : base(message, inner)
this.assemblyName = assemblyName;
this.typeName = typeName;
this.publisherFormat = publisherFormat;
/// <summary>
/// Constructor used for deserialization of the exception class.
/// </summary>
/// <param name="info">Represents the SerializationInfo of the exception.</param>
/// <param name="context">Represents the context information of the exception.</param>
protected CustomPublisherException(SerializationInfo info, StreamingContext context) : base(info, context)
assemblyName = info.GetString("assemblyName");
typeName = info.GetString("typeName");
publisherFormat = (PublisherFormat)info.GetValue("publisherFormat",typeof(PublisherFormat));
#endregion
// Member variable declarations
private string assemblyName;
private string typeName;
private PublisherFormat publisherFormat;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>2/24/2003</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="3052"> 
///
<ExpectedInput>Valid info and context objects</ExpectedInput>
///
<ExpectedOutput>Valid object data in OS, user name</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="3053"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// This method overrides the GetObjectData method in Exception.  It sets the SerializationInfo
/// with information or custom values about the exception.
/// </summary>
/// <param name="info">Represents the SerializationInfo of the exception.</param>
/// <param name="context">Represents the context information of the exception.</param>
[SecurityPermission(SecurityAction.Demand, SerializationFormatter = true)]
public override void GetObjectData( SerializationInfo info, StreamingContext context ) 
info.AddValue("assemblyName", assemblyName, typeof(string));
info.AddValue("typeName", typeName, typeof(string));
info.AddValue("publisherFormat", publisherFormat, typeof(PublisherFormat));
base.GetObjectData(info,context);
#region Public Properties
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>2/24/2003</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="2351"> 
///
<ExpectedInput>none</ExpectedInput>
///
<ExpectedOutput>PublisherFormat</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="3072"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// The exception format configured for the publisher that threw an exception.
/// </summary>
public PublisherFormat PublisherFormat
get
return publisherFormat;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>2/24/2003</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="2352"> 
///
<ExpectedInput>none</ExpectedInput>
///
<ExpectedOutput>string</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="3073"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// The Assembly name of the publisher that threw an exception.
/// </summary>
public string PublisherAssemblyName
get
return assemblyName;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>2/24/2003</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="2353"> 
///
<ExpectedInput>none</ExpectedInput>
///
<ExpectedOutput>string</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="3085"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// The Type name of the publisher that threw an exception.
/// </summary>
public string PublisherTypeName
get
return typeName;
#endregion
