using System;
using System.Data;
using System.Data.SqlClient;
using STOREDPROC = EXT.DOMAIN.vbecs.Common.VbecsStoredProcs;
using TABLES = EXT.DOMAIN.vbecs.Common.VbecsTables;
using ARTIFICIAL = EXT.DOMAIN.vbecs.Common.DatabaseConstants.ArtificialColumnNames;
namespace EXT.DOMAIN.vbecs.DAL
#region Header
///<Package>Package: VBECS - VistA Blood Establishment Computer System</Package>
///<Warning> WARNING: Per VHA Directive $VADIRECTIVE this class should not be modified</Warning>
///<MedicalDevice> Medical Device #: $MEDDEVICENO</MedicalDevice>
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>09/22/2003</CreationDate>
///<Note>The Food and Drug Administration classifies this software as a medical device.  As such, it may not be changed in any way. Modifications to this software may result in an adulterated medical device under 21CFR820, the use of which is considered to be a violation of US Federal Statutes.  Acquiring and implementing this software through the Freedom of information Act requires the implementor to assume total responsibility for the software, and become a registered manufacturer of a medical device, subject to FDA regulations</Note>
///<summary>
/// LockManager data access layer class.
///</summary>
#endregion
public class LockManager
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>3/3/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6817"> 
///
<ExpectedInput>RecordGuid, FormInstanceGuid, LockFunction</ExpectedInput>
///
<ExpectedOutput>DataTable</ExpectedOutput>
///
</Case>
///
///
///<Case type="1" testid ="6818"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Locks the incoming record
/// </summary>
/// <param name="recordGuid"></param>
/// <param name="formInstanceGuid"></param>
/// <param name="lockFunction"></param>
/// <param name="multiDivisionIndicator"></param>
public static DataTable LockRecord(System.Guid recordGuid, System.Guid formInstanceGuid, Common.LockFunctions lockFunction, bool multiDivisionIndicator)
SqlParameter[] prms =
new SqlParameter(STOREDPROC.InsertLock.recordguid, System.Data.DbType.Guid),
new SqlParameter(STOREDPROC.InsertLock.forminstanceguid, System.Data.DbType.Guid),
new SqlParameter(STOREDPROC.InsertLock.functionid, System.Data.SqlDbType.Int),
new SqlParameter(STOREDPROC.InsertLock.lastupdateuser,System.Data.DbType.String),
new SqlParameter(STOREDPROC.InsertLock.lastupdatefunctionid, System.Data.SqlDbType.Int),
new SqlParameter(STOREDPROC.InsertLock.divisioncode, System.Data.SqlDbType.VarChar),
new SqlParameter(STOREDPROC.InsertLock.sessionguid, System.Data.SqlDbType.UniqueIdentifier),
new SqlParameter(STOREDPROC.InsertLock.multidivisionindicator, System.Data.SqlDbType.Bit)
};
prms[0].Value = recordGuid;
prms[1].Value = formInstanceGuid;
prms[2].Value = (int)lockFunction;
prms[3].Value = Common.LogonUser.LogonUserName;
prms[4].Value = (int)Common.UpdateFunction.LockingFunction;
prms[5].Value = (Common.LogonUser.LogonUserDivisionCode != null) ? (object)Common.LogonUser.LogonUserDivisionCode : (object)DBNull.Value;
prms[6].Value = Common.LogonUser.VbecsSessionGuid;
prms[7].Value = multiDivisionIndicator;
return DAL.StoredProcedure.GetDataTable(STOREDPROC.InsertLock.StoredProcName, prms);
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>3/3/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6819"> 
///
<ExpectedInput>RecordGuid</ExpectedInput>
///
<ExpectedOutput>DataTable</ExpectedOutput>
///
</Case>
///
///
///<Case type="1" testid ="6820"> 
///
<ExpectedInput>Invalid RecordGuid</ExpectedInput>
///
<ExpectedOutput>Empty DataTable</ExpectedOutput>
///
</Case>
///
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Returns table for Locked record.  (record(s)? - hopefully not)
/// </summary>
/// <param name="recordGuid"></param>
/// <returns></returns>
public static System.Data.DataTable GetLock(System.Guid recordGuid)
SqlParameter[] prms =
new SqlParameter(STOREDPROC.GetLock.recordguid, System.Data.DbType.Guid),
new SqlParameter(STOREDPROC.GetLock.divisioncode, System.Data.SqlDbType.VarChar)
};
prms[0].Value = recordGuid;
prms[1].Value = Common.LogonUser.LogonUserDivisionCode;
return DAL.StoredProcedure.GetDataTable(STOREDPROC.GetLock.StoredProcName, prms);
/// <summary>
/// Returns a DataTable of Lock(s) for a given FormInstanceGuid
/// </summary>
/// <param name="formInstanceGuid"></param>
/// <returns></returns>
public static System.Data.DataTable GetLocksByFormInstanceGuid(System.Guid formInstanceGuid)
SqlParameter[] prms =
new SqlParameter(STOREDPROC.GetLocksByFormInstanceGuid.forminstanceguid, System.Data.DbType.Guid),
new SqlParameter(STOREDPROC.GetLocksByFormInstanceGuid.divisioncode, System.Data.SqlDbType.VarChar)
};
prms[0].Value = formInstanceGuid;
prms[1].Value = Common.LogonUser.LogonUserDivisionCode;
return DAL.StoredProcedure.GetDataTable(STOREDPROC.GetLocksByFormInstanceGuid.StoredProcName, prms);
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>3/3/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="6821"> 
///
<ExpectedInput>UserName LockFunction</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///
///<Case type="1" testid ="6822"> 
///
<ExpectedInput>Undefined User</ExpectedInput>
///
<ExpectedOutput>DataAccessLayerException</ExpectedOutput>
///
</Case>
///
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// NEW
/// </summary>
/// <param name="userName"></param>
/// <param name="lockFunction"></param>
/// <param name="formInstanceGuid"></param>
public static void UnlockAllRecordsForUseCaseUser(string userName, Common.LockFunctions lockFunction, System.Guid formInstanceGuid)
SqlParameter[] prms =
new SqlParameter(STOREDPROC.DeleteLock.functionid, System.Data.DbType.Int16),
new SqlParameter(STOREDPROC.DeleteLock.lastupdateuser, System.Data.DbType.String),
new SqlParameter(STOREDPROC.DeleteLock.forminstanceguid, System.Data.DbType.Guid),
new SqlParameter(STOREDPROC.DeleteLock.divisioncode, System.Data.DbType.String),
new SqlParameter(STOREDPROC.DeleteLock.sessionguid, System.Data.DbType.Guid)
};
prms[0].Value = (int)lockFunction;
prms[1].Value = Common.LogonUser.LogonUserName;
prms[2].Value = formInstanceGuid;
if (EXT.DOMAIN.vbecs.Common.LogonUser.NotDefined)
prms[3].Value = DBNull.Value;
else
prms[3].Value = Common.LogonUser.LogonUserDivisionCode;
prms[4].Value = Common.LogonUser.VbecsSessionGuid;
new StoredProcedure().TransactionalGetValue(STOREDPROC.DeleteLock.StoredProcName, prms);
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/20/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="1192"> 
///
<ExpectedInput>RecordGuids, LockFunctions Id</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="1193"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// Unlock multiple records in a transaction
/// </summary>
/// <param name="recordGuids"></param>
/// <param name="formInstanceGuid"></param>
/// <param name="lockFunction"></param>
public static void UnlockRecords(System.Guid[] recordGuids, System.Guid formInstanceGuid, Common.LockFunctions lockFunction)
System.Data.DataTable dtLocks = new System.Data.DataTable();
//Column names that correspond to the spInsertLock parameter list
dtLocks.Columns.Add(TABLES.VbecsLock.RecordGuid, typeof(System.Guid));
dtLocks.Columns.Add(TABLES.VbecsLock.FormInstanceGuid, typeof(System.Guid));
dtLocks.Columns.Add(TABLES.VbecsLock.FunctionId, typeof(int));
dtLocks.Columns.Add(TABLES.VbecsLock.LastUpdateUser, typeof(string));
dtLocks.Columns.Add(TABLES.VbecsLock.DivisionCode, typeof(string));
dtLocks.Columns.Add(TABLES.VbecsLock.SessionGuid, typeof(System.Guid));
//Create a new row in the table for each Record we want locked
foreach(System.Guid recordGuid in recordGuids)
System.Data.DataRow drAdd = dtLocks.NewRow();
drAdd[TABLES.VbecsLock.RecordGuid] = recordGuid;
drAdd[TABLES.VbecsLock.FormInstanceGuid] = formInstanceGuid;
drAdd[TABLES.VbecsLock.FunctionId] = (int)lockFunction;
drAdd[TABLES.VbecsLock.LastUpdateUser] = Common.LogonUser.LogonUserName;
if (Common.LogonUser.LogonUserDivisionCode != null)
drAdd[TABLES.VbecsLock.DivisionCode] = Common.LogonUser.LogonUserDivisionCode;
drAdd[TABLES.VbecsLock.SessionGuid] = Common.LogonUser.VbecsSessionGuid;
dtLocks.Rows.Add(drAdd);
new StoredProcedure().TransactionalGetValue(STOREDPROC.DeleteLock.StoredProcName, dtLocks);
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/20/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="1194"> 
///
<ExpectedInput>UserName</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="1195"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// Deletes all records from the VbecsLock table for a particular user
/// </summary>
/// <param name="userName"></param>
/// <param name="unlockAllSessions"></param>
public static void UnlockAllRecordsForUser(string userName, bool unlockAllSessions)
SqlParameter[] prms =
new SqlParameter(STOREDPROC.DeleteAllVbecsLocksForUser.lastupdateuser, System.Data.DbType.String),
new SqlParameter(STOREDPROC.DeleteAllVbecsLocksForUser.sessionguid, System.Data.SqlDbType.UniqueIdentifier)
};
prms[0].Value = userName;
prms[1].Value = unlockAllSessions ? (object)DBNull.Value : (object)Common.LogonUser.VbecsSessionGuid;
new StoredProcedure().TransactionalGetValue(STOREDPROC.DeleteAllVbecsLocksForUser.StoredProcName, prms);
