using System;
using System.Data;
using System.Data.SqlClient;
using STOREDPROC = EXT.DOMAIN.vbecs.Common.VbecsStoredProcs;
namespace EXT.DOMAIN.vbecs.DAL
#region Header
///<Package>Package: VBECS - VistA Blood Establishment Computer System</Package>
///<Warning> WARNING: Per VHA Directive $VADIRECTIVE this class should not be modified</Warning>
///<MedicalDevice> Medical Device #: $MEDDEVICENO</MedicalDevice>
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>03/12/2004</CreationDate>
///<Note>The Food and Drug Administration classifies this software as a medical device.  As such, it may not be changed in any way. Modifications to this software may result in an adulterated medical device under 21CFR820, the use of which is considered to be a violation of US Federal Statutes.  Acquiring and implementing this software through the Freedom of information Act requires the implementor to assume total responsibility for the software, and become a registered manufacturer of a medical device, subject to FDA regulations</Note>
///<summary>
/// VbecsDateTime data access layer class.
///</summary>
#endregion
public class VbecsDateTime
#region Methods
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/15/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="1226"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>String representing TimeZone</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="3822"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// Gets information about division time zone
/// </summary>
/// <returns></returns>
public static string GetDivisionTimeZone()
SqlParameter[] _prms =
new SqlParameter(STOREDPROC.GetDivisionTimeZone.divisioncode, System.Data.SqlDbType.Char)
};
_prms[0].Value = Common.LogonUser.LogonUserDivisionCode;
DataSet ds = DAL.StoredProcedure.GetData(STOREDPROC.GetDivisionTimeZone.StoredProcName, _prms);
if (ds.Tables[0].Rows[0][0].ToString() == string.Empty)
return "Time Zone is not setup for division " + Common.LogonUser.LogonUserDivisionCode; 
else
return (System.Convert.ToString(ds.Tables[0].Rows[0][0]));
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>8/22/2005</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="8063"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>string</ExpectedOutput>
///
</Case>
///
///
///<Case type="1" testid ="8064"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// GetDivisionTimeZoneAbbreviation
/// </summary>
/// <returns></returns>
public static string GetDivisionTimeZoneAbbreviation()
SqlParameter[] _prms =
new SqlParameter(STOREDPROC.GetDivisionTimeZoneAbbreviation.divisioncode, System.Data.SqlDbType.Char)
};
_prms[0].Value = Common.LogonUser.LogonUserDivisionCode;
DataSet ds = DAL.StoredProcedure.GetData(STOREDPROC.GetDivisionTimeZoneAbbreviation.StoredProcName, _prms);
return ds.Tables[0].Rows[0][Common.VbecsTables.TimeZone.TimeZoneName].ToString();
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/15/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="1232"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="1234"> 
///
<ExpectedInput>NA</ExpectedInput>
///
<ExpectedOutput>NA</ExpectedOutput>
///
</Case>
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// Gets division current data time based on the converted server current time
/// </summary>
/// <returns></returns>
public static System.DateTime GetDivisionCurrentDateTime()
return DAL.VbecsDateTime.GetDivisionCurrentDateTime(Common.LogonUser.LogonUserDivisionCode);
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/15/2004</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="1238"> 
///
<ExpectedInput>DivisonCode</ExpectedInput>
///
<ExpectedOutput>DateTime of Division</ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="1239"> 
///
<ExpectedInput>Invalid Division</ExpectedInput>
///
<ExpectedOutput>InvalidCastException</ExpectedOutput>
///
</Case>
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
/// <summary>
/// Gets division current data time based on the converted server current time
/// </summary>
/// <param name="divisionCode">Division Code</param>
/// <returns></returns>
public static System.DateTime GetDivisionCurrentDateTime(string divisionCode)
SqlParameter[] _prms =
new SqlParameter(STOREDPROC.GetDivisionCurrentDateTime.divisioncode, System.Data.SqlDbType.Char)
};
_prms[0].Value = divisionCode;
DataSet ds = DAL.StoredProcedure.GetData(STOREDPROC.GetDivisionCurrentDateTime.StoredProcName, _prms);
if (ds.Tables[0].Rows[0][0].ToString() == string.Empty)
return System.DateTime.Now;
else
return (System.Convert.ToDateTime(ds.Tables[0].Rows[0][0]));
#endregion
