using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using System.Windows.Forms;
namespace EXT.DOMAIN.vbecs.GUI
/// <summary>
/// Class FrmMaintainEquipment
/// </summary>
public class FrmMaintainEquipment : EXT.DOMAIN.vbecs.GUI.VbecsBaseForm
#region Form Controls
private System.Windows.Forms.Button btnCancel;
private System.Windows.Forms.GroupBox grpInventory;
private System.Windows.Forms.Panel pnlContainer;
private System.Windows.Forms.PictureBox picFlask;
private System.Windows.Forms.Splitter splitter1;
private System.Windows.Forms.Panel pnlTreeView;
private System.Windows.Forms.Button btnSearch;
private System.Windows.Forms.TreeView tvInventory;
private System.Windows.Forms.Panel pnlTreeViewHeader;
private System.Windows.Forms.Label lblInventory;
private System.Windows.Forms.PictureBox picInventory;
private System.Windows.Forms.GroupBox grpImage;
private System.Windows.Forms.ColumnHeader columnHeader1;
private System.Windows.Forms.ColumnHeader columnHeader2;
private System.Windows.Forms.ColumnHeader columnHeader3;
private EXT.DOMAIN.vbecs.GUI.controls.VbecsButton btnOK;
private System.Windows.Forms.ImageList imageList1;
private System.Windows.Forms.Panel pnlEquipmentHeader;
private System.Windows.Forms.PictureBox picEquipment;
private System.Windows.Forms.Panel pnlEquipmentType;
private System.Windows.Forms.GroupBox grpMaintenanceEvents;
private System.Windows.Forms.ListView lvMaintenanceEvents;
private System.Windows.Forms.Label lblEquipmentHeader;
private System.Windows.Forms.TabPage pageEquipment;
private System.Windows.Forms.TabPage pageMaintenance;
private System.Windows.Forms.TabControl tabEquipment;
private System.Windows.Forms.TextBox txtPendingIssues;
private System.Windows.Forms.Label lblPendingIssues;
private System.Windows.Forms.Label lblResults;
private System.Windows.Forms.GroupBox grpNewEvent;
private System.Windows.Forms.Button btnClear;
private EXT.DOMAIN.vbecs.GUI.controls.VbecsButton btnAdd;
private System.Windows.Forms.GroupBox grpEquipment;
private System.Windows.Forms.TextBox txtContractNumber;
private System.Windows.Forms.Label lblContractNumber;
private System.Windows.Forms.Label lblDateReceived;
private System.Windows.Forms.GroupBox grpManufacturer;
private System.Windows.Forms.DateTimePicker dtpMaintenanceDate;
private System.Windows.Forms.Label lblMaintenanceType;
private System.Windows.Forms.Label lblMaintenanceDate;
private System.Windows.Forms.TextBox txtResults;
private System.Windows.Forms.TextBox txtEquipmentName;
private System.Windows.Forms.Label lblEquipmentName;
private System.Windows.Forms.Label lblEquipmentType;
private System.Windows.Forms.GroupBox grpInstallation;
private System.Windows.Forms.CheckBox cbExpirationDate;
private System.Windows.Forms.DateTimePicker dtpExpirationDate;
private System.Windows.Forms.DateTimePicker dtpDateReceived;
private System.Windows.Forms.Label lblZip;
private System.Windows.Forms.Label lblPhone;
private EXT.DOMAIN.vbecs.GUI.controls.MaskedTextBox mtxtPhone;
private EXT.DOMAIN.vbecs.GUI.controls.MaskedTextBox mtxtZip;
private EXT.DOMAIN.vbecs.GUI.controls.ComboBoxLookup cmbState;
private System.Windows.Forms.Label lblState;
private System.Windows.Forms.Label lblCity;
private System.Windows.Forms.TextBox txtCity;
private System.Windows.Forms.Label lblAddress;
private System.Windows.Forms.TextBox txtAddressLine1;
private System.Windows.Forms.Label lblManufacturerName;
private System.Windows.Forms.GroupBox grpScheduledEvent;
private System.Windows.Forms.Button btnPrint;
private System.Windows.Forms.Label lblScheduledEvent;
private System.Windows.Forms.CheckBox cbOutOfService;
private System.Windows.Forms.TextBox txtScheduledEvent;
private System.Windows.Forms.CheckBox cbIncludeOutOfService;
private System.Windows.Forms.TextBox txtIDSearch;
private System.Windows.Forms.Label lblEquipID;
private System.Windows.Forms.ColumnHeader columnHeader4;
private System.Windows.Forms.TextBox txtEquipmentType;
private System.Windows.Forms.TextBox txtSerialNumber;
private System.Windows.Forms.Label lblSerialNumber;
private System.Windows.Forms.TextBox txtEquipmentID;
private System.Windows.Forms.Label lblEquipmentID;
private System.Windows.Forms.TextBox txtAddressLine2;
private System.ComponentModel.IContainer components = null;
private EXT.DOMAIN.vbecs.GUI.controls.ComboBoxLookup cmbManufacturerName;
#endregion
private BOL.Equipment _equipment;
private DataTable _maintenanceEvents;
private System.Windows.Forms.PrintDialog printDialog1;
private EXT.DOMAIN.vbecs.GUI.controls.ComboBoxLookup cmbMaintenanceType;
private BOL.EquipmentMaintenance _equipmentMaintenance;
private System.Windows.Forms.Button btnAddress;
private bool _closeAfterSave;
private System.Windows.Forms.Label label1;
private bool _isLoading = false;
#region Constructors/Dispose
/// <summary>
/// Constructor
/// </summary>
public FrmMaintainEquipment()
this.FormLockFunction = Common.LockFunctions.UC022MaintainBloodBankEquipment;
// This call is required by the Windows Form Designer.
InitializeComponent();
SetComponentProperties();
LoadEquipment(false);
_closeAfterSave = false;
/// <summary>
/// Constructor
/// </summary>
/// <param name="equipmentGuid"></param>
public FrmMaintainEquipment(Guid equipmentGuid)
this.FormLockFunction = Common.LockFunctions.UC022MaintainBloodBankEquipment;
// This call is required by the Windows Form Designer.
InitializeComponent();
SetComponentProperties();
LoadEquipment(equipmentGuid);
_closeAfterSave = true;
//
//Remove highlighting
this.cmbManufacturerName.SelectionLength=0;
this.cmbState.SelectionLength=0;
this.cmbMaintenanceType.SelectionLength=0;
/// <summary>
/// Clean up any resources being used.
/// </summary>
protected override void Dispose( bool disposing )
if( disposing )
if (components != null) 
components.Dispose();
base.Dispose( disposing );
#endregion
#region Designer generated code
/// <summary>
/// Required method for Designer support - do not modify
/// the contents of this method with the code editor.
/// </summary>
private void InitializeComponent()
this.components = new System.ComponentModel.Container();
System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FrmMaintainEquipment));
this.btnCancel = new System.Windows.Forms.Button();
this.grpInventory = new System.Windows.Forms.GroupBox();
this.pnlContainer = new System.Windows.Forms.Panel();
this.pnlEquipmentType = new System.Windows.Forms.Panel();
this.tabEquipment = new System.Windows.Forms.TabControl();
this.pageEquipment = new System.Windows.Forms.TabPage();
this.grpInstallation = new System.Windows.Forms.GroupBox();
this.cbExpirationDate = new System.Windows.Forms.CheckBox();
this.dtpExpirationDate = new System.Windows.Forms.DateTimePicker();
this.txtContractNumber = new System.Windows.Forms.TextBox();
this.lblContractNumber = new System.Windows.Forms.Label();
this.dtpDateReceived = new System.Windows.Forms.DateTimePicker();
this.lblDateReceived = new System.Windows.Forms.Label();
this.grpEquipment = new System.Windows.Forms.GroupBox();
this.txtEquipmentID = new System.Windows.Forms.TextBox();
this.lblEquipmentID = new System.Windows.Forms.Label();
this.txtEquipmentType = new System.Windows.Forms.TextBox();
this.txtSerialNumber = new System.Windows.Forms.TextBox();
this.lblSerialNumber = new System.Windows.Forms.Label();
this.txtEquipmentName = new System.Windows.Forms.TextBox();
this.lblEquipmentName = new System.Windows.Forms.Label();
this.lblEquipmentType = new System.Windows.Forms.Label();
this.grpManufacturer = new System.Windows.Forms.GroupBox();
this.label1 = new System.Windows.Forms.Label();
this.btnAddress = new System.Windows.Forms.Button();
this.cmbManufacturerName = new EXT.DOMAIN.vbecs.GUI.controls.ComboBoxLookup(this.components);
this.txtAddressLine2 = new System.Windows.Forms.TextBox();
this.lblPhone = new System.Windows.Forms.Label();
this.mtxtPhone = new EXT.DOMAIN.vbecs.GUI.controls.MaskedTextBox();
this.mtxtZip = new EXT.DOMAIN.vbecs.GUI.controls.MaskedTextBox();
this.cmbState = new EXT.DOMAIN.vbecs.GUI.controls.ComboBoxLookup(this.components);
this.lblState = new System.Windows.Forms.Label();
this.lblCity = new System.Windows.Forms.Label();
this.txtCity = new System.Windows.Forms.TextBox();
this.lblAddress = new System.Windows.Forms.Label();
this.txtAddressLine1 = new System.Windows.Forms.TextBox();
this.lblManufacturerName = new System.Windows.Forms.Label();
this.lblZip = new System.Windows.Forms.Label();
this.pageMaintenance = new System.Windows.Forms.TabPage();
this.grpMaintenanceEvents = new System.Windows.Forms.GroupBox();
this.lvMaintenanceEvents = new System.Windows.Forms.ListView();
this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
this.grpNewEvent = new System.Windows.Forms.GroupBox();
this.cmbMaintenanceType = new EXT.DOMAIN.vbecs.GUI.controls.ComboBoxLookup(this.components);
this.btnClear = new System.Windows.Forms.Button();
this.btnAdd = new EXT.DOMAIN.vbecs.GUI.controls.VbecsButton();
this.txtResults = new System.Windows.Forms.TextBox();
this.lblResults = new System.Windows.Forms.Label();
this.dtpMaintenanceDate = new System.Windows.Forms.DateTimePicker();
this.lblMaintenanceType = new System.Windows.Forms.Label();
this.lblMaintenanceDate = new System.Windows.Forms.Label();
this.txtPendingIssues = new System.Windows.Forms.TextBox();
this.lblPendingIssues = new System.Windows.Forms.Label();
this.grpScheduledEvent = new System.Windows.Forms.GroupBox();
this.txtScheduledEvent = new System.Windows.Forms.TextBox();
this.lblScheduledEvent = new System.Windows.Forms.Label();
this.pnlEquipmentHeader = new System.Windows.Forms.Panel();
this.lblEquipmentHeader = new System.Windows.Forms.Label();
this.picFlask = new System.Windows.Forms.PictureBox();
this.btnOK = new EXT.DOMAIN.vbecs.GUI.controls.VbecsButton();
this.btnPrint = new System.Windows.Forms.Button();
this.cbOutOfService = new System.Windows.Forms.CheckBox();
this.splitter1 = new System.Windows.Forms.Splitter();
this.pnlTreeView = new System.Windows.Forms.Panel();
this.cbIncludeOutOfService = new System.Windows.Forms.CheckBox();
this.btnSearch = new System.Windows.Forms.Button();
this.txtIDSearch = new System.Windows.Forms.TextBox();
this.lblEquipID = new System.Windows.Forms.Label();
this.tvInventory = new System.Windows.Forms.TreeView();
this.imageList1 = new System.Windows.Forms.ImageList(this.components);
this.pnlTreeViewHeader = new System.Windows.Forms.Panel();
this.lblInventory = new System.Windows.Forms.Label();
this.picInventory = new System.Windows.Forms.PictureBox();
this.grpImage = new System.Windows.Forms.GroupBox();
this.picEquipment = new System.Windows.Forms.PictureBox();
this.printDialog1 = new System.Windows.Forms.PrintDialog();
this.grpInventory.SuspendLayout();
this.pnlContainer.SuspendLayout();
this.pnlEquipmentType.SuspendLayout();
this.tabEquipment.SuspendLayout();
this.pageEquipment.SuspendLayout();
this.grpInstallation.SuspendLayout();
this.grpEquipment.SuspendLayout();
this.grpManufacturer.SuspendLayout();
this.pageMaintenance.SuspendLayout();
this.grpMaintenanceEvents.SuspendLayout();
this.grpNewEvent.SuspendLayout();
this.grpScheduledEvent.SuspendLayout();
this.pnlEquipmentHeader.SuspendLayout();
this.pnlTreeView.SuspendLayout();
this.pnlTreeViewHeader.SuspendLayout();
this.grpImage.SuspendLayout();
this.SuspendLayout();
// 
// vbecsLogo1
// 
this.vbecsLogo1.Name = "vbecsLogo1";
this.vbecsLogo1.Size = new System.Drawing.Size(692, 30);
this.vbecsLogo1.Title = "Maintain Equipment";
// 
// lblRequiredField
// 
this.lblRequiredField.Location = new System.Drawing.Point(0, 507);
this.lblRequiredField.Name = "lblRequiredField";
this.lblRequiredField.TabIndex = 4;
// 
// btnCancel
// 
this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
this.btnCancel.CausesValidation = false;
this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
this.btnCancel.Location = new System.Drawing.Point(610, 492);
this.btnCancel.Name = "btnCancel";
this.btnCancel.TabIndex = 1;
this.btnCancel.Text = "&Cancel";
this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
// 
// grpInventory
// 
this.grpInventory.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.grpInventory.Controls.Add(this.pnlContainer);
this.grpInventory.Location = new System.Drawing.Point(60, 32);
this.grpInventory.Name = "grpInventory";
this.grpInventory.Size = new System.Drawing.Size(626, 456);
this.grpInventory.TabIndex = 0;
this.grpInventory.TabStop = false;
// 
// pnlContainer
// 
this.pnlContainer.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.pnlContainer.Controls.Add(this.pnlEquipmentType);
this.pnlContainer.Controls.Add(this.splitter1);
this.pnlContainer.Controls.Add(this.pnlTreeView);
this.pnlContainer.Location = new System.Drawing.Point(8, 12);
this.pnlContainer.Name = "pnlContainer";
this.pnlContainer.Size = new System.Drawing.Size(610, 436);
this.pnlContainer.TabIndex = 0;
// 
// pnlEquipmentType
// 
this.pnlEquipmentType.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
this.pnlEquipmentType.Controls.Add(this.tabEquipment);
this.pnlEquipmentType.Controls.Add(this.pnlEquipmentHeader);
this.pnlEquipmentType.Controls.Add(this.btnOK);
this.pnlEquipmentType.Controls.Add(this.btnPrint);
this.pnlEquipmentType.Controls.Add(this.cbOutOfService);
this.pnlEquipmentType.Dock = System.Windows.Forms.DockStyle.Fill;
this.pnlEquipmentType.Location = new System.Drawing.Point(191, 0);
this.pnlEquipmentType.Name = "pnlEquipmentType";
this.pnlEquipmentType.Size = new System.Drawing.Size(419, 436);
this.pnlEquipmentType.TabIndex = 2;
// 
// tabEquipment
// 
this.tabEquipment.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.tabEquipment.Controls.Add(this.pageEquipment);
this.tabEquipment.Controls.Add(this.pageMaintenance);
this.tabEquipment.Location = new System.Drawing.Point(4, 28);
this.tabEquipment.Name = "tabEquipment";
this.tabEquipment.SelectedIndex = 0;
this.tabEquipment.Size = new System.Drawing.Size(408, 376);
this.tabEquipment.TabIndex = 0;
// 
// pageEquipment
// 
this.pageEquipment.Controls.Add(this.grpInstallation);
this.pageEquipment.Controls.Add(this.grpEquipment);
this.pageEquipment.Controls.Add(this.grpManufacturer);
this.pageEquipment.Location = new System.Drawing.Point(4, 23);
this.pageEquipment.Name = "pageEquipment";
this.pageEquipment.Size = new System.Drawing.Size(400, 349);
this.pageEquipment.TabIndex = 0;
this.pageEquipment.Text = "Equipment";
// 
// grpInstallation
// 
this.grpInstallation.AccessibleDescription = "Installation Information";
this.grpInstallation.AccessibleName = "Installation Information";
this.grpInstallation.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.grpInstallation.Controls.Add(this.cbExpirationDate);
this.grpInstallation.Controls.Add(this.dtpExpirationDate);
this.grpInstallation.Controls.Add(this.txtContractNumber);
this.grpInstallation.Controls.Add(this.lblContractNumber);
this.grpInstallation.Controls.Add(this.dtpDateReceived);
this.grpInstallation.Controls.Add(this.lblDateReceived);
this.grpInstallation.Location = new System.Drawing.Point(4, 260);
this.grpInstallation.Name = "grpInstallation";
this.grpInstallation.Size = new System.Drawing.Size(392, 88);
this.grpInstallation.TabIndex = 2;
this.grpInstallation.TabStop = false;
this.grpInstallation.Text = "Installation Info";
// 
// cbExpirationDate
// 
this.cbExpirationDate.AccessibleDescription = "Expiration Renewal Date";
this.cbExpirationDate.AccessibleName = "Expiration Renewal Date";
this.cbExpirationDate.Location = new System.Drawing.Point(8, 64);
this.cbExpirationDate.Name = "cbExpirationDate";
this.cbExpirationDate.Size = new System.Drawing.Size(160, 20);
this.cbExpirationDate.TabIndex = 4;
this.cbExpirationDate.Text = "E&xpiration/Renewal Date";
this.cbExpirationDate.CheckedChanged += new System.EventHandler(this.ExpirationCheckChanged);
// 
// dtpExpirationDate
// 
this.dtpExpirationDate.AccessibleDescription = "Expiration Renewal Date";
this.dtpExpirationDate.AccessibleName = "Expiration Renewal Date";
this.dtpExpirationDate.CustomFormat = "MM/dd/yyyy HH:mm";
this.dtpExpirationDate.Enabled = false;
this.dtpExpirationDate.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
this.dtpExpirationDate.Location = new System.Drawing.Point(168, 64);
this.dtpExpirationDate.Name = "dtpExpirationDate";
this.dtpExpirationDate.Size = new System.Drawing.Size(112, 20);
this.dtpExpirationDate.TabIndex = 2;
this.dtpExpirationDate.CloseUp += new System.EventHandler(this.dtpExpirationDate_ValueChanged);
this.dtpExpirationDate.ValueChanged += new System.EventHandler(this.dtpExpirationDate_ValueChanged);
// 
// txtContractNumber
// 
this.txtContractNumber.AccessibleDescription = "Warranty Service Contract Number";
this.txtContractNumber.AccessibleName = "Warranty Service Contract Number";
this.txtContractNumber.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtContractNumber.Location = new System.Drawing.Point(168, 40);
this.txtContractNumber.MaxLength = 25;
this.txtContractNumber.Name = "txtContractNumber";
this.txtContractNumber.Size = new System.Drawing.Size(196, 20);
this.txtContractNumber.TabIndex = 1;
this.txtContractNumber.Text = "";
this.txtContractNumber.TextChanged += new System.EventHandler(this.txtContractNumber_TextChanged);
// 
// lblContractNumber
// 
this.lblContractNumber.Location = new System.Drawing.Point(8, 40);
this.lblContractNumber.Name = "lblContractNumber";
this.lblContractNumber.Size = new System.Drawing.Size(160, 20);
this.lblContractNumber.TabIndex = 2;
this.lblContractNumber.Text = "Warranty/Service Contract No.";
this.lblContractNumber.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// dtpDateReceived
// 
this.dtpDateReceived.AccessibleDescription = "Date Received Installed";
this.dtpDateReceived.AccessibleName = "Date Received Installed";
this.dtpDateReceived.CustomFormat = "MM/dd/yyyy HH:mm";
this.dtpDateReceived.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
this.dtpDateReceived.Location = new System.Drawing.Point(168, 16);
this.dtpDateReceived.Name = "dtpDateReceived";
this.dtpDateReceived.Size = new System.Drawing.Size(112, 20);
this.dtpDateReceived.TabIndex = 0;
this.dtpDateReceived.ValueChanged += new System.EventHandler(this.dtpDateReceived_ValueChanged);
// 
// lblDateReceived
// 
this.lblDateReceived.Location = new System.Drawing.Point(8, 16);
this.lblDateReceived.Name = "lblDateReceived";
this.lblDateReceived.Size = new System.Drawing.Size(152, 20);
this.lblDateReceived.TabIndex = 0;
this.lblDateReceived.Text = "Date Received/Installed*";
this.lblDateReceived.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// grpEquipment
// 
this.grpEquipment.AccessibleDescription = "Equipment Information";
this.grpEquipment.AccessibleName = "Equipment Information";
this.grpEquipment.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.grpEquipment.Controls.Add(this.txtEquipmentID);
this.grpEquipment.Controls.Add(this.lblEquipmentID);
this.grpEquipment.Controls.Add(this.txtEquipmentType);
this.grpEquipment.Controls.Add(this.txtSerialNumber);
this.grpEquipment.Controls.Add(this.lblSerialNumber);
this.grpEquipment.Controls.Add(this.txtEquipmentName);
this.grpEquipment.Controls.Add(this.lblEquipmentName);
this.grpEquipment.Controls.Add(this.lblEquipmentType);
this.grpEquipment.Location = new System.Drawing.Point(4, 4);
this.grpEquipment.Name = "grpEquipment";
this.grpEquipment.Size = new System.Drawing.Size(392, 116);
this.grpEquipment.TabIndex = 0;
this.grpEquipment.TabStop = false;
this.grpEquipment.Text = "Equipment Info";
// 
// txtEquipmentID
// 
this.txtEquipmentID.AccessibleDescription = "Local Equipment I D ";
this.txtEquipmentID.AccessibleName = "Local Equipment I D ";
this.txtEquipmentID.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtEquipmentID.Location = new System.Drawing.Point(112, 88);
this.txtEquipmentID.MaxLength = 25;
this.txtEquipmentID.Name = "txtEquipmentID";
this.txtEquipmentID.Size = new System.Drawing.Size(268, 20);
this.txtEquipmentID.TabIndex = 3;
this.txtEquipmentID.Text = "";
this.txtEquipmentID.TextChanged += new System.EventHandler(this.txtEquipmentID_TextChanged);
// 
// lblEquipmentID
// 
this.lblEquipmentID.Location = new System.Drawing.Point(8, 88);
this.lblEquipmentID.Name = "lblEquipmentID";
this.lblEquipmentID.Size = new System.Drawing.Size(132, 20);
this.lblEquipmentID.TabIndex = 6;
this.lblEquipmentID.Text = "Local Equipment ID";
this.lblEquipmentID.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// txtEquipmentType
// 
this.txtEquipmentType.AccessibleDescription = "Equipment Type";
this.txtEquipmentType.AccessibleName = "Equipment Type";
this.txtEquipmentType.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtEquipmentType.Location = new System.Drawing.Point(112, 16);
this.txtEquipmentType.Name = "txtEquipmentType";
this.txtEquipmentType.ReadOnly = true;
this.txtEquipmentType.Size = new System.Drawing.Size(268, 20);
this.txtEquipmentType.TabIndex = 0;
this.txtEquipmentType.Text = "";
// 
// txtSerialNumber
// 
this.txtSerialNumber.AccessibleDescription = "Serial Number";
this.txtSerialNumber.AccessibleName = "Serial Number";
this.txtSerialNumber.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtSerialNumber.Location = new System.Drawing.Point(112, 64);
this.txtSerialNumber.MaxLength = 50;
this.txtSerialNumber.Name = "txtSerialNumber";
this.txtSerialNumber.Size = new System.Drawing.Size(268, 20);
this.txtSerialNumber.TabIndex = 2;
this.txtSerialNumber.Text = "";
this.txtSerialNumber.TextChanged += new System.EventHandler(this.txtSerialNumber_TextChanged);
// 
// lblSerialNumber
// 
this.lblSerialNumber.Location = new System.Drawing.Point(8, 64);
this.lblSerialNumber.Name = "lblSerialNumber";
this.lblSerialNumber.Size = new System.Drawing.Size(132, 20);
this.lblSerialNumber.TabIndex = 4;
this.lblSerialNumber.Text = "Serial No.*";
this.lblSerialNumber.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// txtEquipmentName
// 
this.txtEquipmentName.AccessibleDescription = "Equipment Name";
this.txtEquipmentName.AccessibleName = "Equipment Name";
this.txtEquipmentName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtEquipmentName.Location = new System.Drawing.Point(112, 40);
this.txtEquipmentName.Name = "txtEquipmentName";
this.txtEquipmentName.ReadOnly = true;
this.txtEquipmentName.Size = new System.Drawing.Size(268, 20);
this.txtEquipmentName.TabIndex = 1;
this.txtEquipmentName.Text = "";
// 
// lblEquipmentName
// 
this.lblEquipmentName.Location = new System.Drawing.Point(8, 40);
this.lblEquipmentName.Name = "lblEquipmentName";
this.lblEquipmentName.Size = new System.Drawing.Size(108, 20);
this.lblEquipmentName.TabIndex = 2;
this.lblEquipmentName.Text = "Equipment Name";
this.lblEquipmentName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// lblEquipmentType
// 
this.lblEquipmentType.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
this.lblEquipmentType.Location = new System.Drawing.Point(8, 16);
this.lblEquipmentType.Name = "lblEquipmentType";
this.lblEquipmentType.Size = new System.Drawing.Size(108, 20);
this.lblEquipmentType.TabIndex = 0;
this.lblEquipmentType.Text = "Equipment Type";
this.lblEquipmentType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// grpManufacturer
// 
this.grpManufacturer.AccessibleDescription = "Manufacturer Information";
this.grpManufacturer.AccessibleName = "Manufacturer Information";
this.grpManufacturer.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.grpManufacturer.Controls.Add(this.label1);
this.grpManufacturer.Controls.Add(this.btnAddress);
this.grpManufacturer.Controls.Add(this.cmbManufacturerName);
this.grpManufacturer.Controls.Add(this.txtAddressLine2);
this.grpManufacturer.Controls.Add(this.lblPhone);
this.grpManufacturer.Controls.Add(this.mtxtPhone);
this.grpManufacturer.Controls.Add(this.mtxtZip);
this.grpManufacturer.Controls.Add(this.cmbState);
this.grpManufacturer.Controls.Add(this.lblState);
this.grpManufacturer.Controls.Add(this.lblCity);
this.grpManufacturer.Controls.Add(this.txtCity);
this.grpManufacturer.Controls.Add(this.lblAddress);
this.grpManufacturer.Controls.Add(this.txtAddressLine1);
this.grpManufacturer.Controls.Add(this.lblManufacturerName);
this.grpManufacturer.Controls.Add(this.lblZip);
this.grpManufacturer.Location = new System.Drawing.Point(4, 120);
this.grpManufacturer.Name = "grpManufacturer";
this.grpManufacturer.Size = new System.Drawing.Size(392, 140);
this.grpManufacturer.TabIndex = 1;
this.grpManufacturer.TabStop = false;
this.grpManufacturer.Text = "Manufacturer Info";
// 
// label1
// 
this.label1.Location = new System.Drawing.Point(8, 64);
this.label1.Name = "label1";
this.label1.Size = new System.Drawing.Size(96, 20);
this.label1.TabIndex = 13;
this.label1.Text = "Address Line 2";
this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// btnAddress
// 
this.btnAddress.AccessibleDescription = "find";
this.btnAddress.AccessibleName = "find";
this.btnAddress.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
this.btnAddress.Enabled = false;
this.btnAddress.Font = new System.Drawing.Font("Arial", 5.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
this.btnAddress.Location = new System.Drawing.Point(358, 40);
this.btnAddress.Name = "btnAddress";
this.btnAddress.Size = new System.Drawing.Size(26, 22);
this.btnAddress.TabIndex = 2;
this.btnAddress.Text = "find";
this.btnAddress.Click += new System.EventHandler(this.btnAddress_Click);
// 
// cmbManufacturerName
// 
this.cmbManufacturerName.AccessibleDescription = "Manufacturer Name";
this.cmbManufacturerName.AccessibleName = "Manufacturer Name";
this.cmbManufacturerName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.cmbManufacturerName.Interval = 500;
this.cmbManufacturerName.Location = new System.Drawing.Point(112, 16);
this.cmbManufacturerName.LookupEnabled = false;
this.cmbManufacturerName.MaxLength = 50;
this.cmbManufacturerName.Name = "cmbManufacturerName";
this.cmbManufacturerName.Size = new System.Drawing.Size(268, 22);
this.cmbManufacturerName.TabIndex = 0;
this.cmbManufacturerName.TextChanged += new System.EventHandler(this.txtManufacturerName_TextChanged);
// 
// txtAddressLine2
// 
this.txtAddressLine2.AccessibleDescription = "Address line 2";
this.txtAddressLine2.AccessibleName = "Address line 2";
this.txtAddressLine2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtAddressLine2.Location = new System.Drawing.Point(112, 64);
this.txtAddressLine2.MaxLength = 255;
this.txtAddressLine2.Name = "txtAddressLine2";
this.txtAddressLine2.Size = new System.Drawing.Size(268, 20);
this.txtAddressLine2.TabIndex = 3;
this.txtAddressLine2.Text = "";
this.txtAddressLine2.TextChanged += new System.EventHandler(this.txtAddressLine2_TextChanged);
// 
// lblPhone
// 
this.lblPhone.Image = ((System.Drawing.Image)(resources.GetObject("lblPhone.Image")));
this.lblPhone.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
this.lblPhone.Location = new System.Drawing.Point(8, 112);
this.lblPhone.Name = "lblPhone";
this.lblPhone.Size = new System.Drawing.Size(104, 20);
this.lblPhone.TabIndex = 12;
this.lblPhone.Text = "Phone";
this.lblPhone.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// mtxtPhone
// 
this.mtxtPhone.AccessibleDescription = "Phone";
this.mtxtPhone.AccessibleName = "Phone";
this.mtxtPhone.ErrorMsg = "The phone number you have entered is invalid.";
this.mtxtPhone.Location = new System.Drawing.Point(104, 112);
this.mtxtPhone.Mask = "(###) ###-####";
this.mtxtPhone.Name = "mtxtPhone";
this.mtxtPhone.Size = new System.Drawing.Size(104, 24);
this.mtxtPhone.TabIndex = 7;
this.mtxtPhone.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.KeyPressCheckDigit);
this.mtxtPhone.MaskedTextValidated += new System.EventHandler(this.ValidPhoneNumber);
this.mtxtPhone.MaskedTextInvalidated += new System.EventHandler(this.InvalidPhoneNumber);
// 
// mtxtZip
// 
this.mtxtZip.AccessibleDescription = "Zip ";
this.mtxtZip.AccessibleName = "Zip ";
this.mtxtZip.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
this.mtxtZip.ErrorMsg = null;
this.mtxtZip.Location = new System.Drawing.Point(308, 88);
this.mtxtZip.Mask = "#####-####";
this.mtxtZip.Name = "mtxtZip";
this.mtxtZip.Size = new System.Drawing.Size(80, 24);
this.mtxtZip.TabIndex = 6;
this.mtxtZip.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.KeyPressCheckDigit);
this.mtxtZip.MaskedTextValidated += new System.EventHandler(this.ValidZipCode);
this.mtxtZip.MaskedTextInvalidated += new System.EventHandler(this.InvalidZipCode);
// 
// cmbState
// 
this.cmbState.AccessibleDescription = "State";
this.cmbState.AccessibleName = "State";
this.cmbState.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
this.cmbState.Interval = 500;
this.cmbState.Location = new System.Drawing.Point(232, 88);
this.cmbState.MaxLength = 2;
this.cmbState.Name = "cmbState";
this.cmbState.Size = new System.Drawing.Size(60, 22);
this.cmbState.TabIndex = 5;
this.cmbState.Leave += new System.EventHandler(this.cmbState_Leave);
this.cmbState.SelectedIndexChanged += new System.EventHandler(this.cmbState_SelectedIndexChanged);
// 
// lblState
// 
this.lblState.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
this.lblState.Location = new System.Drawing.Point(204, 88);
this.lblState.Name = "lblState";
this.lblState.Size = new System.Drawing.Size(36, 20);
this.lblState.TabIndex = 8;
this.lblState.Text = "State";
this.lblState.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// lblCity
// 
this.lblCity.Location = new System.Drawing.Point(8, 88);
this.lblCity.Name = "lblCity";
this.lblCity.Size = new System.Drawing.Size(96, 20);
this.lblCity.TabIndex = 6;
this.lblCity.Text = "City";
this.lblCity.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// txtCity
// 
this.txtCity.AccessibleDescription = "City";
this.txtCity.AccessibleName = "City";
this.txtCity.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtCity.Location = new System.Drawing.Point(112, 88);
this.txtCity.MaxLength = 55;
this.txtCity.Name = "txtCity";
this.txtCity.Size = new System.Drawing.Size(88, 20);
this.txtCity.TabIndex = 4;
this.txtCity.Text = "";
this.txtCity.TextChanged += new System.EventHandler(this.txtCity_TextChanged);
// 
// lblAddress
// 
this.lblAddress.Location = new System.Drawing.Point(8, 40);
this.lblAddress.Name = "lblAddress";
this.lblAddress.Size = new System.Drawing.Size(96, 20);
this.lblAddress.TabIndex = 2;
this.lblAddress.Text = "Address Line 1";
this.lblAddress.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// txtAddressLine1
// 
this.txtAddressLine1.AccessibleDescription = "Address Line 1";
this.txtAddressLine1.AccessibleName = "Address Line 1";
this.txtAddressLine1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtAddressLine1.Location = new System.Drawing.Point(112, 40);
this.txtAddressLine1.MaxLength = 255;
this.txtAddressLine1.Name = "txtAddressLine1";
this.txtAddressLine1.Size = new System.Drawing.Size(246, 20);
this.txtAddressLine1.TabIndex = 1;
this.txtAddressLine1.Text = "";
this.txtAddressLine1.TextChanged += new System.EventHandler(this.txtAddressLine1_TextChanged);
// 
// lblManufacturerName
// 
this.lblManufacturerName.Location = new System.Drawing.Point(8, 16);
this.lblManufacturerName.Name = "lblManufacturerName";
this.lblManufacturerName.Size = new System.Drawing.Size(112, 20);
this.lblManufacturerName.TabIndex = 0;
this.lblManufacturerName.Text = "Manufacturer Name*";
this.lblManufacturerName.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// lblZip
// 
this.lblZip.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
this.lblZip.Location = new System.Drawing.Point(292, 88);
this.lblZip.Name = "lblZip";
this.lblZip.Size = new System.Drawing.Size(28, 20);
this.lblZip.TabIndex = 10;
this.lblZip.Text = "Zip";
this.lblZip.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// pageMaintenance
// 
this.pageMaintenance.Controls.Add(this.grpMaintenanceEvents);
this.pageMaintenance.Controls.Add(this.grpNewEvent);
this.pageMaintenance.Controls.Add(this.grpScheduledEvent);
this.pageMaintenance.Location = new System.Drawing.Point(4, 23);
this.pageMaintenance.Name = "pageMaintenance";
this.pageMaintenance.Size = new System.Drawing.Size(400, 349);
this.pageMaintenance.TabIndex = 2;
this.pageMaintenance.Text = "Maintenance";
// 
// grpMaintenanceEvents
// 
this.grpMaintenanceEvents.AccessibleDescription = "Maintenance Events";
this.grpMaintenanceEvents.AccessibleName = "Maintenance Events";
this.grpMaintenanceEvents.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.grpMaintenanceEvents.Controls.Add(this.lvMaintenanceEvents);
this.grpMaintenanceEvents.Location = new System.Drawing.Point(4, 176);
this.grpMaintenanceEvents.Name = "grpMaintenanceEvents";
this.grpMaintenanceEvents.Size = new System.Drawing.Size(392, 120);
this.grpMaintenanceEvents.TabIndex = 1;
this.grpMaintenanceEvents.TabStop = false;
this.grpMaintenanceEvents.Text = "Maintenance Events";
// 
// lvMaintenanceEvents
// 
this.lvMaintenanceEvents.AccessibleDescription = "Maintenance Events";
this.lvMaintenanceEvents.AccessibleName = "Maintenance Events";
this.lvMaintenanceEvents.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.lvMaintenanceEvents.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
  this.columnHeader2,
  this.columnHeader1,
  this.columnHeader3,
  this.columnHeader4});
this.lvMaintenanceEvents.FullRowSelect = true;
this.lvMaintenanceEvents.HideSelection = false;
this.lvMaintenanceEvents.Location = new System.Drawing.Point(8, 16);
this.lvMaintenanceEvents.MultiSelect = false;
this.lvMaintenanceEvents.Name = "lvMaintenanceEvents";
this.lvMaintenanceEvents.Size = new System.Drawing.Size(376, 96);
this.lvMaintenanceEvents.TabIndex = 0;
this.lvMaintenanceEvents.View = System.Windows.Forms.View.Details;
this.lvMaintenanceEvents.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.lvMaintenanceEvents_ColumnClick);
this.lvMaintenanceEvents.SelectedIndexChanged += new System.EventHandler(this.lvMaintenanceEvents_SelectedIndexChanged);
// 
// columnHeader2
// 
this.columnHeader2.Text = "Date";
this.columnHeader2.Width = 85;
// 
// columnHeader1
// 
this.columnHeader1.Text = "Type";
this.columnHeader1.Width = 85;
// 
// columnHeader3
// 
this.columnHeader3.Text = "Results";
this.columnHeader3.Width = 105;
// 
// columnHeader4
// 
this.columnHeader4.Text = "Pending Issues";
this.columnHeader4.Width = 85;
// 
// grpNewEvent
// 
this.grpNewEvent.AccessibleDescription = "New Maintenance Event";
this.grpNewEvent.AccessibleName = "New Maintenance Event";
this.grpNewEvent.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.grpNewEvent.Controls.Add(this.cmbMaintenanceType);
this.grpNewEvent.Controls.Add(this.btnClear);
this.grpNewEvent.Controls.Add(this.btnAdd);
this.grpNewEvent.Controls.Add(this.txtResults);
this.grpNewEvent.Controls.Add(this.lblResults);
this.grpNewEvent.Controls.Add(this.dtpMaintenanceDate);
this.grpNewEvent.Controls.Add(this.lblMaintenanceType);
this.grpNewEvent.Controls.Add(this.lblMaintenanceDate);
this.grpNewEvent.Controls.Add(this.txtPendingIssues);
this.grpNewEvent.Controls.Add(this.lblPendingIssues);
this.grpNewEvent.Location = new System.Drawing.Point(4, 4);
this.grpNewEvent.Name = "grpNewEvent";
this.grpNewEvent.Size = new System.Drawing.Size(392, 172);
this.grpNewEvent.TabIndex = 0;
this.grpNewEvent.TabStop = false;
this.grpNewEvent.Text = "New Maintenance Event";
// 
// cmbMaintenanceType
// 
this.cmbMaintenanceType.AccessibleDescription = "Maintenance Type";
this.cmbMaintenanceType.AccessibleName = "Maintenance Type";
this.cmbMaintenanceType.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.cmbMaintenanceType.Interval = 500;
this.cmbMaintenanceType.Location = new System.Drawing.Point(132, 16);
this.cmbMaintenanceType.LookupEnabled = false;
this.cmbMaintenanceType.MaxLength = 50;
this.cmbMaintenanceType.Name = "cmbMaintenanceType";
this.cmbMaintenanceType.Size = new System.Drawing.Size(252, 22);
this.cmbMaintenanceType.TabIndex = 0;
this.cmbMaintenanceType.TextChanged += new System.EventHandler(this.txtMaintenanceType_TextChanged);
// 
// btnClear
// 
this.btnClear.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
this.btnClear.CausesValidation = false;
this.btnClear.Location = new System.Drawing.Point(308, 144);
this.btnClear.Name = "btnClear";
this.btnClear.TabIndex = 5;
this.btnClear.Text = "C&lear";
this.btnClear.Click += new System.EventHandler(this.btnClear_Click);
// 
// btnAdd
// 
this.btnAdd.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
this.btnAdd.EnabledButton = false;
this.btnAdd.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
this.btnAdd.Image = ((System.Drawing.Image)(resources.GetObject("btnAdd.Image")));
this.btnAdd.Location = new System.Drawing.Point(228, 144);
this.btnAdd.Name = "btnAdd";
this.btnAdd.Size = new System.Drawing.Size(75, 23);
this.btnAdd.TabIndex = 4;
this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
this.btnAdd.MouseHover += new System.EventHandler(this.btnAdd_MouseHover);
// 
// txtResults
// 
this.txtResults.AcceptsReturn = true;
this.txtResults.AccessibleDescription = "Maintenance Results";
this.txtResults.AccessibleName = "Maintenance Results";
this.txtResults.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtResults.Location = new System.Drawing.Point(132, 64);
this.txtResults.MaxLength = 255;
this.txtResults.Multiline = true;
this.txtResults.Name = "txtResults";
this.txtResults.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
this.txtResults.Size = new System.Drawing.Size(252, 36);
this.txtResults.TabIndex = 2;
this.txtResults.Text = "";
this.txtResults.TextChanged += new System.EventHandler(this.txtResults_TextChanged);
// 
// lblResults
// 
this.lblResults.Location = new System.Drawing.Point(8, 64);
this.lblResults.Name = "lblResults";
this.lblResults.Size = new System.Drawing.Size(140, 20);
this.lblResults.TabIndex = 4;
this.lblResults.Text = "Maintenance Results*";
this.lblResults.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// dtpMaintenanceDate
// 
this.dtpMaintenanceDate.AccessibleDescription = "Maintenance Date";
this.dtpMaintenanceDate.AccessibleName = "Maintenance Date";
this.dtpMaintenanceDate.CustomFormat = "MM/dd/yyyy HH:mm";
this.dtpMaintenanceDate.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
this.dtpMaintenanceDate.Location = new System.Drawing.Point(132, 40);
this.dtpMaintenanceDate.Name = "dtpMaintenanceDate";
this.dtpMaintenanceDate.Size = new System.Drawing.Size(116, 20);
this.dtpMaintenanceDate.TabIndex = 1;
this.dtpMaintenanceDate.ValueChanged += new System.EventHandler(this.dtpMaintenanceDate_ValueChanged);
// 
// lblMaintenanceType
// 
this.lblMaintenanceType.Location = new System.Drawing.Point(8, 16);
this.lblMaintenanceType.Name = "lblMaintenanceType";
this.lblMaintenanceType.Size = new System.Drawing.Size(140, 20);
this.lblMaintenanceType.TabIndex = 0;
this.lblMaintenanceType.Text = "Maintenance Type*";
this.lblMaintenanceType.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// lblMaintenanceDate
// 
this.lblMaintenanceDate.Location = new System.Drawing.Point(8, 40);
this.lblMaintenanceDate.Name = "lblMaintenanceDate";
this.lblMaintenanceDate.Size = new System.Drawing.Size(140, 20);
this.lblMaintenanceDate.TabIndex = 2;
this.lblMaintenanceDate.Text = "Maintenance Date*";
this.lblMaintenanceDate.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// txtPendingIssues
// 
this.txtPendingIssues.AcceptsReturn = true;
this.txtPendingIssues.AccessibleDescription = "Pending Issues";
this.txtPendingIssues.AccessibleName = "Pending Issues";
this.txtPendingIssues.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtPendingIssues.Location = new System.Drawing.Point(132, 104);
this.txtPendingIssues.MaxLength = 255;
this.txtPendingIssues.Multiline = true;
this.txtPendingIssues.Name = "txtPendingIssues";
this.txtPendingIssues.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
this.txtPendingIssues.Size = new System.Drawing.Size(252, 36);
this.txtPendingIssues.TabIndex = 3;
this.txtPendingIssues.Text = "";
this.txtPendingIssues.TextChanged += new System.EventHandler(this.txtPendingIssues_TextChanged);
// 
// lblPendingIssues
// 
this.lblPendingIssues.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
this.lblPendingIssues.Location = new System.Drawing.Point(8, 104);
this.lblPendingIssues.Name = "lblPendingIssues";
this.lblPendingIssues.Size = new System.Drawing.Size(120, 20);
this.lblPendingIssues.TabIndex = 6;
this.lblPendingIssues.Text = "Pending Issues";
this.lblPendingIssues.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// grpScheduledEvent
// 
this.grpScheduledEvent.AccessibleDescription = "Next Scheduled Maintenance Event";
this.grpScheduledEvent.AccessibleName = "Next Scheduled Maintenance Event";
this.grpScheduledEvent.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.grpScheduledEvent.Controls.Add(this.txtScheduledEvent);
this.grpScheduledEvent.Controls.Add(this.lblScheduledEvent);
this.grpScheduledEvent.Location = new System.Drawing.Point(4, 296);
this.grpScheduledEvent.Name = "grpScheduledEvent";
this.grpScheduledEvent.Size = new System.Drawing.Size(392, 52);
this.grpScheduledEvent.TabIndex = 2;
this.grpScheduledEvent.TabStop = false;
// 
// txtScheduledEvent
// 
this.txtScheduledEvent.AccessibleDescription = "Next Scheduled Maintenance Event";
this.txtScheduledEvent.AccessibleName = "Next Scheduled Maintenance Event";
this.txtScheduledEvent.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtScheduledEvent.Location = new System.Drawing.Point(8, 24);
this.txtScheduledEvent.MaxLength = 255;
this.txtScheduledEvent.Name = "txtScheduledEvent";
this.txtScheduledEvent.Size = new System.Drawing.Size(376, 20);
this.txtScheduledEvent.TabIndex = 1;
this.txtScheduledEvent.Text = "";
this.txtScheduledEvent.TextChanged += new System.EventHandler(this.txtScheduledEvent_TextChanged);
// 
// lblScheduledEvent
// 
this.lblScheduledEvent.Location = new System.Drawing.Point(8, 8);
this.lblScheduledEvent.Name = "lblScheduledEvent";
this.lblScheduledEvent.Size = new System.Drawing.Size(184, 20);
this.lblScheduledEvent.TabIndex = 0;
this.lblScheduledEvent.Text = "Next Scheduled Maintenance Event";
this.lblScheduledEvent.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// pnlEquipmentHeader
// 
this.pnlEquipmentHeader.BackColor = System.Drawing.SystemColors.ActiveCaption;
this.pnlEquipmentHeader.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
this.pnlEquipmentHeader.Controls.Add(this.lblEquipmentHeader);
this.pnlEquipmentHeader.Controls.Add(this.picFlask);
this.pnlEquipmentHeader.Dock = System.Windows.Forms.DockStyle.Top;
this.pnlEquipmentHeader.Location = new System.Drawing.Point(0, 0);
this.pnlEquipmentHeader.Name = "pnlEquipmentHeader";
this.pnlEquipmentHeader.Size = new System.Drawing.Size(417, 24);
this.pnlEquipmentHeader.TabIndex = 0;
// 
// lblEquipmentHeader
// 
this.lblEquipmentHeader.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
this.lblEquipmentHeader.Location = new System.Drawing.Point(24, 2);
this.lblEquipmentHeader.Name = "lblEquipmentHeader";
this.lblEquipmentHeader.Size = new System.Drawing.Size(124, 18);
this.lblEquipmentHeader.TabIndex = 0;
this.lblEquipmentHeader.Text = "Selected Equipment";
this.lblEquipmentHeader.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// picFlask
// 
this.picFlask.Image = ((System.Drawing.Image)(resources.GetObject("picFlask.Image")));
this.picFlask.Location = new System.Drawing.Point(4, 4);
this.picFlask.Name = "picFlask";
this.picFlask.Size = new System.Drawing.Size(16, 16);
this.picFlask.TabIndex = 0;
this.picFlask.TabStop = false;
// 
// btnOK
// 
this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
this.btnOK.Font = new System.Drawing.Font("Arial", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
this.btnOK.Image = ((System.Drawing.Image)(resources.GetObject("btnOK.Image")));
this.btnOK.Location = new System.Drawing.Point(336, 408);
this.btnOK.Name = "btnOK";
this.btnOK.Size = new System.Drawing.Size(75, 23);
this.btnOK.TabIndex = 3;
this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
this.btnOK.MouseHover += new System.EventHandler(this.btnOK_MouseHover);
// 
// btnPrint
// 
this.btnPrint.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
this.btnPrint.Enabled = false;
this.btnPrint.Image = ((System.Drawing.Image)(resources.GetObject("btnPrint.Image")));
this.btnPrint.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
this.btnPrint.Location = new System.Drawing.Point(256, 408);
this.btnPrint.Name = "btnPrint";
this.btnPrint.TabIndex = 2;
this.btnPrint.Text = "&Print";
this.btnPrint.Click += new System.EventHandler(this.btnPrint_Click);
// 
// cbOutOfService
// 
this.cbOutOfService.AccessibleDescription = "Out of Service Equipment";
this.cbOutOfService.AccessibleName = "Out of Service Equipment";
this.cbOutOfService.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
this.cbOutOfService.Location = new System.Drawing.Point(4, 408);
this.cbOutOfService.Name = "cbOutOfService";
this.cbOutOfService.Size = new System.Drawing.Size(160, 16);
this.cbOutOfService.TabIndex = 1;
this.cbOutOfService.Text = "&Out of Service Equipment";
this.cbOutOfService.CheckedChanged += new System.EventHandler(this.cbOutOfService_CheckedChanged);
// 
// splitter1
// 
this.splitter1.Location = new System.Drawing.Point(188, 0);
this.splitter1.MinExtra = 350;
this.splitter1.MinSize = 150;
this.splitter1.Name = "splitter1";
this.splitter1.Size = new System.Drawing.Size(3, 436);
this.splitter1.TabIndex = 1;
this.splitter1.TabStop = false;
// 
// pnlTreeView
// 
this.pnlTreeView.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
this.pnlTreeView.Controls.Add(this.cbIncludeOutOfService);
this.pnlTreeView.Controls.Add(this.btnSearch);
this.pnlTreeView.Controls.Add(this.txtIDSearch);
this.pnlTreeView.Controls.Add(this.lblEquipID);
this.pnlTreeView.Controls.Add(this.tvInventory);
this.pnlTreeView.Controls.Add(this.pnlTreeViewHeader);
this.pnlTreeView.Dock = System.Windows.Forms.DockStyle.Left;
this.pnlTreeView.Location = new System.Drawing.Point(0, 0);
this.pnlTreeView.Name = "pnlTreeView";
this.pnlTreeView.Size = new System.Drawing.Size(188, 436);
this.pnlTreeView.TabIndex = 0;
// 
// cbIncludeOutOfService
// 
this.cbIncludeOutOfService.AccessibleDescription = "Include Out of Service Equipment";
this.cbIncludeOutOfService.AccessibleName = "Include Out of Service Equipment";
this.cbIncludeOutOfService.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.cbIncludeOutOfService.Location = new System.Drawing.Point(0, 418);
this.cbIncludeOutOfService.Name = "cbIncludeOutOfService";
this.cbIncludeOutOfService.Size = new System.Drawing.Size(196, 16);
this.cbIncludeOutOfService.TabIndex = 3;
this.cbIncludeOutOfService.Text = "&Include Out of Service Equipment";
this.cbIncludeOutOfService.CheckedChanged += new System.EventHandler(this.cbIncludeOutOfService_CheckedChanged);
// 
// btnSearch
// 
this.btnSearch.AccessibleDescription = "Search";
this.btnSearch.AccessibleName = "Search";
this.btnSearch.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
this.btnSearch.Enabled = false;
this.btnSearch.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
this.btnSearch.Image = ((System.Drawing.Image)(resources.GetObject("btnSearch.Image")));
this.btnSearch.Location = new System.Drawing.Point(166, 24);
this.btnSearch.Name = "btnSearch";
this.btnSearch.Size = new System.Drawing.Size(20, 20);
this.btnSearch.TabIndex = 1;
this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
// 
// txtIDSearch
// 
this.txtIDSearch.AccessibleDescription = "Serial Number";
this.txtIDSearch.AccessibleName = "Serial Number";
this.txtIDSearch.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.txtIDSearch.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
this.txtIDSearch.Location = new System.Drawing.Point(48, 24);
this.txtIDSearch.MaxLength = 50;
this.txtIDSearch.Name = "txtIDSearch";
this.txtIDSearch.Size = new System.Drawing.Size(118, 20);
this.txtIDSearch.TabIndex = 0;
this.txtIDSearch.Text = "";
this.txtIDSearch.TextChanged += new System.EventHandler(this.txtIDSearch_TextChanged);
// 
// lblEquipID
// 
this.lblEquipID.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
this.lblEquipID.Font = new System.Drawing.Font("Arial", 6.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
this.lblEquipID.Location = new System.Drawing.Point(0, 24);
this.lblEquipID.Name = "lblEquipID";
this.lblEquipID.Size = new System.Drawing.Size(48, 20);
this.lblEquipID.TabIndex = 1;
this.lblEquipID.Text = "Serial No.";
this.lblEquipID.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// tvInventory
// 
this.tvInventory.AccessibleDescription = "Equipment";
this.tvInventory.AccessibleName = "Equipment";
this.tvInventory.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.tvInventory.HideSelection = false;
this.tvInventory.ImageList = this.imageList1;
this.tvInventory.Location = new System.Drawing.Point(0, 44);
this.tvInventory.Name = "tvInventory";
this.tvInventory.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
new System.Windows.Forms.TreeNode("Equipment Type", 0, 0, new System.Windows.Forms.TreeNode[] {
  new System.Windows.Forms.TreeNode("Equipment Name", 2, 2, new System.Windows.Forms.TreeNode[] {
new System.Windows.Forms.TreeNode("Serial Number", 1, 1, new System.Windows.Forms.TreeNode[] {
 new System.Windows.Forms.TreeNode("Maintenance", 7, 7)})})})});
this.tvInventory.Size = new System.Drawing.Size(186, 376);
this.tvInventory.TabIndex = 2;
this.tvInventory.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvInventory_AfterSelect);
this.tvInventory.BeforeSelect += new System.Windows.Forms.TreeViewCancelEventHandler(this.tvInventory_BeforeSelect);
// 
// imageList1
// 
this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
// 
// pnlTreeViewHeader
// 
this.pnlTreeViewHeader.BackColor = System.Drawing.SystemColors.ActiveCaption;
this.pnlTreeViewHeader.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
this.pnlTreeViewHeader.Controls.Add(this.lblInventory);
this.pnlTreeViewHeader.Controls.Add(this.picInventory);
this.pnlTreeViewHeader.Dock = System.Windows.Forms.DockStyle.Top;
this.pnlTreeViewHeader.Location = new System.Drawing.Point(0, 0);
this.pnlTreeViewHeader.Name = "pnlTreeViewHeader";
this.pnlTreeViewHeader.Size = new System.Drawing.Size(186, 24);
this.pnlTreeViewHeader.TabIndex = 0;
// 
// lblInventory
// 
this.lblInventory.ForeColor = System.Drawing.SystemColors.ActiveCaptionText;
this.lblInventory.Location = new System.Drawing.Point(24, 2);
this.lblInventory.Name = "lblInventory";
this.lblInventory.Size = new System.Drawing.Size(124, 18);
this.lblInventory.TabIndex = 0;
this.lblInventory.Text = "Inventory";
this.lblInventory.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
// 
// picInventory
// 
this.picInventory.Image = ((System.Drawing.Image)(resources.GetObject("picInventory.Image")));
this.picInventory.Location = new System.Drawing.Point(4, 4);
this.picInventory.Name = "picInventory";
this.picInventory.Size = new System.Drawing.Size(16, 16);
this.picInventory.TabIndex = 0;
this.picInventory.TabStop = false;
// 
// grpImage
// 
this.grpImage.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left)));
this.grpImage.Controls.Add(this.picEquipment);
this.grpImage.Location = new System.Drawing.Point(4, 32);
this.grpImage.Name = "grpImage";
this.grpImage.Size = new System.Drawing.Size(52, 456);
this.grpImage.TabIndex = 0;
this.grpImage.TabStop = false;
// 
// picEquipment
// 
this.picEquipment.Image = ((System.Drawing.Image)(resources.GetObject("picEquipment.Image")));
this.picEquipment.Location = new System.Drawing.Point(4, 12);
this.picEquipment.Name = "picEquipment";
this.picEquipment.Size = new System.Drawing.Size(45, 44);
this.picEquipment.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
this.picEquipment.TabIndex = 0;
this.picEquipment.TabStop = false;
// 
// printDialog1
// 
this.printDialog1.AllowPrintToFile = false;
// 
// FrmMaintainEquipment
// 
this.AcceptButton = this.btnSearch;
this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
this.CancelButton = this.btnCancel;
this.ClientSize = new System.Drawing.Size(692, 523);
this.Controls.Add(this.btnCancel);
this.Controls.Add(this.grpInventory);
this.Controls.Add(this.grpImage);
this.hlphelpChm.SetHelpKeyword(this, "Maintain_Equipment.htm");
this.hlphelpChm.SetHelpNavigator(this, System.Windows.Forms.HelpNavigator.Topic);
this.MinimumSize = new System.Drawing.Size(700, 550);
this.Name = "FrmMaintainEquipment";
this.RequiredFieldsLabel = true;
this.hlphelpChm.SetShowHelp(this, true);
this.Text = "VBECS - Maintain Equipment";
this.KeyDownSpeakMessage += new EXT.DOMAIN.vbecs.GUI.VbecsBaseForm.KeyDownSpeakMessageEventHandler(this.FrmMaintainEquipment_KeyDownSpeakMessage);
this.Controls.SetChildIndex(this.vbecsLogo1, 0);
this.Controls.SetChildIndex(this.lblRequiredField, 0);
this.Controls.SetChildIndex(this.grpImage, 0);
this.Controls.SetChildIndex(this.grpInventory, 0);
this.Controls.SetChildIndex(this.btnCancel, 0);
this.grpInventory.ResumeLayout(false);
this.pnlContainer.ResumeLayout(false);
this.pnlEquipmentType.ResumeLayout(false);
this.tabEquipment.ResumeLayout(false);
this.pageEquipment.ResumeLayout(false);
this.grpInstallation.ResumeLayout(false);
this.grpEquipment.ResumeLayout(false);
this.grpManufacturer.ResumeLayout(false);
this.pageMaintenance.ResumeLayout(false);
this.grpMaintenanceEvents.ResumeLayout(false);
this.grpNewEvent.ResumeLayout(false);
this.grpScheduledEvent.ResumeLayout(false);
this.pnlEquipmentHeader.ResumeLayout(false);
this.pnlTreeView.ResumeLayout(false);
this.pnlTreeViewHeader.ResumeLayout(false);
this.grpImage.ResumeLayout(false);
this.ResumeLayout(false);
#endregion
#region Methods
/// <summary>
/// Set initial component properties
/// </summary>
private void SetComponentProperties()
this._isLoading = true;
this.vbecsLogo1.Title = this.Text.Replace("VBECS - ","");
// CR 2693
// hlpHelp
// 
this.hlpHelp.HelpNamespace = Environment.CurrentDirectory+"\\VBECS.chm";
// 
// hlphelpChm
// 
this.hlphelpChm.HelpNamespace = Environment.CurrentDirectory+"\\VBECS.chm";
// 
//
this.SetThisHelpFile(this, Common.StrRes.HelpFiles.UC022.FrmMaintainEquipment());
//
this.btnOK.EnabledButton = false;
this.btnOK.Text = "&OK";
//
this.btnAdd.EnabledButton = false;
this.btnAdd.Text = "&Add";
//
this.SetToolTips();
//
this.mtxtZip.IsZipCode = true;
//
//set custom date and time format
this.dtpMaintenanceDate.CustomFormat = Common.VBECSDateTime.DateTimeFormat;
this.dtpExpirationDate.CustomFormat = " ";
this.dtpDateReceived.CustomFormat = " ";
//set current date value based on the division time zone
System.DateTime _currentDate = BOL.VBECSDateTime.GetDivisionCurrentDateTime();
this.dtpMaintenanceDate.Value = _currentDate;
this.dtpExpirationDate.Value = _currentDate;
this.dtpDateReceived.Value = _currentDate;
this.dtpMaintenanceDate.MaxDate = _currentDate;
this.dtpDateReceived.MaxDate = _currentDate;
//
this.cmbMaintenanceType.LookupEnabled = false;
this.cmbManufacturerName.LookupEnabled = false;
//
this.tvInventory.PathSeparator = "\t";
this.LoadStates();
//
this.LoadManufacturerNames();
//
this.LoadMaintenanceTypes();
//
this.EnableEquipmentControls(false);
this._isLoading = false;
private void SetToolTips()
this.SetThisToolTip(this.txtIDSearch, Common.StrRes.Tooltips.UC022.SerialNumberSearch());
this.SetThisToolTip(this.btnSearch, Common.StrRes.Tooltips.UC022.SerialNumberSearchButton());
this.SetThisToolTip(this.tvInventory, Common.StrRes.Tooltips.UC022.EquipmentInventory());
this.SetThisToolTip(this.cbIncludeOutOfService, Common.StrRes.Tooltips.UC022.IncludeOutOfService());
//
this.SetThisToolTip(this.cbOutOfService, Common.StrRes.Tooltips.UC022.OutOfService());
this.SetThisToolTip(this.txtEquipmentType, Common.StrRes.Tooltips.UC022.ViewEquipmentType());
this.SetThisToolTip(this.txtEquipmentName, Common.StrRes.Tooltips.UC022.ViewEquipmentName());
this.SetThisToolTip(this.txtEquipmentID, Common.StrRes.Tooltips.UC022.LocalEquipmentId());
this.SetThisToolTip(this.txtSerialNumber, Common.StrRes.Tooltips.UC022.SerialNumber());
this.SetThisToolTip(this.dtpDateReceived, Common.StrRes.Tooltips.UC022.DateReceivedInstalled());
this.SetThisToolTip(this.txtContractNumber, Common.StrRes.Tooltips.UC022.WarrantyServiceContractNumber());
this.SetThisToolTip(this.cbExpirationDate, Common.StrRes.Tooltips.UC022.ExpirationRenewalDateOnOff());
this.SetThisToolTip(this.dtpExpirationDate, Common.StrRes.Tooltips.UC022.ExpirationRenewalDate());
//
this.SetThisToolTip(this.cmbManufacturerName, Common.StrRes.Tooltips.Common.ManufacturerName());
this.SetThisToolTip(this.txtAddressLine1, Common.StrRes.Tooltips.Common.ManufacturerAddress1());
this.SetThisToolTip(this.txtAddressLine2, Common.StrRes.Tooltips.Common.ManufacturerAddress2());
this.SetThisToolTip(this.txtCity, Common.StrRes.Tooltips.Common.ManufacturerCity());
this.SetThisToolTip(this.cmbState, Common.StrRes.Tooltips.Common.ManufacturerState());
this.mtxtZip.SetToolTip(Common.StrRes.Tooltips.Common.ManufacturerZip());
this.mtxtPhone.SetToolTip(Common.StrRes.Tooltips.Common.ManufacturerPhone());
this.SetThisToolTip(this.btnAddress, Common.StrRes.Tooltips.UC022.AddressSelect());
//
this.SetThisToolTip(this.cmbMaintenanceType, Common.StrRes.Tooltips.UC022.MaintenanceType());
this.SetThisToolTip(this.dtpMaintenanceDate, Common.StrRes.Tooltips.UC022.MaintenanceDate());
this.SetThisToolTip(this.txtResults, Common.StrRes.Tooltips.UC022.MaintenanceResults());
this.SetThisToolTip(this.txtPendingIssues, Common.StrRes.Tooltips.UC022.PendingIssues());
this.SetThisToolTip(this.lvMaintenanceEvents, Common.StrRes.Tooltips.UC022.MaintenanceEvents());
this.SetThisToolTip(this.txtScheduledEvent, Common.StrRes.Tooltips.UC022.NextScheduledEvent());
//
this.SetThisToolTip(this.btnClear,Common.StrRes.Tooltips.Common.ClearEntries());
this.SetThisToolTip(this.btnCancel,Common.StrRes.Tooltips.Common.Cancel());
this.SetThisToolTip(this.btnPrint,Common.StrRes.Tooltips.Common.Print());
/// <summary>
/// Load States into combo box
/// </summary>
private void LoadStates()
cmbState.Items.Clear();
cmbState.Items.AddRange(BOL.ReferenceData.GetStateCodes());
/// <summary>
/// Load previously entered manufacturer names
/// </summary>
private void LoadManufacturerNames()
ArrayList manufacturers = BOL.Equipment.GetEquipmentManufacturerNames();
//
cmbManufacturerName.Items.Clear();
foreach(string mfr in manufacturers)
cmbManufacturerName.Items.Add(mfr);
/// <summary>
/// Load previously entered maintenance types
/// </summary>
private void LoadMaintenanceTypes()
ArrayList maintenance = BOL.EquipmentMaintenance.GetMaintenanceTypes();
//
cmbMaintenanceType.Items.Clear();
foreach(string m in maintenance)
cmbMaintenanceType.Items.Add(m);
/// <summary>
/// Load equipment into tree view
/// </summary>
/// <param name="includeOutOfService"></param>
private void LoadEquipment(bool includeOutOfService)
this.tvInventory.Nodes.Clear();
//
using (new WaitCursor())
ArrayList equipments = BOL.Equipment.GetEquipmentList();
//
if (equipments.Count==0)
this.tvInventory.Nodes.Add(new TreeNode("No equipment found",0,0));
//
foreach(BOL.Equipment equipment in equipments)
if (!includeOutOfService && equipment.OutOfServiceIndicator)
continue;
TreeNode parentNode = AddEquipmentTypeNode(equipment);
TreeNode childNode = AddEquipmentNameNode(parentNode, equipment);
TreeNode serialNode = AddSerialNumberNode(childNode, equipment);
//Ensure list displays first node
if (this.tvInventory.Nodes.Count > 0)
this.tvInventory.SelectedNode = this.tvInventory.Nodes[0];
this.tvInventory.SelectedNode = null;
private void LoadEquipment(Guid equipmentGuid)
this.cbIncludeOutOfService.Enabled = false;
this.tvInventory.Nodes.Clear();
//
using (new WaitCursor())
BOL.Equipment equipment = new BOL.Equipment(equipmentGuid);
//
TreeNode parentNode = AddEquipmentTypeNode(equipment);
TreeNode childNode = AddEquipmentNameNode(parentNode, equipment);
TreeNode serialNode = AddSerialNumberNode(childNode, equipment);
//
this.tvInventory.SelectedNode = serialNode;
/// <summary>
/// Get selected tree node level
/// </summary>
/// <param name="e"></param>
/// <returns></returns>
private int GetSelectedLevel(TreeNode e)
if (this.tvInventory.Nodes.Count==0)
return -1;
string str = e.FullPath;
string strcmp = this.tvInventory.PathSeparator;
int pos = 0;
int level = 0;
while (str.IndexOf(strcmp,pos) > -1)
pos = str.IndexOf(strcmp,pos)+1;
level = level +1;
return level;
/// <summary>
/// Add Equipment Type Node
/// </summary>
/// <param name="equipment"></param>
private TreeNode AddEquipmentTypeNode(BOL.Equipment equipment)
foreach(TreeNode node in this.tvInventory.Nodes)
if ((node.Text.ToUpper() == equipment.EquipmentType.ToUpper()) && (GetSelectedLevel(node)==0))
return node;
//
TreeNode equipmentTypeNode = new TreeNode(equipment.EquipmentType,7,7);
this.tvInventory.Nodes.Add(equipmentTypeNode);
return(equipmentTypeNode);
/// <summary>
/// Add Equipment Name Node
/// </summary>
/// <param name="parentNode"></param>
/// <param name="equipment"></param>
private TreeNode AddEquipmentNameNode(TreeNode parentNode, BOL.Equipment equipment)
foreach(TreeNode typenode in this.tvInventory.Nodes)
foreach(TreeNode node in typenode.Nodes)
if ((node.Text.ToUpper() == equipment.EquipmentName.ToUpper()) && (GetSelectedLevel(node)==1))
return node;
//
TreeNode nameNode = new TreeNode(equipment.EquipmentName,2,2);
parentNode.Nodes.Add(nameNode);
return(nameNode);
/// <summary>
/// Add Serial Number Node
/// </summary>
/// <param name="parentNode"></param>
/// <param name="equipment"></param>
private TreeNode AddSerialNumberNode(TreeNode parentNode, BOL.Equipment equipment)
//
TreeNode lotNode = new TreeNode(equipment.SerialNumber,1,1);
lotNode.Tag = equipment.EquipmentGuid;
if (equipment.OutOfServiceIndicator)
lotNode.ForeColor = Color.FromKnownColor(KnownColor.GrayText);
parentNode.Nodes.Add(lotNode);
return(lotNode);
/// <summary>
/// Load maintenance events into list view
/// </summary>
private void LoadEvents()
this.lvMaintenanceEvents.Items.Clear();
//
foreach(DataRow drEvent in this._maintenanceEvents.Rows)
ListViewItem lvi = new ListViewItem();
lvi.Tag = drEvent;
lvi.Text = Common.VBECSDateTime.FormatDateTimeString(drEvent[Common.VbecsTables.EquipmentMaintenance.MaintenanceDate]);
lvi.SubItems.Add(drEvent[Common.VbecsTables.EquipmentMaintenance.MaintenanceType].ToString());
lvi.SubItems.Add(drEvent[Common.VbecsTables.EquipmentMaintenance.MaintenanceResults].ToString());
lvi.SubItems.Add(drEvent[Common.VbecsTables.EquipmentMaintenance.PendingIssues].ToString());
this.lvMaintenanceEvents.Items.Add(lvi);
//
controls.VbecsFunction.SetColumnWidths(this.lvMaintenanceEvents);
/// <summary>
/// Clear equipment controls
/// </summary>
private void ClearEquipment()
this.errError.SetVbecsError(this.mtxtZip, string.Empty); // **** 508 Compliance ***
this._equipment = null;
//
this.txtEquipmentType.Text = "";
this.txtEquipmentName.Text = "";
this.txtSerialNumber.Text = "";
this.txtEquipmentID.Text = "";
//
this.cmbManufacturerName.Text = "";
this.txtAddressLine1.Text = "";
this.txtAddressLine2.Text = "";
this.txtCity.Text = "";
this.cmbState.SelectedIndex = -1;
this.cmbState.Text = "";
this.mtxtZip.SetText("");
this.mtxtPhone.SetText("");
//
DateTime currentDate = BOL.VBECSDateTime.GetDivisionCurrentDateTime();
this.dtpDateReceived.MaxDate = currentDate;
this.dtpDateReceived.Value = currentDate;
this.dtpDateReceived.CustomFormat = " ";
this.txtContractNumber.Text = "";
this.cbExpirationDate.Checked = false;
this.dtpExpirationDate.Enabled = false;
this.dtpExpirationDate.Value = BOL.VBECSDateTime.GetDivisionCurrentDateTime().Date.AddHours(23).AddMinutes(59);
this.dtpExpirationDate.CustomFormat = " ";
//
this.cbOutOfService.Checked = false;
this.txtScheduledEvent.Text = "";
/// <summary>
/// Clear maintenance event controls
/// </summary>
private void ClearMaintenanceEvent()
//
this._equipmentMaintenance = new BOL.EquipmentMaintenance(Guid.NewGuid());
if (this._equipment != null)
this._equipmentMaintenance.EquipmentGuid = this._equipment.EquipmentGuid;
this._equipmentMaintenance.SetInitialBrokenRules(this.Name,Common.VbecsTables.EquipmentMaintenance.TableName);
this._equipmentMaintenance.Invalid += new System.EventHandler(CheckMaintenanceValid);
this._equipmentMaintenance.Valid += new System.EventHandler(CheckMaintenanceValid);
this._equipmentMaintenance.IsDirtyChanged += new System.EventHandler(CheckMaintenanceValid);
//
this.cmbMaintenanceType.SelectedIndex = -1;
this.cmbMaintenanceType.Text = "";
DateTime currentDate = BOL.VBECSDateTime.GetDivisionCurrentDateTime();
this.dtpMaintenanceDate.MaxDate = currentDate;
this.dtpMaintenanceDate.Value = currentDate;
this.txtResults.Text = "";
this.txtPendingIssues.Text = "";
//
this._equipmentMaintenance.IsNew = true;
this._equipmentMaintenance.IsDirty = false;
//
this.btnAdd.Text = "&Add";
/// <summary>
/// Display selected equipment
/// </summary>
/// <param name="equipment"></param>
private void DisplaySelectedEquipment(BOL.Equipment equipment)
this._equipment = equipment;
//
if (this.SetLocks(equipment.EquipmentGuid))
this.errError.SetVbecsError(this.mtxtZip, string.Empty); // **** 508 Compliance ***
this._equipment.SetInitialBrokenRules(this.Name,Common.VbecsTables.Equipment.TableName);
this._equipment.Invalid += new System.EventHandler(CheckValid);
this._equipment.Valid += new System.EventHandler(CheckValid);
this._equipment.IsDirtyChanged += new System.EventHandler(CheckValid);
this._equipment.ManufacturerAddress.SetInitialBrokenRules(this.Name,Common.VbecsTables.Address.TableName);
this._equipment.ManufacturerAddress.Invalid += new System.EventHandler(CheckValid);
this._equipment.ManufacturerAddress.Valid += new System.EventHandler(CheckValid);
this._equipment.ManufacturerAddress.IsDirtyChanged += new System.EventHandler(CheckValid);
//
this.txtEquipmentType.Text = equipment.EquipmentType;
this.txtEquipmentName.Text = equipment.EquipmentName;
this.txtSerialNumber.Text = equipment.SerialNumber;
this.txtEquipmentID.Text = equipment.LocalIdentifier;
//
this.cmbManufacturerName.Text = equipment.ManufacturerName;
this.txtAddressLine1.Text = equipment.ManufacturerAddress.AddressLine1;
this.txtAddressLine2.Text = equipment.ManufacturerAddress.AddressLine2;
this.txtCity.Text = equipment.ManufacturerAddress.City;
this.cmbState.SelectedIndex = this.cmbState.Items.IndexOf(equipment.ManufacturerAddress.StateCode);
this.mtxtZip.SetText(equipment.ManufacturerAddress.ZipCode);
this.mtxtPhone.SetText(equipment.ManufacturerPhoneNumber.Trim());
//
this.dtpDateReceived.MaxDate = BOL.VBECSDateTime.GetDivisionCurrentDateTime();
this.dtpDateReceived.CustomFormat = Common.VBECSDateTime.DateTimeFormat;
this.dtpDateReceived.Value = equipment.ReceiptDate;
this.txtContractNumber.Text = equipment.MaintenanceContractNumber;
if (equipment.IsMaintenanceContractDate)
//remember date, cos checking the checkbox will reset it!
DateTime dt = equipment.MaintenanceContractDate;
this.cbExpirationDate.Checked = true;
this.dtpExpirationDate.Value = dt;
else
this.cbExpirationDate.Checked = false;
this.dtpExpirationDate.Value = BOL.VBECSDateTime.GetDivisionCurrentDateTime().Date.AddHours(23).AddMinutes(59);
//
this.txtScheduledEvent.Text = equipment.NextMaintenanceEvent;
this.cbOutOfService.Checked = equipment.OutOfServiceIndicator;
//
this._equipment.IsDirty = false;
this._equipment.ManufacturerAddress.IsDirty = false;
//
this.EnableEquipmentControls(true);
//
this._maintenanceEvents = BOL.EquipmentMaintenance.GetEquipmentMaintenance(this._equipment.EquipmentGuid);
this.LoadEvents();
else
this.ClearEquipment();
this.EnableEquipmentControls(false);
/// <summary>
/// Display selected maintenance event
/// </summary>
/// <param name="maintenanceEvent"></param>
private void DisplaySelectedMaintenanceEvent(BOL.EquipmentMaintenance maintenanceEvent)
this._equipmentMaintenance = maintenanceEvent;
this._equipmentMaintenance.SetInitialBrokenRules(this.Name,Common.VbecsTables.EquipmentMaintenance.TableName);
this._equipmentMaintenance.Invalid += new System.EventHandler(CheckMaintenanceValid);
this._equipmentMaintenance.Valid += new System.EventHandler(CheckMaintenanceValid);
this._equipmentMaintenance.IsDirtyChanged += new System.EventHandler(CheckMaintenanceValid);
//
this.cmbMaintenanceType.Text = maintenanceEvent.MaintenanceActivity;
this.dtpMaintenanceDate.MaxDate = BOL.VBECSDateTime.GetDivisionCurrentDateTime();
this.dtpMaintenanceDate.Value = maintenanceEvent.MaintenanceDate;
this.txtResults.Text = maintenanceEvent.MaintenanceResult;
this.txtPendingIssues.Text = maintenanceEvent.PendingMaintenanceIssues;
this.btnAdd.Text = "&Update";
//
this._equipmentMaintenance.IsDirty = false;
/// <summary>
/// Enable/disable equipment controls
/// </summary>
/// <param name="enable"></param>
private void EnableEquipmentControls(bool enable)
this.txtSerialNumber.ReadOnly = !enable;
this.txtEquipmentID.ReadOnly = !enable;
//
this.grpManufacturer.Enabled = enable;
//
this.grpInstallation.Enabled = enable;
//
this.cbOutOfService.Enabled = enable;
//
if (!enable)
this.lvMaintenanceEvents.Items.Clear();
//
if (!enable && this.tabEquipment.TabPages.Contains(this.pageMaintenance))
this.tabEquipment.TabPages.Remove(this.pageMaintenance);
else if (enable && !this.tabEquipment.TabPages.Contains(this.pageMaintenance))
this.tabEquipment.TabPages.Add(this.pageMaintenance);
/// <summary>
/// Finds and opens the node with equipment having a certain serial number
/// </summary>
/// <param name="serialNumber"></param>
public void SearchAndOpenNode(string serialNumber)
foreach(TreeNode typenode in this.tvInventory.Nodes)
foreach(TreeNode namenode in typenode.Nodes)
foreach(TreeNode node in namenode.Nodes)
if (GetSelectedLevel(node)==2)
if (node.Text.ToUpper() == serialNumber.ToUpper())
typenode.Expand();
namenode.Expand();
this.tvInventory.SelectedNode = node;
node.ExpandAll();
return;
//
//Search again, for partial match this time
foreach(TreeNode typenode in this.tvInventory.Nodes)
foreach(TreeNode namenode in typenode.Nodes)
foreach(TreeNode node in namenode.Nodes)
if (GetSelectedLevel(node)==2)
if (node.Text.ToUpper().StartsWith(serialNumber.ToUpper()))
typenode.Expand();
namenode.Expand();
this.tvInventory.SelectedNode = node;
node.ExpandAll();
return;
//
GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC020.NoMatchingEntries());
//Ensure list displays first node
if (this.tvInventory.Nodes.Count > 0)
this.tvInventory.SelectedNode = this.tvInventory.Nodes[0];
this.tvInventory.SelectedNode = null;
/// <summary>
/// **** 508 Compliance ***
/// </summary>
private string GetAddButtonToolTip()
string message = string.Empty;
//
if (this._equipmentMaintenance != null)
if (this._equipmentMaintenance.IsValid)
if (this._equipmentMaintenance.IsDirty)
if (this.btnAdd.Text == "&Add")
message = Common.StrRes.Tooltips.UC022.AddEquipmentMaintenance().ResString;
else
message = Common.StrRes.Tooltips.UC022.UpdateEquipmentMaintenance().ResString;
else
message = Common.StrRes.Tooltips.Common.NoChangesToSave().ResString;
else
message = this._equipmentMaintenance.GetBrokenRulesMessage(this.Name);
//
return message;
/// <summary>
/// **** 508 Compliance ***
/// </summary>
private string GetOKButtonToolTip()
string message = string.Empty;
//
if (this._equipment != null)
if (this._equipment.IsValid && this._equipment.ManufacturerAddress.IsValid)
if (this._equipment.IsDirty || this._equipment.ManufacturerAddress.IsDirty || (this._maintenanceEvents.GetChanges() != null))
message = Common.StrRes.Tooltips.Common.OKToSave().ResString;
else
message = Common.StrRes.Tooltips.Common.NoChangesToSave().ResString;
else
message = this._equipment.GetBrokenRulesMessage(this.Name);
if (message.Length > 0)
message = string.Concat(message, "\n");
message = string.Concat(message, this._equipment.ManufacturerAddress.GetBrokenRulesMessage(this.Name));
else
message = Common.StrRes.Tooltips.Common.SelectOneItem("equipment").ResString;
//
return message;
#endregion
#region Event Handlers
private void tvInventory_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
Guid previousEquipmentGuid = Guid.Empty;
Guid selectedEquipmentGuid = Guid.Empty;
//
if (this._equipment != null)
previousEquipmentGuid = this._equipment.EquipmentGuid;
//
this.ClearEquipment();
//
if (e.Node != null)
int level = this.GetSelectedLevel(e.Node);
//
if (level == 0)
if (e.Node.Text != "No equipment found")
this.txtEquipmentType.Text = e.Node.Text;
this.EnableEquipmentControls(false);
else if (level == 1)
this.txtEquipmentType.Text = e.Node.Parent.Text;
this.txtEquipmentName.Text = e.Node.Text;
this.EnableEquipmentControls(false);
else if (level == 2)
selectedEquipmentGuid = (Guid)e.Node.Tag;
//
//Only load from the database if the current equipment selection 
//is different to the previous selection.
if (selectedEquipmentGuid != previousEquipmentGuid)
//
this.DisplaySelectedEquipment(new BOL.Equipment(selectedEquipmentGuid));
this.ClearMaintenanceEvent();
//
this.tabEquipment.SelectedTab = this.pageEquipment;
//
this.CheckValid(sender,e);
private void CheckValid(object sender, EventArgs e)
if ((this._equipment == null) || (this._equipment.ManufacturerAddress == null))
this.btnOK.EnabledButton = false;
this.btnPrint.Enabled = false;
return;
//
this.btnOK.EnabledButton = ((this._equipment.IsDirty || this._equipment.ManufacturerAddress.IsDirty || (this._maintenanceEvents != null && this._maintenanceEvents.GetChanges() != null)) 
&& this._equipment.IsValid && this._equipment.ManufacturerAddress.IsValid);
this.btnPrint.Enabled = ((!this._equipment.IsDirty) && (!this._equipment.ManufacturerAddress.IsDirty) && (this._maintenanceEvents == null || this._maintenanceEvents.GetChanges() == null));
private void CheckMaintenanceValid(object sender, EventArgs e)
this.btnAdd.EnabledButton = (this._equipmentMaintenance.IsDirty && this._equipmentMaintenance.IsValid);
/// <summary>
/// Find and select the node
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>
private void btnSearch_Click(object sender, System.EventArgs e)
SearchAndOpenNode(this.txtIDSearch.Text.Trim());
private void txtIDSearch_TextChanged(object sender, System.EventArgs e)
if (this.txtIDSearch.Text.Trim().Length > 0)
this.btnSearch.Enabled = true;
else
this.btnSearch.Enabled = false;
private void txtContractNumber_TextChanged(object sender, System.EventArgs e)
if(this._equipment != null)
this._equipment.MaintenanceContractNumber = txtContractNumber.Text;
this.IsDirty = true;
private void txtEquipmentID_TextChanged(object sender, System.EventArgs e)
if(this._equipment != null)
this._equipment.LocalIdentifier = txtEquipmentID.Text;
this.IsDirty = true;
private void txtSerialNumber_TextChanged(object sender, System.EventArgs e)
if(this._equipment != null)
this._equipment.SerialNumber = txtSerialNumber.Text;
this.IsDirty = true;
private void dtpDateReceived_ValueChanged(object sender, System.EventArgs e)
if(this._equipment != null)
this._equipment.ReceiptDate = dtpDateReceived.Value;
this.IsDirty = true;
private void dtpExpirationDate_ValueChanged(object sender, System.EventArgs e)
if(this._equipment != null)
this._equipment.MaintenanceContractDate = dtpExpirationDate.Value;
this.IsDirty = true;
private void txtManufacturerName_TextChanged(object sender, System.EventArgs e)
if(this._equipment != null)
this._equipment.ManufacturerName = cmbManufacturerName.Text;
this.IsDirty = true;
//
this.btnAddress.Enabled = (this.cmbManufacturerName.Text.Trim().Length>0);
private void txtAddressLine1_TextChanged(object sender, System.EventArgs e)
if(this._equipment != null)
this._equipment.ManufacturerAddress.AddressLine1 = txtAddressLine1.Text;
this.IsDirty = true;
private void txtAddressLine2_TextChanged(object sender, System.EventArgs e)
if(this._equipment != null)
this._equipment.ManufacturerAddress.AddressLine2 = txtAddressLine2.Text;
this.IsDirty = true;
private void txtCity_TextChanged(object sender, System.EventArgs e)
if(this._equipment != null)
this._equipment.ManufacturerAddress.City = txtCity.Text;
this.IsDirty = true;
private void cmbState_SelectedIndexChanged(object sender, System.EventArgs e)
if(this._equipment != null)
if (this.cmbState.SelectedIndex>-1)
this._equipment.ManufacturerAddress.StateCode = cmbState.Text;
else
this._equipment.ManufacturerAddress.StateCode = "";
this.IsDirty = true;
private void ValidZipCode(object sender, System.EventArgs e)
if (this._equipment != null)
try
this._equipment.ManufacturerAddress.ZipCode = this.mtxtZip.GetText();
this.errError.SetVbecsError(this.mtxtZip, string.Empty); // **** 508 Compliance ***
this.IsDirty = true;
catch(BOL.BusinessObjectException err)
this.errError.SetVbecsError(this.mtxtZip, err.Message); // **** 508 Compliance ***
private void InvalidZipCode(object sender, System.EventArgs e)
if (this._equipment != null)
this._equipment.ManufacturerAddress.ZipCode = "";
this.IsDirty = true;
this.errError.SetVbecsError(this.mtxtZip, string.Empty); // **** 508 Compliance ***
private void InvalidPhoneNumber(object sender, System.EventArgs e)
if (this._equipment != null)
this._equipment.ManufacturerPhoneNumber = "";
this.IsDirty = true;
private void ValidPhoneNumber(object sender, System.EventArgs e)
if (this._equipment != null)
this._equipment.ManufacturerPhoneNumber = this.mtxtPhone.GetText();
this.IsDirty = true;
private void ExpirationCheckChanged(object sender, System.EventArgs e)
if (this._equipment != null)
if (this.cbExpirationDate.Checked)
this._equipment.IsMaintenanceContractDate = true;
this._equipment.MaintenanceContractDate = this.dtpExpirationDate.Value;
this.dtpExpirationDate.CustomFormat = Common.VBECSDateTime.DateTimeFormat;
this.dtpExpirationDate.Enabled = true;
this.cbExpirationDate.Text = "Expiration/Renewal Date*";
this.IsDirty = true;
else
this._equipment.IsMaintenanceContractDate = false;
this._equipment.MaintenanceContractDate = DateTime.MinValue;
this.dtpExpirationDate.CustomFormat = " ";
this.dtpExpirationDate.Enabled = false;
this.cbExpirationDate.Text = "Expiration/Renewal Date";
this.IsDirty = true;
private void cbOutOfService_CheckedChanged(object sender, System.EventArgs e)
if (this._equipment != null)
this._equipment.OutOfServiceIndicator = this.cbOutOfService.Checked;
this.IsDirty = true;
private void btnCancel_Click(object sender, System.EventArgs e)
this.Close();
private void btnOK_Click(object sender, System.EventArgs e)
if (GuiMessenger.ShowMessageBox(Common.StrRes.ConfMsg.Common.OKToSave("equipment")) != DialogResult.Yes)
return;
//
try
if (!this._equipment.Update(this._maintenanceEvents, Common.UpdateFunction.UC022_FrmNewEquipment))
GuiMessenger.ShowMessageBox(Common.StrRes.SysErrMsg.Common.SystemErrorWhileSaving("equipment"));
return;
//CR 1441
System.Data.DataTable dt  = DAL.WorkloadEvent.GetWorkloadProcessGuidByProcessID((int) Common.WorkloadProcessID.UpdateEquipmentRecord);
if(dt!= null)
if(dt.Rows.Count == 0)
GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC015.BR1502_NoWorkloadDefined());
catch(Common.RowVersionException)
this.btnOK.RowVersionException = true;
//CR2077
GuiMessenger.ShowMessageBox(Common.StrRes.SysErrMsg.Common.DataWasNotSavedBecauseOfRowversionViolation());
return;
//
//We might have to update the node in the tree-view
this.tvInventory.SelectedNode.Text = this._equipment.SerialNumber;
if (this._equipment.OutOfServiceIndicator)
this.tvInventory.SelectedNode.ForeColor  = Color.FromKnownColor(KnownColor.GrayText);
else
this.tvInventory.SelectedNode.ForeColor  = Color.FromKnownColor(KnownColor.ControlText);
//
this.IsDirty = false;
//
if (_closeAfterSave)
this.Close();
else
this.tvInventory.SelectedNode = this.tvInventory.SelectedNode.Parent;
private void btnOK_MouseHover(object sender, System.EventArgs e)
this.btnOK.SetToolTip( GetOKButtonToolTip() );
private void cbIncludeOutOfService_CheckedChanged(object sender, System.EventArgs e)
this.LoadEquipment(this.cbIncludeOutOfService.Checked);
private void lvMaintenanceEvents_SelectedIndexChanged(object sender, System.EventArgs e)
if (this.lvMaintenanceEvents.SelectedItems.Count>0)
DataRow drSelected = this._maintenanceEvents.NewRow();
drSelected.ItemArray = ((DataRow)this.lvMaintenanceEvents.SelectedItems[0].Tag).ItemArray;
this.DisplaySelectedMaintenanceEvent(new BOL.EquipmentMaintenance(drSelected));
private void lvMaintenanceEvents_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
if (e.Column == 0)
controls.ColumnClickSorter.ColumnClickHandler(sender,e,lvMaintenanceEvents.CheckBoxes,controls.ColumnClickSorter.ColumnSortType.DateTime);
else
controls.ColumnClickSorter.ColumnClickHandler(sender,e,lvMaintenanceEvents.CheckBoxes,controls.ColumnClickSorter.ColumnSortType.String);
private void btnClear_Click(object sender, System.EventArgs e)
this.lvMaintenanceEvents.SelectedItems.Clear();
//
this.ClearMaintenanceEvent();
private void txtMaintenanceType_TextChanged(object sender, System.EventArgs e)
if (this._equipmentMaintenance != null)
this._equipmentMaintenance.MaintenanceActivity = this.cmbMaintenanceType.Text;
this.IsDirty = true;
private void dtpMaintenanceDate_ValueChanged(object sender, System.EventArgs e)
if (this._equipmentMaintenance != null && !this._isLoading)
this._equipmentMaintenance.MaintenanceDate = this.dtpMaintenanceDate.Value;
this.IsDirty = true;
private void txtResults_TextChanged(object sender, System.EventArgs e)
if (this._equipmentMaintenance != null)
this._equipmentMaintenance.MaintenanceResult = this.txtResults.Text;
this.IsDirty = true;
private void txtPendingIssues_TextChanged(object sender, System.EventArgs e)
if (this._equipmentMaintenance != null)
this._equipmentMaintenance.PendingMaintenanceIssues = this.txtPendingIssues.Text;
this.IsDirty = true;
private void btnAdd_MouseHover(object sender, System.EventArgs e)
this.btnAdd.SetToolTip( GetAddButtonToolTip() );
private void btnAdd_Click(object sender, System.EventArgs e)
DataRow drEvent = this._equipmentMaintenance.LoadDataRowFromThis(BOL.EquipmentMaintenance.GetEmptyEquipmentMaintenanceTable().NewRow());
//
bool found = false;
//
foreach(ListViewItem lvi in this.lvMaintenanceEvents.Items)
DataRow drUpdate = (DataRow)lvi.Tag;
//
if (drUpdate[Common.VbecsTables.EquipmentMaintenance.EquipmentMaintenanceGuid].ToString() == drEvent[Common.VbecsTables.EquipmentMaintenance.EquipmentMaintenanceGuid].ToString())
lvi.SubItems[0].Text = Common.VBECSDateTime.FormatDateTimeString(this._equipmentMaintenance.MaintenanceDate);
lvi.SubItems[1].Text = this._equipmentMaintenance.MaintenanceActivity;
lvi.SubItems[2].Text = this._equipmentMaintenance.MaintenanceResult;
lvi.SubItems[3].Text = this._equipmentMaintenance.PendingMaintenanceIssues;
//
drUpdate[Common.VbecsTables.EquipmentMaintenance.MaintenanceDate] = drEvent[Common.VbecsTables.EquipmentMaintenance.MaintenanceDate];
drUpdate[Common.VbecsTables.EquipmentMaintenance.MaintenanceType] = drEvent[Common.VbecsTables.EquipmentMaintenance.MaintenanceType];
drUpdate[Common.VbecsTables.EquipmentMaintenance.MaintenanceResults] = drEvent[Common.VbecsTables.EquipmentMaintenance.MaintenanceResults];
drUpdate[Common.VbecsTables.EquipmentMaintenance.PendingIssues] = drEvent[Common.VbecsTables.EquipmentMaintenance.PendingIssues];
//
found = true;
break;
//
if (!found)
//Add to the list and to the table
ListViewItem lvi = new ListViewItem();
lvi.Tag = drEvent;
lvi.Text = Common.VBECSDateTime.FormatDateTimeString(this._equipmentMaintenance.MaintenanceDate);
lvi.SubItems.Add(this._equipmentMaintenance.MaintenanceActivity);
lvi.SubItems.Add(this._equipmentMaintenance.MaintenanceResult);
lvi.SubItems.Add(this._equipmentMaintenance.PendingMaintenanceIssues);
this.lvMaintenanceEvents.Items.Insert(0,lvi);
//
this._maintenanceEvents.Rows.Add(drEvent.ItemArray);
//
this.CheckValid(sender,e);
//
controls.VbecsFunction.SetColumnWidths(this.lvMaintenanceEvents);
//Before we clear what they wrote, append what they wrote in cmbMaintenanceType to itself
this.UpdateMaintenanceTypeCmb();
btnClear_Click(sender,e);
private void txtScheduledEvent_TextChanged(object sender, System.EventArgs e)
if (this._equipment != null)
this._equipment.NextMaintenanceEvent = this.txtScheduledEvent.Text;
this.IsDirty = true;
private void UpdateMaintenanceTypeCmb()
bool foundValue = false;
foreach(string typeText in this.cmbMaintenanceType.Items)
if (typeText == this.cmbMaintenanceType.Text)
foundValue = true;
break;
if (!foundValue)
this.cmbMaintenanceType.Items.Add(this.cmbMaintenanceType.Text);
private void btnPrint_Click(object sender, System.EventArgs e)
FrmEquipmentInventory dlg = new FrmEquipmentInventory(this._equipment.EquipmentGuid);
dlg.ParentFormGuid = this.FormInstanceGuid;
dlg.RefreshParentLockTimeEvent += new EventHandler(this.ResetLockTimer);
dlg.ShowDialog(this);
private void tvInventory_BeforeSelect(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
if ((this.tvInventory.SelectedNode != null) && (this.GetSelectedLevel(this.tvInventory.SelectedNode)==2))
Guid selectedEquipmentGuid = (Guid)this.tvInventory.SelectedNode.Tag;
//
Guid nextEquipmentGuid = Guid.Empty;
if (this.GetSelectedLevel(e.Node) == 2)
nextEquipmentGuid = (Guid)e.Node.Tag;
//
if ((selectedEquipmentGuid != nextEquipmentGuid) && ((this._maintenanceEvents != null) && (this._maintenanceEvents.GetChanges() != null)))
if (GuiMessenger.ShowMessageBox(Common.StrRes.ConfMsg.UC022.EquipmentChangesNotSaved())!=DialogResult.Yes)
e.Cancel = true;
return;
private void btnAddress_Click(object sender, System.EventArgs e)
//Check if addresses exist on file for manufacturer name
DataTable addresses = BOL.Equipment.GetManufacturerAddresses(this.cmbManufacturerName.Text.ToUpper());
//
if (addresses.Rows.Count>0)
DlgSelectAddress dlg = new DlgSelectAddress(addresses);
dlg.ParentFormGuid = this.FormInstanceGuid;
dlg.RefreshParentLockTimeEvent += new EventHandler(this.ResetLockTimer);
if (dlg.ShowDialog(this) == DialogResult.OK)
if (dlg.NewAddress)
this.txtAddressLine1.Text = "";
this.txtAddressLine2.Text = "";
this.txtCity.Text = "";
this.cmbState.SelectedIndex = -1;
this.cmbState.Text = "";
this.mtxtZip.SetText("");
this.mtxtPhone.SetText("");
else
this.txtAddressLine1.Text = dlg.Address.AddressLine1;
this.txtAddressLine2.Text = dlg.Address.AddressLine2;
this.txtCity.Text = dlg.Address.City;
this.cmbState.Text = dlg.Address.StateCode;
this.mtxtZip.SetText(dlg.Address.ZipCode);
this.mtxtPhone.SetText(dlg.PhoneNumber);
else
GuiMessenger.ShowMessageBox(Common.StrRes.InfoMsg.UC022.NoManufacturerAddresses(this.cmbManufacturerName.Text));
private void cmbState_Leave(object sender, System.EventArgs e)
if (this.cmbState.SelectedIndex<0)
this.cmbState.Text = "";
private void KeyPressCheckDigit(object sender, System.Windows.Forms.KeyPressEventArgs e)
//Restricting to digits and control characters only.
if (!(char.IsDigit(e.KeyChar)||char.IsControl(e.KeyChar)))
e.Handled = true;
return;
//
/// <summary>
/// **** 508 Compliance ***
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>
private void FrmMaintainEquipment_KeyDownSpeakMessage(object sender, EventArgs e)
string textToSpeak = string.Empty;
//
if ( !this.btnAdd.EnabledButton )
textToSpeak = GetAddButtonToolTip();
//
if ( !this.btnOK.EnabledButton )
textToSpeak = string.Concat(textToSpeak, GetOKButtonToolTip());
//
if ( textToSpeak.Length > 0 )
this.SpeakMessage( textToSpeak );
#endregion
