using System;
using System.Data;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using System.Windows.Forms;
namespace EXT.DOMAIN.vbecs.GUI
/// <summary>
/// Class FrmTestingWorklistReport
/// </summary>
public class FrmTestingWorklistReport : EXT.DOMAIN.vbecs.GUI.VbecsBaseForm
private BOL.TestingWorklist _report;
//
private System.Windows.Forms.GroupBox grpImage;
private System.Windows.Forms.PictureBox pictureBox1;
private CrystalDecisions.Windows.Forms.CrystalReportViewer crvTestingWorklist;
private System.Windows.Forms.Button btnCancel;
private System.Windows.Forms.Button btnPrint;
private System.ComponentModel.IContainer components = null;
//
private System.Windows.Forms.PrintDialog printDialog1;
//
private EXT.DOMAIN.vbecs.reports.TestingWorklist.TestingWorklistMain _rptTestingWorklistReport;
/// <summary>
/// Constructor
/// </summary>
/// <param name="testingWorklistReport"></param>
public FrmTestingWorklistReport(BOL.TestingWorklist testingWorklistReport)
using ( new WaitCursor())
InitializeComponent();
//
this.SetComponentProperties();
//
this._report = testingWorklistReport;
//
if (this._report.Patient != null)
this.SetThisHelpFile(this, Common.StrRes.HelpFiles.UC048.FrmTestingWorklistReport_Patient());
else
this.SetThisHelpFile(this, Common.StrRes.HelpFiles.UC048.FrmTestingWorklistReport());
//
LoadTestingWorklistReport();
/// <summary>
/// Constructor
/// </summary>
/// <param name="patient"></param>
/// <param name="specimens"></param>
public FrmTestingWorklistReport(BOL.Patient patient,
System.Collections.ArrayList specimens)
using ( new WaitCursor())
InitializeComponent();
//
this.SetComponentProperties();
//
this.hlphelpChm.SetHelpKeyword(this,"Patient_Testing_Worklist_and_Testing_Worklist_Reports.htm");
//
this._report = new BOL.TestingWorklist(patient,specimens);
LoadTestingWorklistReport();
/// <summary>
/// Clean up any resources being used.
/// </summary>
protected override void Dispose( bool disposing )
if( disposing )
if (components != null) 
components.Dispose();
base.Dispose( disposing );
#region Designer generated code
/// <summary>
/// Required method for Designer support - do not modify
/// the contents of this method with the code editor.
/// </summary>
private void InitializeComponent()
System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FrmTestingWorklistReport));
this.grpImage = new System.Windows.Forms.GroupBox();
this.pictureBox1 = new System.Windows.Forms.PictureBox();
this.crvTestingWorklist = new CrystalDecisions.Windows.Forms.CrystalReportViewer();
this.btnCancel = new System.Windows.Forms.Button();
this.btnPrint = new System.Windows.Forms.Button();
this.printDialog1 = new System.Windows.Forms.PrintDialog();
this.grpImage.SuspendLayout();
this.SuspendLayout();
// 
// vbecsLogo1
// 
this.vbecsLogo1.Name = "vbecsLogo1";
this.vbecsLogo1.Size = new System.Drawing.Size(742, 30);
this.vbecsLogo1.TabIndex = 3;
this.vbecsLogo1.Title = "Testing Worklist Report";
// 
// lblRequiredField
// 
this.lblRequiredField.Location = new System.Drawing.Point(0, 507);
this.lblRequiredField.Name = "lblRequiredField";
this.lblRequiredField.TabIndex = 5;
// 
// grpImage
// 
this.grpImage.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left)));
this.grpImage.BackColor = System.Drawing.SystemColors.Control;
this.grpImage.Controls.Add(this.pictureBox1);
this.grpImage.Location = new System.Drawing.Point(4, 28);
this.grpImage.Name = "grpImage";
this.grpImage.Size = new System.Drawing.Size(48, 468);
this.grpImage.TabIndex = 4;
this.grpImage.TabStop = false;
// 
// pictureBox1
// 
this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
this.pictureBox1.Location = new System.Drawing.Point(4, 16);
this.pictureBox1.Name = "pictureBox1";
this.pictureBox1.Size = new System.Drawing.Size(40, 40);
this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
this.pictureBox1.TabIndex = 38;
this.pictureBox1.TabStop = false;
// 
// crvTestingWorklist
// 
this.crvTestingWorklist.ActiveViewIndex = -1;
this.crvTestingWorklist.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
| System.Windows.Forms.AnchorStyles.Left) 
| System.Windows.Forms.AnchorStyles.Right)));
this.crvTestingWorklist.DisplayGroupTree = false;
this.crvTestingWorklist.Location = new System.Drawing.Point(56, 28);
this.crvTestingWorklist.Name = "crvTestingWorklist";
this.crvTestingWorklist.ReportSource = null;
this.crvTestingWorklist.ShowCloseButton = false;
this.crvTestingWorklist.ShowExportButton = false;
this.crvTestingWorklist.ShowPrintButton = false;
this.crvTestingWorklist.ShowRefreshButton = false;
this.crvTestingWorklist.Size = new System.Drawing.Size(680, 464);
this.crvTestingWorklist.TabIndex = 0;
// 
// btnCancel
// 
this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
this.btnCancel.Location = new System.Drawing.Point(664, 496);
this.btnCancel.Name = "btnCancel";
this.btnCancel.TabIndex = 2;
this.btnCancel.Text = "&Close";
this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
// 
// btnPrint
// 
this.btnPrint.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
this.btnPrint.DialogResult = System.Windows.Forms.DialogResult.OK;
this.btnPrint.Image = ((System.Drawing.Image)(resources.GetObject("btnPrint.Image")));
this.btnPrint.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
this.btnPrint.Location = new System.Drawing.Point(584, 496);
this.btnPrint.Name = "btnPrint";
this.btnPrint.TabIndex = 1;
this.btnPrint.Text = "&Print";
this.btnPrint.Click += new System.EventHandler(this.btnPrint_Click);
// 
// printDialog1
// 
this.printDialog1.AllowPrintToFile = false;
// 
// FrmTestingWorklistReport
// 
this.AcceptButton = this.btnPrint;
this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
this.CancelButton = this.btnCancel;
this.ClientSize = new System.Drawing.Size(742, 523);
this.Controls.Add(this.grpImage);
this.Controls.Add(this.crvTestingWorklist);
this.Controls.Add(this.btnCancel);
this.Controls.Add(this.btnPrint);
this.hlphelpChm.SetHelpKeyword(this, "Reports_UC_48.htm");
this.hlphelpChm.SetHelpNavigator(this, System.Windows.Forms.HelpNavigator.Topic);
this.Name = "FrmTestingWorklistReport";
this.RequiredFieldsLabel = true;
this.hlphelpChm.SetShowHelp(this, true);
this.Text = "VBECS - Testing Worklist Report";
this.Controls.SetChildIndex(this.vbecsLogo1, 0);
this.Controls.SetChildIndex(this.lblRequiredField, 0);
this.Controls.SetChildIndex(this.btnPrint, 0);
this.Controls.SetChildIndex(this.btnCancel, 0);
this.Controls.SetChildIndex(this.crvTestingWorklist, 0);
this.Controls.SetChildIndex(this.grpImage, 0);
this.grpImage.ResumeLayout(false);
this.ResumeLayout(false);
#endregion
private void SetComponentProperties()
// CR 2693
// hlpHelp
// 
this.hlpHelp.HelpNamespace = Environment.CurrentDirectory+"\\VBECS.chm";
// 
// hlphelpChm
// 
this.hlphelpChm.HelpNamespace = Environment.CurrentDirectory+"\\VBECS.chm";
this.vbecsLogo1.Title = this.Text.Replace("VBECS - ","");
//
this.ttToolTip.SetToolTip(btnCancel,Common.StrRes.Tooltips.Common.Cancel().ResString);
this.ttToolTip.SetToolTip(btnPrint,Common.StrRes.Tooltips.Common.Print().ResString);
private void LoadTestingWorklistReport()
try
_rptTestingWorklistReport = this._report.GenerateReport(ThisUser.UserName);
//
this.crvTestingWorklist.EnableDrillDown = false;
this.crvTestingWorklist.ReportSource = _rptTestingWorklistReport;
this.crvTestingWorklist.Zoom(1);
//
if (this._report.Patient != null)
controls.VbecsFunction.RenameCrystalReportTab(this.crvTestingWorklist,"Patient Testing Worklist Report");
else
controls.VbecsFunction.RenameCrystalReportTab(this.crvTestingWorklist,"Testing Worklist Report");
catch(CrystalDecisions.CrystalReports.Engine.OutOfLicenseException)
GuiMessenger.ShowMessageBox(Common.StrRes.SysErrMsg.Common.ReportsOutOfLicense());
return;
private void btnCancel_Click(object sender, System.EventArgs e)
this.Close();
private void btnPrint_Click(object sender, System.EventArgs e)
System.Drawing.Printing.PrinterSettings settings = new System.Drawing.Printing.PrinterSettings();
printDialog1.PrinterSettings = settings;
if (printDialog1.ShowDialog(this) == DialogResult.OK)
this._rptTestingWorklistReport.PrintOptions.PrinterName = settings.PrinterName;
this._rptTestingWorklistReport.PrintToPrinter(settings.Copies,settings.Collate,settings.FromPage,settings.ToPage);
//
