using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using EXT.DOMAIN.vbecs.BOL;
using EXT.DOMAIN.vbecs.Common;
namespace EXT.DOMAIN.vbecs.reports
/// <summary>
/// Class VbecsScheduledReportRunner
/// </summary>
public class VbecsScheduledReportRunner : System.ServiceProcess.ServiceBase
private System.ComponentModel.IContainer components = null;
private System.Threading.Timer tmrCheck;
private const int REPORT_RUNNER_TIMER_INTERVAL = 15000;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/22/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9054"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9055"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor
/// </summary>
public VbecsScheduledReportRunner()
// This call is required by the Windows.Forms Component Designer.
InitializeComponent();
// The main entry point for the process
static void Main()
System.ServiceProcess.ServiceBase[] ServicesToRun;
//
ServicesToRun = new System.ServiceProcess.ServiceBase[] { new VbecsScheduledReportRunner() };
//
System.ServiceProcess.ServiceBase.Run(ServicesToRun);
/// <summary> 
/// Required method for Designer support - do not modify 
/// the contents of this method with the code editor.
/// </summary>
private void InitializeComponent()
// 
// VbecsScheduledReportRunner
// 
this.ServiceName = "VBECS Scheduled Report Runner";
/// <summary>
/// Clean up any resources being used.
/// </summary>
protected override void Dispose( bool disposing )
if( disposing )
if (components != null) 
components.Dispose();
base.Dispose( disposing );
/// <summary>
/// Set things in motion so your service can do its work.
/// </summary>
protected override void OnStart(string[] args)
System.Threading.TimerCallback tmrDelegate = new System.Threading.TimerCallback(TimerElapsed);
tmrCheck = new System.Threading.Timer(tmrDelegate, null, 0, REPORT_RUNNER_TIMER_INTERVAL);
/// <summary>
/// Stop this service.
/// </summary>
protected override void OnStop()
tmrCheck.Change(System.Threading.Timeout.Infinite,System.Threading.Timeout.Infinite);
tmrCheck.Dispose();
/// <summary>
/// Timer delegate
/// </summary>
/// <param name="target"></param>
private void TimerElapsed(object target)
//Stops timer from firing again, while processing...
tmrCheck.Change(System.Threading.Timeout.Infinite,System.Threading.Timeout.Infinite);
//
try
PrintPendingReports();
finally
//Starts timer again in 15 secs
tmrCheck.Change(REPORT_RUNNER_TIMER_INTERVAL,REPORT_RUNNER_TIMER_INTERVAL);
/// <summary>
/// Print any pending reports in the queue
/// </summary>
private void PrintPendingReports()
//Retrieve all prending reports
DataTable dtReports = BOL.VbecsReport.GetScheduledReports(Common.TaskStatus.NotStarted);
//
//Now mark them as in progress, print them, and mark them as complete
foreach(DataRow drReport in dtReports.Rows)
try
//Mark as "In Progress"
BOL.VbecsReport.UpdateScheduledReportStatus((Guid)drReport[Common.VbecsTables.ScheduledReport.ScheduledReportGuid],Common.TaskStatus.InProgress,(byte[])drReport[Common.VbecsTables.ScheduledReport.RowVersion]);
//
string s = drReport[Common.VbecsTables.ScheduledReport.ReportParameters].ToString();
//
System.Xml.XmlReader reader = new System.Xml.XmlTextReader(new System.IO.StringReader(s));
DataSet ds = new DataSet();
ds.ReadXml(reader);
DataRow dr = ds.Tables[0].Rows[0];
//
string reportName = dr["ReportName"].ToString();
//
EXT.DOMAIN.vbecs.Common.LogonUser.LogonUserDivisionCode = dr[Common.VbecsTables.VamcDivision.DivisionCode].ToString();
//
//Create report object and print
BOL.VbecsReport rpt = (BOL.VbecsReport)(Activator.CreateInstance("VBECS.BOL",reportName).Unwrap());
rpt.LoadPropertiesFromDataRow(dr);
rpt.IsScheduled = true;
rpt.GenerateAndPrintReport();
//
//Retrive updated row version, then mark as "Complete"
DataTable dtUpdateReport = BOL.VbecsReport.GetScheduledReport((Guid)drReport[Common.VbecsTables.ScheduledReport.ScheduledReportGuid]);
BOL.VbecsReport.UpdateScheduledReportStatus((Guid)drReport[Common.VbecsTables.ScheduledReport.ScheduledReportGuid],Common.TaskStatus.Completed,(byte[])dtUpdateReport.Rows[0][Common.VbecsTables.ScheduledReport.RowVersion]);
catch(Exception e)
//Publish exception but continue to print any other reports in queue.
EXT.DOMAIN.vbecs.ExceptionManagement.ExceptionManager.Publish(e);
