using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;
using System.Collections.Specialized;
using System.ServiceProcess;
using System.IO;
using System.Reflection;
using System.Xml;
using Microsoft.Win32;
namespace EXT.DOMAIN.vbecs.reports
/// <summary>
/// Summary description for ProjectInstaller.
/// </summary>
[RunInstaller(true)]
public class VbecsScheduledReportRunnerProjectInstaller : System.Configuration.Install.Installer
private System.ServiceProcess.ServiceInstaller VbecsReportSchedulerInstaller;
private System.ServiceProcess.ServiceProcessInstaller VbecsReportScheduledServiceProcessInstaller;
/// <summary>
/// Required designer variable.
/// </summary>
private System.ComponentModel.Container components = null;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/22/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9052"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9053"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor
/// </summary>
public VbecsScheduledReportRunnerProjectInstaller()
VbecsReportSchedulerInstaller
= new System.ServiceProcess.ServiceInstaller();
VbecsReportScheduledServiceProcessInstaller
= new System.ServiceProcess.ServiceProcessInstaller();
// Set some defaults
VbecsReportScheduledServiceProcessInstaller.Account
= System.ServiceProcess.ServiceAccount.LocalSystem;
VbecsReportSchedulerInstaller.StartType
= System.ServiceProcess.ServiceStartMode.Automatic;
VbecsReportSchedulerInstaller.ServiceName
= "VBECS Scheduled Report Runner";
Installers.Add(VbecsReportSchedulerInstaller);
Installers.Add(VbecsReportScheduledServiceProcessInstaller);
/// <summary> 
/// Clean up any resources being used.
/// </summary>
protected override void Dispose( bool disposing )
if( disposing )
if(components != null)
components.Dispose();
base.Dispose( disposing );
#region Access parameters
/// <summary>
/// Return the value of the parameter in dicated by key
/// </summary>
/// <param name="key">Context parameter key</param>
/// <returns>Context parameter specified by key</returns>
public string GetContextParameter(string key) 
string sValue = "";
try 
sValue = this.Context.Parameters[key].ToString();
catch 
sValue = "";
return sValue;
#endregion
/// <summary>
/// This method is run before the install process.
/// This method is overriden to set the following parameters:
/// service name (/name switch)
/// account type (/account switch)
/// for a user account user name (/user switch)
/// for a user account password (/password switch)
/// Note that when using a user account, if the user name or password is not set,
/// the installing user is prompted for the credentials to use.
/// </summary>
/// <param name="savedState"></param>
protected override void OnBeforeInstall(IDictionary savedState)
base.OnBeforeInstall(savedState);
bool isUserAccount = false;
// Decode the command line switches
//
serviceInstaller.ServiceName = GetContextParameter("serviceName");
VbecsReportSchedulerInstaller.ServiceName = GetContextParameter("serviceName");
//VbecsReportSchedulerInstaller.ServiceName = "VBECS Scheduled Report Runner " + GetContextParameter("server") + "_" + GetContextParameter("database");
SetXmlConfigFileKeyValue("serviceName",VbecsReportSchedulerInstaller.ServiceName);
SetXmlConfigFileKeyValue("PrimaryDbConnectionString","Connection Timeout=90"
+ ";Data Source=" + GetContextParameter("server") + ";Initial Catalog=" + GetContextParameter("database")
+ ";persist security info=False;packet size=8192;integrated security=SSPI"
+ ";Application Name=VBECS");
// What type of credentials to use to run the service
// The default is User
string acct
= GetContextParameter("account");
if (0 == acct.Length) acct = "user";
// Decode the type of account to use
switch (acct) 
case "user":
VbecsReportScheduledServiceProcessInstaller.Account = System.ServiceProcess.ServiceAccount.User;
isUserAccount = true;
break;
case "localservice":
VbecsReportScheduledServiceProcessInstaller.Account = System.ServiceProcess.ServiceAccount.LocalService;
break;
case "localsystem":
VbecsReportScheduledServiceProcessInstaller.Account = System.ServiceProcess.ServiceAccount.LocalSystem;
break;
case "networkservice":
VbecsReportScheduledServiceProcessInstaller.Account = System.ServiceProcess.ServiceAccount.NetworkService;
break;
default:
VbecsReportScheduledServiceProcessInstaller.Account = System.ServiceProcess.ServiceAccount.User;
isUserAccount = true;
break;
// Should I use a user account?
if (isUserAccount) 
// If we need to use a user account, set the user name and password
VbecsReportScheduledServiceProcessInstaller.Username = GetContextParameter("nameuser");
VbecsReportScheduledServiceProcessInstaller.Password = GetContextParameter("password");
/// <summary>
/// Modify the registry to install the new service
/// </summary>
/// <param name="stateServer"></param>
public override void Install(IDictionary stateServer)
RegistryKey system,
//HKEY_LOCAL_MACHINE\Services\CurrentControlSet
currentControlSet,
//...\Services
services,
//...\<Service Name>
service,
//...\Parameters - this is where you can put service-specific configuration
config; 
base.Install(stateServer);
// Define the registry keys
// Navigate to services
system
= Registry.LocalMachine.OpenSubKey("System");
currentControlSet
= system.OpenSubKey("CurrentControlSet");
services
= currentControlSet.OpenSubKey("Services");
// Add the service
service
= services.OpenSubKey(VbecsReportSchedulerInstaller.ServiceName, true);
// Default service description
service.SetValue("Description", "Searches for scheduled VBECS reports and sends them to the printer");
// Display the assembly image path and modify to add the service name
// The executable then strips the name out of the image
Console.WriteLine("ImagePath: " + service.GetValue("ImagePath"));
string imagePath = (string)service.GetValue("ImagePath");
imagePath
+= " -s" + VbecsReportSchedulerInstaller.ServiceName;
service.SetValue("ImagePath", imagePath);
// Create a parameters subkey
config
= service.CreateSubKey("Parameters");
// Close keys
config.Close();
service.Close();
services.Close();
currentControlSet.Close();
system.Close();
/// <summary>
/// Uninstall based on the service name
/// </summary>
/// <param name="savedState"></param>
protected override void OnBeforeUninstall(IDictionary savedState)
base.OnBeforeUninstall(savedState);
// Set the service name based on the config file.
VbecsReportSchedulerInstaller.ServiceName = GetXmlConfigFileKeyValue("serviceName");
/// <summary>
/// Modify the registry to remove the service
/// </summary>
/// <param name="stateServer"></param>
public override void Uninstall(IDictionary stateServer)
RegistryKey system,
//HKEY_LOCAL_MACHINE\Services\CurrentControlSet
currentControlSet,
//...\Services
services,
//...\<Service Name>
service;
//...\Parameters - this is where you can put service-specific configuration
base.Uninstall(stateServer);
// Navigate down the registry path
system
= Registry.LocalMachine.OpenSubKey("System");
currentControlSet
= system.OpenSubKey("CurrentControlSet");
services
= currentControlSet.OpenSubKey("Services");
service
= services.OpenSubKey(GetXmlConfigFileKeyValue("serviceName"),true);
// Remove the parameters key
service.DeleteSubKeyTree("Parameters");
// Close keys
service.Close();
services.Close();
currentControlSet.Close();
system.Close();
private static bool SetXmlConfigFileKeyValue(string keyName, string keyValue)
FileInfo _fileInfo = new FileInfo(Assembly.GetExecutingAssembly().Location + ".config");
if(!_fileInfo.Exists)
throw new InstallException("Missing config file");
XmlDocument xmlConfig = new XmlDocument();
xmlConfig.Load(_fileInfo.FullName);
bool keyExists = false;
foreach(XmlNode node in xmlConfig["configuration"]["appSettings"])
if(node.Name == "add")
if(node.Attributes.GetNamedItem("key").Value == keyName)
node.Attributes.GetNamedItem("value").Value = keyValue;
keyExists = true;
xmlConfig.Save(_fileInfo.FullName);
return keyExists;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/22/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9050"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9051"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// GetXmlConfigFileKeyValue
/// </summary>
/// <param name="keyName"></param>
/// <returns></returns>
public static string GetXmlConfigFileKeyValue(string keyName)
FileInfo _fileInfo = new FileInfo(Assembly.GetExecutingAssembly().Location + ".config");
if(!_fileInfo.Exists)
throw new InstallException("Missing config file");
XmlDocument xmlConfig = new XmlDocument();
xmlConfig.Load(_fileInfo.FullName);
string keyValue = null;
foreach(XmlNode node in xmlConfig["configuration"]["appSettings"])
if(node.Name == "add")
if(node.Attributes.GetNamedItem("key").Value == keyName)
keyValue = node.Attributes.GetNamedItem("value").Value;
return keyValue;
