using System;
using System.Net;
namespace EXT.DOMAIN.vbecs.DAL.VistALink.Listener.Core
/// <summary>
/// This class represents caller (remote client) security information
/// needed to perform published procedure access authorization
/// on a server side. 
/// </summary>
public class CallerSecurityEvidence
private readonly string _securityContext;
private readonly IPAddress _clientIP;
/// <summary>
/// Constructor specifying all parameters needed to perform authorization. 
/// </summary>
/// <param name="securityContext">Security context provided by caller.</param>
/// <param name="clientIP">Caller IP address.</param>
public CallerSecurityEvidence( string securityContext, IPAddress clientIP )
if( securityContext == null )
throw( new ArgumentNullException( "securityContext" ) );
if( clientIP == null )
throw( new ArgumentNullException( "clientIP" ) );
_securityContext = securityContext;
_clientIP = clientIP;
/// <summary>
/// Security context provided by caller.
/// </summary>
public string SecurityContext
get
return _securityContext;
/// <summary>
/// Client IP address.
/// </summary>
public IPAddress ClientIP
get
return _clientIP;
