using System;
using System.Xml;
using System.Configuration;
namespace EXT.DOMAIN.vbecs.DAL.VistALink.Listener.Core
/// <summary>
/// Application configuration section handler class providing ability to 
/// read list of published procedures from application configuration section.
/// </summary>
public class RpcListConfigSectionHandler : IConfigurationSectionHandler
/// <summary>
/// Method deserializing and returning list of published procedures from 
/// application configuration file section.
/// </summary>
/// <param name="parent">The configuration settings in a corresponding parent configuration section. </param>
/// <param name="configContext">
///
Reserved by the interface.
///
</param>
/// <param name="section">Corresponding <see cref="XmlNode"/> section in configuration file.</param>
/// <returns>
///
List of published procedures deserialized 
///
from application configuration section.
///
</returns>
public object Create( object parent, object configContext, XmlNode section )
return new PublishedProceduresCollection( section );
