using System;
using System.Collections;
using System.Reflection;
using System.Threading;
namespace EXT.DOMAIN.vbecs.DAL.VistALink.Listener.Core
/// <summary>
/// Summary description for RpcManager
/// </summary>
public class RpcManager : IDisposable
AppDomain _foreignCodeDomain;
PublishedProceduresCollection _procedures;
/// <summary>
/// Constructor
/// </summary>
protected RpcManager()
_procedures = ServerConfig.GetPublishedProceduresListFromAppConfig();
_foreignCodeDomain = AppDomain.CreateDomain( "VistALink RPC Server Foreign Code Domain" );
/// <summary>
/// ExecutePublishedProcedure
/// </summary>
/// <param name="publishedProcedureName"></param>
/// <param name="evidence"></param>
/// <param name="parameters"></param>
/// <returns></returns>
protected object ExecutePublishedProcedure( string publishedProcedureName, CallerSecurityEvidence evidence, object[] parameters )
if( publishedProcedureName == null )
throw( new ArgumentNullException( "publishedProcedureName" ) );
if( evidence == null )
throw( new ArgumentNullException( "evidence" ) );
PublishedProcedure _proc = _procedures[ publishedProcedureName ];
if( _proc == null )
throw( new PublishedProcedureNotFoundException( "Published procedure '{0}' was not found in the list of published procedures." ) );
return _proc.Execute( _foreignCodeDomain, evidence, parameters );
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/30/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9098"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9099"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Dispose
/// </summary>
public void Dispose()
GC.SuppressFinalize( this );
Dispose( true );
private void Dispose( bool disposing )
lock( this )
if( disposing )
if( _foreignCodeDomain != null )
AppDomain.Unload( _foreignCodeDomain );
_procedures = null;
_foreignCodeDomain = null;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/30/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9100"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9101"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Destructor
/// </summary>
~RpcManager()
Dispose( false );
