using System;
using System.Configuration;
using EXT.DOMAIN.vbecs.DAL.VistALink.OpenLibrary;
namespace EXT.DOMAIN.vbecs.DAL.VistALink.Listener.Core
/// <summary>
/// The class provides global centralized store for listener settings. 
/// It reads settings from application configuration file
/// if they're present. If not - default hardcoded values are used.
/// </summary>
public class ServerConfig
private const string RPC_LIST_SECTION_NAME = "RpcList";
private ServerConfig(){}
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/30/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9094"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9095"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Retrives list of published procedures from app.config section 
/// utilizing RpcListConfigSectionHandler.
/// </summary>
/// <returns>List of published procedures deserialized from app.config file.</returns>
public static PublishedProceduresCollection GetPublishedProceduresListFromAppConfig()
return (PublishedProceduresCollection)ConfigurationSettings.GetConfig( GlobalConfig.GetXPathToChildConfigSection( RPC_LIST_SECTION_NAME ) );
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/30/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9092"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9093"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Get PortNumber
/// </summary>
public static int PortNumber
get
return Convert.ToInt32( ConfigurationSettings.AppSettings["listenerPortNumber"] );
