using System;
using System.Diagnostics;
using System.Threading;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.ServiceProcess;
using EXT.DOMAIN.vbecs.Common;
using EXT.DOMAIN.vbecs.DAL.VistALink.OpenLibrary;
using EXT.DOMAIN.vbecs.DAL.VistALink.OpenLibrary.Messages;
namespace EXT.DOMAIN.vbecs.DAL.VistALink.Listener.Core
using EXT.DOMAIN.vbecs.DAL.VistALink.OpenLibrary;
using EXT.DOMAIN.vbecs.DAL.VistALink.OpenLibrary.Messages;
/// <summary>
/// Class SimpleListener
/// </summary>
public class SimpleListener
private static System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
private static VistALinkRpcManager _rpcManager;
private static readonly IPAddress _listenerIp = StDbNullConvert.ToIPAddress((string)(configurationAppSettings.GetValue("listenerIpAddress", typeof(string))));
private Thread _listeningThread;
TcpListener _listener;
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/30/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9080"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9081"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Static Constructor
/// </summary>
static SimpleListener()
_rpcManager = new VistALinkRpcManager();
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/30/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9078"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9079"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Constructor
/// </summary>
public SimpleListener()
// CR2510
// Set the unhandled exception handler
AppDomain currentDomain = AppDomain.CurrentDomain;
currentDomain.UnhandledException += new UnhandledExceptionEventHandler(currentDomain_UnhandledException);
lock( this )
_listener = new TcpListener( _listenerIp, ServerConfig.PortNumber );
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/30/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9076"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9077"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Start
/// </summary>
public void Start()
lock( this )
_listeningThread = new Thread( new ThreadStart( BlockingStart ) );
_listeningThread.Start();
EventLog.WriteEntry( ((string)(configurationAppSettings.GetValue("serviceName", typeof(string)))) , "Listener has started on port: " + 
((string)(configurationAppSettings.GetValue("listenerPortNumber", typeof(string)))) + "  IP Address: " + ((string)(configurationAppSettings.GetValue("listenerIpAddress", typeof(string)))), EventLogEntryType.Information );
private void BlockingStart()
// CR2510: add try/catch
try
lock( this )
_listener.Start();
for(;;)
ThreadPool.QueueUserWorkItem( new WaitCallback( new ClientRequestContext( _listener.AcceptTcpClient() ).ServeClient ) );
catch(Exception ex)
//add log entry
System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
string serviceName = (string) configurationAppSettings.GetValue("serviceName", typeof(string));
System.Diagnostics.EventLog.WriteEntry(serviceName, "BlockingStart method failed: " + ex.Message, EventLogEntryType.Error);
//rethrow exception
throw;
    // CR2510
    // unhandled exception handler: logs error message, stops service
    private void currentDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e)
    {
      Exception unhandledException = e.ExceptionObject as Exception;
      System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
      string serviceName = (string) configurationAppSettings.GetValue("serviceName", typeof(string));
      System.Diagnostics.EventLog.WriteEntry(serviceName, "UnhandledExceptionHandler: " + unhandledException.Message, EventLogEntryType.Error);
      System.ServiceProcess.ServiceController cntr = new System.ServiceProcess.ServiceController(serviceName, ".");
      if(cntr.Status == System.ServiceProcess.ServiceControllerStatus.Running)
      {
        // Stop the service
        try
        {
          cntr.Stop();
          cntr.WaitForStatus(ServiceControllerStatus.Stopped, new TimeSpan(0,0,1,0,0));
        }
        catch(Exception ex)
        {
          System.Diagnostics.EventLog.WriteEntry(serviceName, "UnhandledExceptionHandler failed to stop service: " + ex.Message, EventLogEntryType.Error);
        }
      }
    }
    // CR2510 - end
///<Developers>
///
<Developer></Developer>
///</Developers>
///<SiteName>Hines OIFO</SiteName>
///<CreationDate>7/30/2010</CreationDate>
///<TestCases>
///
///<Case type="0" testid ="9074"> 
///
<ExpectedInput>Valid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///<Case type="1" testid ="9075"> 
///
<ExpectedInput>Invalid</ExpectedInput>
///
<ExpectedOutput></ExpectedOutput>
///
</Case>
///
///</TestCases>
///<Update></Update>
///<ArchivePlan></ArchivePlan>
///<Interfaces></Interfaces>
///
/// <summary>
/// Stop
/// </summary>
public void Stop()
lock( this )
if( _listener != null )
_listener.Stop();
if( _listeningThread == null )
return;
_listeningThread.Abort();
_listeningThread.Join( 5000 );
private class ClientRequestContext
TcpClient _client;
public ClientRequestContext( TcpClient client )
if( client == null )
throw( new ArgumentNullException( "client" ) );
_client = client;
public void ServeClient( object state )
using( VistALinkTestRRConnection _cn = new VistALinkTestRRConnection() )
_cn.RegisterConnection( _client );
VistALinkMessage _response;
try
VistALinkMessage _incomingMessage = _cn.ReceiveMessage();
if( !(_incomingMessage is RpcRequestMessage) )
throw( new VistALinkException( String.Format( "Message of {0} type was received from client while message of {1} type was expected.",
_incomingMessage.GetType().Name, typeof(RpcRequestMessage).Name ) ) );
try
_response = new RpcResponseMessage( _rpcManager.ExecuteRpcRequest( ((RpcRequestMessage)_incomingMessage).RpcRequest, IPAddress.Parse( "127.0.0.1" ) ) );
catch( Exception xcp )
_response = new RpcFaultMessage( new FaultInfo( FaultCode.Server, "Exception occured while executing RPC", "", "", xcp.GetType().Name, xcp.Message ) );
catch( Exception xcp )
if( xcp is ThreadAbortException )
throw;
if( xcp is IOException || xcp is SocketException )
throw( new VistALinkException( "Network problems prevent communicating with the client", xcp ) );
_response = new RpcFaultMessage( new FaultInfo( FaultCode.Server, "Exception occured while processing client request", "", "", xcp.GetType().Name, xcp.Message ) );
_cn.SendMessage( _response );
